<?PHP
set_time_limit(7*60*60);
if(!defined('IN_SMAN')) {
	define('IN_SMAN',true);
}

class TaskDispatcher {
	var $taskType;
	var $sql;
	var $tasksScheduled;
	var $taskObj;
	var $taskMsgs;

	function TaskDispatcher($type) {
		global $M_db;
		$this->sql = &$M_db;
		//$M_db->blibVoiceMessages = 1;
		$this->sql->query('UPDATE '.dext('proc_list').' SET task_status="scheduled" WHERE task_status="failed" AND task_type="'.$type.'"');
		$this->bindTask($type);
		if($this->sql->getVar('SELECT COUNT(*) FROM '.dext('proc_list').' WHERE	task_type="'.$this->taskType.'" AND task_status="scheduled"')==0) {
			$this->taskObj->scheduleFirst();
		}
	}

	function getScheduled() {
		$que = 'SELECT * FROM '.dext('proc_list').' WHERE task_type="'.$this->taskType.'" AND task_status="scheduled"';
		$this->tasksScheduled = array();
		$tt = epoch(date('Y-m-d H:i:s'));
		foreach($this->sql->getRows($que) as $key=>$row) {
			$tt1 = epoch($row['pstart']);
			if(($tt-$tt1)>0) {
				$this->tasksScheduled[] = $row;		
			}
		}
		$this->tasksScheduled = $this->sql->getRows($que);
		return $this->tasksScheduled;
	}

	function doTasks() {
		$this->taskLog();
		$this->taskObj->perform($this->tasksScheduled);	
	}


	function getMessages() {
		return $this->taskObj->taskMsgs;
	}

	function bindTask($inType = 'rss_archive') {
		$this->taskType = $inType;
		switch($this->taskType) {
			case 'rss_archive':
				$this->taskObj = &new CronTaskArchive();
			break;
		}
	}

	function scheduleNext($task) {
		$mult = 1;
		switch($task['rep_unit']) {
			case 'mm':$mult = 60; break;
			case 'hh':$mult = 60*60; break;
			case 'dd':$mult = 60*60*24; break;
		}
		$secs_to_add = explode('-',$task['rep_interval']);
		if(isset($secs_to_add[0])&&isset($secs_to_add[1])) {
			srand((float)microtime()*1000000); 
			$secs_to_add = (rand($secs_to_add[0],$secs_to_add[1]))*$mult;
		}else {
			$secs_to_add = $secs_to_add[0]*$mult;
		}

		$next_date = date("Y-m-d H:i:s",time()+$secs_to_add);
		$this->sql->query('INSERT INTO '.dext('proc_list').'(uid,task_type,pstart,rep_interval,rep_unit,extra_field,extra_field1,extra_field2) VALUES("'.$task['uid'].'","'.$task['task_type'].'","'.$next_date.'","'.$task['rep_interval'].'","'.$task['rep_unit'].'","'.$task['extra_field'].'","'.$task['extra_field1'].'","'.$task['extra_field2'].'")');
	}

	function commitNext() {
		
	}
	
	function taskLog() {
		return false;
		if($fp = @fopen(dirname(__FILE__).'/tasklog.log','a+')) {
			@fwrite($fp,date('H:i d-m-Y').' Taskman Called'."\n");
			@fclose($fp);
		}
	}

}

/**
* Archives the content
*/
class CronTaskArchive extends TaskDispatcher {
	function CronTaskArchive() {
		global $M_db;
		$this->sql = &$M_db;
		$this->taskType = 'rss_archive';
		$this->taskMsgs = '';

		//disable inactive keywords (cancel their task schedules)
		foreach($this->sql->getRows('SELECT id FROM '.dext('keyword_list').' WHERE arch_period=0') as $row) {
			$this->sql->query('DELETE FROM '.dext('proc_list').' WHERE extra_field="id='.$row['id'].'" AND task_type="'.$this->taskType.'"');
		}
		//update flash intervals
		foreach($this->sql->getRows('SELECT id, arch_period FROM '.dext('keyword_list').' WHERE arch_period<>0') as $row) {
			$this->sql->query('UPDATE '.dext('proc_list').' SET rep_interval="'.$row['arch_period'].'-'.$row['arch_period'].'" WHERE extra_field1="'.$row['id'].'" AND task_type="'.$this->taskType.'"');
		}
		$this->scheduleFirst();
	}
	
	function scheduleFirst() {
		//get id's of already scheduled tasks
		$ids = array(0);
		$que = 'SELECT extra_field1 as item_id FROM '.dext('proc_list').' WHERE task_status="scheduled" AND task_type="'.$this->taskType.'"';
		foreach($asch = $this->sql->getRows($que) as $row) {
			$ids[] = $row['item_id'];
		}
		$que = 'SELECT * FROM '.dext('keyword_list').' WHERE arch_period<>0 AND id NOT IN('.implode(',',$ids).')';
		foreach($this->sql->getRows($que) as $row) {
			$task_desc = ''.$row['keyword']."\n";
			$this->sql->query('INSERT INTO '.dext('proc_list').'(uid,task_type,pstart,rep_interval,rep_unit,extra_field,extra_field1,extra_field2) VALUES("'.$row['uid'].'","rss_archive","'.date('Y-m-d H:i:s').'","'.$row['arch_period'].'-'.$row['arch_period'].'","dd","id='.$row['id'].'","'.$row['id'].'","'.$task_desc.'")');
		}
	}

	function perform($tasks) {
		if(count($tasks)) {
			require_once('rss_archive.cron.php');
		}
		foreach($tasks as $task) {
			$task_title = '<b>'.$this->taskType.'</b> task for '.$this->sql->getVar('SELECT keyword FROM '.dext('keyword_list').' WHERE id="'.$task['extra_field1'].'"').'<br>';
			$this->taskMsgs .= $task_title;
			$ret = @cron_rss_archive($task['extra_field1']);
			$this->sql->query('UPDATE '.dext('proc_list').' SET task_resp_msg="'.mysql_escape_string($task_title.$ret[1]).'",task_status="'.($ret[0]==true?'performed':'failed').'" WHERE id="'.$task['id'].'"');
			$this->taskMsgs .= $ret[1].'<br><hr style="border:1px dashed silver;height:1px;">';
			if($ret[0]==true) {
				$this->scheduleNext($task);
			}
		}
	}
}

?>