<?
//file: blibClass.class.php
class blibClass {

  var $blibCredits = '2005 phpBlib by F7i Software (OzonE Edition)';
  var $blibVoiceErrors = true;
  var $blibVoiceMessages = false; // mainly the debug messages/warnings

  function errorThrow($inHeader, $inText, $inFile = '', $inLine = '') {
    if($this->blibVoiceErrors) {
      if(!($inFile==''&&$inLine=='')) {
      	$inText = '<b>File:</b> '.$inFile.' <b>Line:</b> '.$inLine.'<br><hr style="border:1px dashed #000066;height:1px;width:100%"><b style="color:red;">Error:</b> '.$inText;
      }
      $this->msgBox($inHeader, $inText);
    }
    exit;
  }

	function msgThrow($inHeader, $inText, $inFile = '', $inLine = '') {
    if($this->blibVoiceMessages) {
      if(!($inFile==''&&$inLine=='')) {
      	$inText = '<b>File:</b> '.$inFile.' <b>Line:</b> '.$inLine.'<br><hr style="border:1px dashed #000066;height:1px;width:100%"><b>Message:</b> '.$inText;
      }
      $this->msgBoxLimited($inHeader, $inText);
    }
	}
  
  /*
  * For compatibility with PHP4, PHP5 has object cloning facilities
  */
  function &instClone() {
    $out = null;
    $classes = get_declared_classes();
    $k = array_search(get_class($this),$classes);
    if(!($k==false)) {//class found 
    	$className = $classes[$k];
      $out = new $className();
      foreach(get_class_vars(get_class($this)) as $key=>$val) {
      	if(is_object($this->$key)) {
          $out->$key = $this->$key->instClone();      		
      	}else {
      	  $out->$key = $this->$key;	
      	}
      }
    }else {
    	$this->errorThrow(get_class($this),'Class cloning failed: '.get_class($this),__FILE__,__LINE__);
    }
  	return $out;
  }

  function isInstanceOf(&$obj, $className){
      $className = strtolower($className);
      return strtolower(get_class($obj)) == $className  ||  is_subclass_of($obj, $className);
  }

  function validateVersion($inVer) {
    if(strcmp($inVer, phpversion()) > 0) {
      return false;
    }else {
    	return true;
    }
  }

  function debugPrint($inVar = null, $inDump = false) {
    $obj = ($inVar)?$inVar:$this;
    ob_start();    
      echo '<pre>';
        print_r($obj);
      echo '</pre>';    
    $out = ob_get_clean();
    $this->msgBox('print_r',$out);
    if(!$inDump) {
    	return;
    }
    ob_start();    
      echo '<pre>';
        var_dump($obj);
      echo '</pre>';    
    $out = ob_get_clean();
    $this->msgBox('var_dump',$out);
  }	

  function msgBox($inHeader, $inText) {
    echo '<div style="border-top:1px #000066 solid;border-bottom:1px #000066 solid;width:100%;padding:4px;font:11px Verdana;background-color:#6666CC;color:#fff;font-weight:bold;">'.$inHeader.'<div style="text-align:right"> '.$this->blibCredits.'</div></div>';
    echo '<div style="border-bottom:1px #000066 solid;width:100%;padding:4px;padding-top:10px;font:11px Verdana;background-color:#CCCCFF;">'.$inText.'</div><div>&nbsp;</div>';
  }

	function msgBoxLimited($inHeader, $inText) {
    echo '<div style="border:1px #000066 solid;width:100%;padding:4px;padding-top:10px;font:11px Verdana;background-color:#CCCCFF;"><b>'.$inHeader.':</b> '.$inText.'</div><div>&nbsp;</div>';
  }
}

//file: blibPackageClass.class.php
class blibPackageClass extends blibClass{
	var $name;
  var $version;
  var $path;
  var $initPars = array();
  var $initFunc = '__construct';
  
  function blibPackageClass($inFile, $inClass, $inVersion,  $inInitPars = array()) {
    $this->path = $inFile;
  	$this->name = $inClass;
    $this->version = $inVersion;
    $this->initPars = $inInitPars;
  }

  function &objectGet($inInitPars) {
  	require_once($this->path);
    $obj = new $this->name;
    
    if(count($inInitPars)) {
    	$initPars = $inInitPars;
    }

    $vars = get_class_vars($this->name);
    foreach($vars as $key=>$val) {
      if(isset($initPars[$key])) {
        $obj->$key = $initPars[$key];
      }
    }
    return $obj;
  }
}

//file: blibPackage.class.php
/**
* @todo - dependecies resolver
*/
class blibPackage extends blibClass{
	var $name;
  var $version;
  var $path;
  var $classList = array();
  var $iclassList = array();

  function classAdd($inFile, $inClass, $inInitPars = array(), $inVersion = '1_0') {
    if(file_exists($inFile)&&is_file($inFile)&&is_readable($inFile)) {
      if(!isset($this->classList[$inClass])) {
        $this->classList[$inClass] = new blibPackageClass($inFile, $inClass, $inVersion, $inInitPars);		
      }else {
      	$this->errorThrow('Duplicate Class','Class "'.$inClass.'" already exists..',__FILE__,__LINE__);
      }
  	  
  	}else {
  		$this->errorThrow('Failed to add class', 'File "'.$inFile.'" could not be opened..', __FILE__,__LINE__);
  	}
  }

  function classRemove($inClass) {

  	if(isset($this->classList[$inClass])) {
  		unset($this->classList[$inClass]);
  	}
    if(isset($this->iclassList[$inClass])) {
    	unset($this->iclassList[$inClass]);
    }
  }
  
  function &classGet($inClass, $inForceNew = false, $inInitPars = array()) {
    if(isset($this->classList[$inClass])) {
      if(isset($this->iclassList[$inClass])&&($inForceNew == false)) {//initialized version exitst
        return $this->iclassList[$inClass];
      }else {
        $this->iclassList[$inClass] = &$this->classList[$inClass]->objectGet($inInitPars);
        return $this->iclassList[$inClass];
      }
  	}else {
  		$this->errorThrow('Class not found','Class "'.$this->name.'.'.$inClass.'" not found..', __FILE__, __LINE__);
  	}
  }
  
}

//file: blibPackager.class.php
/**
* Package manipulation class
*/
class blibPackager extends blibClass {
  var $packagePath = '';
  var $packageExt = '.pack.php';
  var $packageList = array();
  var $ipackageList = array();
  
  function blibPackager() {
    $this->packagePath = dirname(__FILE__).'/framework';
  }

  function packageRegister($inPackage, $inAutoInit = false) {
    $inFile = $this->packagePath.'/'.$inPackage.''.$this->packageExt;
		$inFile = dirname(__FILE__).'/framework/blibPacks.lib.php';
  	if(file_exists($inFile)&&is_file($inFile)&&is_readable($inFile)) {
  		if(!isset($this->packageList[$inPackage])) {
  			$this->packageList[$inPackage] = $inFile;
        if($inAutoInit) {
        	require_once($inFile);
          $this->ipackageList[$inPackage] = new $inPackage;
        }
  		}else {
  			$this->errorThrow('Duplicate Package','Package "'.$inPackage.'" already added..',__FILE__,__LINE__);
  		}
  	}else {
  		$this->errorThrow('Failed to register the package','File "'.$inFile.'" could not be opened..',__FILE__,__LINE__);
  	}
  }

  function packageExists($inPackage) {
  	if(isset($this->packageList[$inPackage])) {
  		return true;
  	}else {
  		return false;
  	}
  }

  function packageInitiated($inPackage) {
  	if(isset($this->ipackageList[$inPackage])) {
  		return true;
  	}else {
  		return false;
  	}
  }

  function packageRemove($inPackage) {
  	if(isset($this->packageList[$inPackage])) {
  		unset($this->packageList[$inPackage]);
  	}
  	if(isset($this->ipackageList[$inPackage])) {
  		unset($this->ipackageList[$inPackage]);
  	}
  }

  function packageInit($inPackage, $inForce = false) {
  	if(isset($this->packageList[$inPackage])) {
			$this->packageList[$inPackage] = dirname(__FILE__).'/framework/blibPacks.lib.php';
  	  if((!isset($this->ipackageList[$inPackage]))||$inForce) {
  	  	require_once($this->packageList[$inPackage]);
        $this->ipackageList[$inPackage] = new $inPackage;
  	  }	
  	}else {
  		$this->errorThrow('Package not found','Package "'.$inPackage.'" does not exist..',__FILE__,__LINE__);
  	}
  }
}
//file: blibCore.class.php
/**
* Core library class
*/
class blibCore extends blibClass{
  var $packager;
  var $curPackage;
  var $classHandles = array();
  
  function blibCore() {
    //initilize packager
    $this->packager = new blibPackager;
  }
  
  function classSetHandle($inClass, $inHandle) {
    if(strpos($inClass,'.')===false) {
    	$inPackage = $this->curPackage;
    }else {
    	list($inPackage, $inClass) = explode('.',$inClass);
    }
    $this->classHandles[$inHandle] = array($inPackage,$inClass);
  }

  function packageSetup($inPackage) {
    $this->packager->packageRegister($inPackage);  	
    $this->curPackage = $inPackage;
  }

  function packageSet($inPackage) {
  	$this->curPackage = $inPackage;
  }

  function &objectGet($inClass, $inForceNew = false, $inInitPars = array()) {
    if(isset($this->classHandles[$inClass])) {
      list($inPackage,$inClass) = $this->classHandles[$inClass];
    }else {
      if(strpos($inClass,'.')===false) {
        $inPackage = $this->curPackage;
      }else {
        list($inPackage, $inClass) = explode('.',$inClass);
      }
    }

    if(!$this->packager->packageInitiated($inPackage)) {
      $this->packager->packageInit($inPackage);    	
    }
    return $this->packager->ipackageList[$inPackage]->classGet($inClass, $inForceNew, $inInitPars);
  }
}

?>