<?
require_once(dirname(__FILE__).'/../../blibFrame.lib.php');
require_once(dirname(__FILE__).'/../blibIO/blibFile.class.php');


//file: blibControl.class.php
class blibControl extends blibClass {
  var $hWrapper = '';
  var $cntTplFile = '';   //location of tpl file 
  var $cntCssFile = '';   //location of css file 
  var $cntJsFile = '';   //location of js file 
  var $cntQueStr = '';    //que string to pass to GET in order to retain state
  var $cntOut = '';       //HTML representation of control
  var $cntId = '';        //id of object (in order to have several instances on single page)
  var $cntBaseUrl = '';       //base url (wrt this file)
  var $cntGlobals = array();         //array of global vars
  var $cntSGlobals = array();
  var $cntCaption = '';
  var $cntError = '';
  var $cntDesc = '';
  var $cntWidth = '100%';
  var $cntHeight = '';
  

  function setBaseUrl($inUrl = '') {
		if(strlen($inUrl)) {
			$this->cntBaseUrl = $inUrl;
		}else {
			$doc_root = (isset($GLOBALS['DOCUMENT_ROOT']))?$GLOBALS['DOCUMENT_ROOT']:$_SERVER['DOCUMENT_ROOT'];
			$pos = strpos(dirname(__FILE__), $doc_root);
			if(!($pos===false)) {
				$dir_name = substr(dirname(__FILE__),$pos);
			}else {
				$dir_name = dirname(__FILE__);
			}
			$this->cntBaseUrl = str_replace($doc_root, '', str_replace("\\","/",$dir_name)).'/'.$inUrl;
		}
  }
  
  function setWrapper($inWrapper, $inPars = array()) {
    $this->hWrapper = new blibWrapper();
    $this->hWrapper->init();
    $this->hWrapper->setType($inWrapper);
    foreach($inPars as $key=>$val) {
    	if(isset($this->hWrapper->$key)) {
    		$this->hWrapper->{$key} = $val;
    	}
    }
  }

  function setGlobal($inVar,$inVal) {
  	$this->cntSGlobals[$inVar] = $inVal;
  }

  function getCss() {
    return $this->cntCssFile;  	
  }

  function setCss() {
    $this->_errorAbstract('setCss');	
  }
  
  function incCss() {
  	echo $this->getIncCss();
  }

  function getIncCss() {
  	$out = '<link href="'.$this->cntCssFile.'" type="text/css" rel=STYLESHEET>';
    if(is_object($this->hWrapper)) {
  	  $out .=	$this->hWrapper->getIncCss();
  	}
    return $out;
  }
  function getJs() {
    return $this->cntJsFile;  	
  }

  function setJs() {
    $this->_errorAbstract('setJs');	
  }
  
  function incJs() {
  	echo $this->getIncJs();
  }

  function getIncJs() {
  	$out = '<script type="text/javascript" src="'.$this->cntJsFile.'"></script>';
    if(is_object($this->hWrapper)) {
  	  $out .=	$this->hWrapper->getIncJs();
  	}
    return $out;
  }
  /*
  * Returns HTML representation of control
  */
  function fetch() {
    $this->cntOut = '';
    $this->_make();	
    if(isset($this->hWrapper)&&is_object($this->hWrapper)) {
    	$this->hWrapper->addContent($this->cntOut, 1);
      $this->hWrapper->setCaptions($this->cntCaption,$this->cntDesc,$this->cntError);
      if($this->cntWidth) {
      	if($this->cntHeight) {
      	  $this->hWrapper->setDims($this->cntWidth,$this->cntHeight);	
      	}else {
      		$this->hWrapper->setDims($this->cntWidth);
      	}
      }
      $this->cntOut = $this->hWrapper->fetch();
    }
  	return $this->cntOut;
  }
  
  /*
  * Displays control
  */
  function display() {
  	echo $this->fetch();
  }

  /*
  * Sets transferable query string portion
  */
  function setQueStr($inQueStr) {
  	$this->cntQueStr = $inQueStr;
  }
  
  /*
  * Returns current query string related to ITEM functioning (used to restore the state once returned from linked page)
  */
  function getQueStr() {
    $this->_errorAbstract('getQueStr');
  }

  function getCUrl($retVal = -1) {
    $url[0] = (isset($GLOBALS['PHP_SELF']))?$GLOBALS['PHP_SELF']:$_SERVER['PHP_SELF'];  	
    $url[1] = ((isset($_SERVER['QUERY_STRING']))?explode('&',$_SERVER['QUERY_STRING']):array());  	
    foreach($url[1] as $key=>$val) {
    	if($val!=''&&(strpos('=',$val)===false)) {
    		list($k,$v) = explode('=',$val);
        if($k!=''&&$v!='') {
          $url[1][$k] = $v;
        }
    	}
      unset($url[1][$key]);
    }
		if($retVal == -1) {
			return $url;	
		}else {
			return $url[$retVal];
		}
    
  }
  function setCUrl($inUrl, $inInd = -1) {
    foreach($inUrl[1] as $key=>$val) {
      $inUrl[1][$key] = $key.'='.$val;
    }
    $inUrl[1] = implode('&',$inUrl[1]);
    
    return ($inInd==-1)?$inUrl[0].'?'.$inUrl[1]:$inUrl[$inInd];
  }
    
  /*
  * Compiles output
  */
  function _make() {
  	$this->_errorAbstract('_make');
  }

  function _processQueStr() {
    $this->_errorAbstract('_processQueStr');    
  }

  function _processGlobals() {
    $this->cntGlobals['CNT_ID'] = $this->cntId;
    $this->cntGlobals['PHP_SELF'] = (isset($GLOBALS['PHP_SELF']))?$GLOBALS['PHP_SELF']:$_SERVER['PHP_SELF'];
    $this->cntGlobals['QUE_STR'] = ($this->cntQueStr!=''?'&'.$this->cntQueStr:'');
    foreach($this->cntSGlobals as $key=>$val) {
    	$this->cntGlobals[$key] = $val;
    }
  }

  function _errorAbstract($inFunc) {
  	$this->errorThrow(get_class($this),'<b>'.get_class($this).'->'.$inFunc.'()</b> must be implemented locally. Parent class is abstract.',__FILE__,__LINE__);
  }

	
}

//file: blibTemplate.class.php
/**
* Content rendering class aka template engine
*/
class blibTemplate extends blibClass{
  var $tplDir = '';             //Root directory for template files
  var $tplVars = array();       //List of assigned variables
  var $hFile;                   //pointer to blibFile object
  var $tplDelimLeft = '{-';     //template variable left delimiter
  var $tplDelimRight = '-}';    //template variable right delimiter
  var $tplRegs = array();       //array of used regular expressions
  var $tplTags = array();       //extracted tags structure
  var $tplTagsParsed = array();       //extracted tags structure; parsed copy
  var $tplTexts = array();      //extracted texts (between tags)
  var $tplTextsParsed = array();  //extracted texts (between tags); parsed copy of $tplTexts
  
  var $tplCurTplStr = '';       //string describing current file being parsed (used mainly in error msgs)

  var $tplBlocks = array();     //used to resolve nested blocks
  

  var $_tagIndex = 0;           //index of last processed tag

  var $debug = false;
  
  function blibTemplate() {
    $ldq = preg_quote($this->tplDelimLeft, '~');
    $rdq = preg_quote($this->tplDelimRight, '~');
    
    $this->tplRegs['all_tags'] = "~{$ldq}\s*(.*?)\s*{$rdq}~s";
    $this->tplRegs['include_tags'] = "~{$ldq}\s*(include)(.*?)\s*{$rdq}~s";
    $this->tplRegs['non_tags'] = "~{$ldq}.*?{$rdq}~s";
    $this->tplRegs['keywords'] = "/^(section|\/section|if|else|\/if)\b/i";
    $this->tplRegs['keywords_start'] = array('if','section');
    $this->tplRegs['keywords_end'] = array('/if','/section');
    $this->tplRegs['all_vars'] = "/\\$[a-z0-9_]+\b/si";
    $this->tplRegs['all_vars_f'] = "/\\$[a-z0-9_.\"]+\b/si";
    $this->tplRegs['all_non_vars'] = "/[\+\-]+\b/si";

    $this->tplVars['tpl'] = array('section'=>array('iteration'=>0,'total'=>0,'index'=>0));
  }

  function init($inTplDir = '') {
  	$this->blibTemplate();
    $this->tplDir = $inTplDir;
  }
  
  /*
  * Assigns variable
  */
  function assign($inVar, $inVal = null) {
  	if($inVar == 'tpl') {
  		$this->errorThrow(get_class($this),'"'.$inVar.'" is reserved for internal use',__FILE__,__LINE__);
  	}
    $this->tplVars[$inVar] = $inVal;
  }

	function getVar($inVar) {
		if(isset($this->tplVars[$inVar])) {
			return $this->tplVars[$inVar];
		}else {
			return '';
		}
	}

  /*
  * Clears specified variable
  */
  function clear($inVar) {
  	
    if(isset($this->tplVars[$inVar])) {
  		unset($this->tplVars[$inVar]);
  	}
  }
  
  /*
  * Clears all registered variables
  */
  function clearAll() {
  	$this->tplVars = array();
    $this->tplVars['tpl'] = array('section'=>array('iteration'=>0,'total'=>0,'index'=>0));
  }

  /*
  * Fetches *parsed* template file
  */
  function fetch($inFile, $inSourceContent = '') {
		if(strlen($inSourceContent)) {
			$this->tplCurTplStr = '<b>Template:</b> Source String';
			$content = $inSourceContent;
		}else {
			$this->hFile = new blibFile($this->tplDir.$inFile);
			$this->tplCurTplStr = '<b>Template:</b> '.$inFile;
			$content = $this->hFile->contentGet();
		}
    return $this->_parse($content);
  }
  
  /*
  * Displays *parsed* template file
  */
  function display($inFile) {
    echo $this->fetch($inFile);
  }
  
	
	function _parseIncludes($sourceContent) {
    //process included content
    preg_match_all($this->tplRegs['include_tags'], $sourceContent, $_match);
    foreach($_match[2] as $key=>$val) {
    	$val = str_replace(')','',str_replace('(','',$val));
    	$hFile = new blibFile($this->tplDir.$val);
      $sourceContent = str_replace($_match[0][$key],$hFile->contentGet(),$sourceContent);
    }
    unset($_match);
    preg_match_all($this->tplRegs['include_tags'], $sourceContent, $_match);
		if(count($_match[2])) {
			$sourceContent = $this->_parseIncludes($sourceContent);
		}
		return $sourceContent;
	}

	function _parseRawPHP($sourceContent) {
    $ldq = preg_quote($this->tplDelimLeft, '~');
    $rdq = preg_quote($this->tplDelimRight, '~');
		
		preg_match_all("~{$ldq}code{$rdq}\s*(.*?)\s*{$ldq}\/code{$rdq}~s", $sourceContent, $raw_codes);
		$non_codes = preg_split("~{$ldq}code{$rdq}\s*(.*?)\s*{$ldq}\/code{$rdq}~s", $sourceContent);
		
		$out = '';
		foreach($non_codes as $key=>$non_code) {
			$out .= $non_code;
			
			if(isset($raw_codes[1][$key])) {
				ob_start();	
				@eval($raw_codes[1][$key]);
				$out .= ob_get_clean();
			}
		}
		return $out;
	}

  /*
  * Parses submited data for template varible/sections/conditionals
  */
  function _parse(&$sourceContent) {
    $parsedContent = '';
    $this->_tagIndex = 0;
    
		$sourceContent = $this->_parseIncludes($sourceContent);
		$sourceContent = $this->_parseRawPHP($sourceContent);

    //get all template tags
    preg_match_all($this->tplRegs['all_tags'], $sourceContent, $_match);
    $this->tplTagsParsed = $this->tplTags = $_match[1];
    unset($_match);

    // Get all raw content between tags
    $this->tplTextsParsed = $this->tplTexts = preg_split($this->tplRegs['non_tags'], $sourceContent);


    //validate if this document could be parsed
    $this->_validate();
    /*
    echo '<pre>';
    print_r($this->tplTags);
    */
    //parse content
    for($i=0,$max=count($this->tplTags); $i<=$max; $i++) {
      if(($move = $this->_parseTag())!=-1) {
    		$i = $move;
    	}
    }

    /*
    $this->debugPrint($this->tplTagsParsed);
    foreach($this->tplTextsParsed as $key=>$val) {
    	$val = str_replace('<','&lt;',$val);
    	$val = str_replace('>','&gt;',$val);
      $tt[$key] = $val;
    }
    $this->debugPrint($tt);
    */
    
    //combine output
    for($i=0,$max=count($this->tplTagsParsed); $i<$max; $i++) {
    	if($this->tplTagsParsed[$i]=='') {  //variable is empty remove next block's starting new line
        $this->tplTextsParsed[$i+1] = preg_replace('~^(\r\n|\r|\n)~', '', $this->tplTextsParsed[$i+1]);    		
    	}

      //todo: remove blank lines from parsed output
    	
      $parsedContent .= $this->tplTextsParsed[$i].$this->tplTagsParsed[$i];
    }
    $parsedContent .= $this->tplTextsParsed[$i];

    return $parsedContent;	
  }

  /*
  * Checks if template could be parsed
  */
  function _validate() {
    //validate close open tags match
    $tcnt = array();
    foreach($this->tplTags as $key=>$tag) {
      $inKey = preg_split("/[\s]+/",$tag);
    	switch($inKey[0]) {
    		case 'if':
        case '/if':
        case 'section':
        case '/section':
          $tcnt[$inKey[0]] = isset($tcnt[$inKey[0]])?++$tcnt[$inKey[0]]:1;        
        break;
    	}
    }
    if(count($tcnt)%2) {
    	$this->errorThrow(get_class($this),'Unmatched open/close tags: template validation failed <br>'.$this->tplCurTplStr,__FILE__,__LINE__);
    }else {
    	foreach($tcnt as $key=>$val) {
    		if($key{0}!='/') {
    			if($tcnt[$key]!=$tcnt['/'.$key]) {
    				$this->errorThrow(get_class($this),'Unmatched open/close tags: template validation failed <br>'.$this->tplCurTplStr,__FILE__,__LINE__);
    			}
    		}
    	}
    }
  }

  /*
  * Parses current tag
  */
  function _parseTag() {
    if(!isset($this->tplTags[$this->_tagIndex])) {
    	return -1;
    }
    $tag = $this->tplTags[$this->_tagIndex];

    if($tag{0}=='*') {  //process comments
    	$this->tplTags[$this->_tagIndex] = '';
    }
    
    if(preg_match($this->tplRegs['keywords'],$tag,$_match)) {//check out if tag is a special keyword (such as section)
    	
      $ind = $this->_tagIndex;
      $this->_parseBlock($this->_tagIndex);
      
      if($ind==$this->_tagIndex) {
      	$this->_tagIndex++;
      }

      return $this->_tagIndex;
    }elseif($tag{0}!='$'&&strlen(trim($tag))&&$tag{0}!='*') {       //function call
    	$this->tplTagsParsed[$this->_tagIndex] = $this->_parseFunction($this->_tagIndex);
      $this->_tagIndex++;
    }else { //simple variable
    	$this->tplTagsParsed[$this->_tagIndex] = $this->_parseVar($this->_tagIndex);
      $this->_tagIndex++;
    }
  	return -1;
  }

  /*
  * Parses ordinary variable (scalar/array)
  */
  function _parseVar($inTagIndex) {
    return $this->_parseRawVar($this->tplTags[$inTagIndex]);
  }
  
  /*
  * Parses string representation of variable
  */
  function _parseRawVar($inTag) {
  	//split tag into command, modifiers, parameters
    $tag = explode('|',$inTag);
    
    //process inline *scalar* variables 
    if(preg_match_all($this->tplRegs['all_vars'], $tag[0], $_match)) {
      for($i=count($_match[0])-1; $i>=0; $i--) {
        $_var = substr($_match[0][$i],1);
        if(isset($this->tplVars[$_var])) {
          if(is_array($this->tplVars[$_var])) {
            $tag[0] = $this->_parseArray($tag[0],$this->tplVars[$_var],true);
          }else {
            $tag[0] = str_replace('$'.$_var,$this->tplVars[$_var],$tag[0]);	
          }
        }else {
        	$tag[0] = '';
        }
      }
    }
    if(count($tag)>1) {//modifiers are present
      for($i=1,$max=count($tag); $i<$max; $i++) {
      	$tag[0] = $this->_varmodApply($tag[0],$tag[$i]);
      }
    }
    return $tag[0];
  }
  
  /*
  * parses given string substituding assigned vars with their coresponding values
  */
  function _parseString($inData) {
    if(preg_match_all($this->tplRegs['all_vars_f'], $inData, $_match)) {
      for($i=count($_match[0])-1;$i>=0; $i--) {
        $_var1 = $_match[0][$i];
        preg_match($this->tplRegs['all_vars'],$_var1,$_var);
        $_var = isset($_var[0])?$_var[0]:$_var1;
        $_var1 = substr($_var1,1);
        $_var = substr($_var,1);
        if(isset($this->tplVars[$_var])) {
          if(is_array($this->tplVars[$_var])) {
            /*
            if(is_string($this->tplVars[$_var])) {
            	$inData = str_replace('$'.$_var1,'"'.$this->_parseArray($_var1,$this->tplVars[$_var]).'"',$inData);
            }else {
              $inData = str_replace('$'.$_var1,$this->_parseArray($_var1,$this->tplVars[$_var]),$inData);	
            }
            */
          }else {
            $inData = str_replace('$'.$_var,(is_string($this->tplVars[$_var])?'"'.$this->tplVars[$_var].'"':$this->tplVars[$_var]),$inData);	
          }
        }
      }
    }

    //additional processing for arrays

    $inData = $this->_preparseArray($inData);

    if(preg_match_all($this->tplRegs['all_vars_f'], $inData, $_match)) {
      for($i=count($_match[0])-1;$i>=0; $i--) {
        $_var1 = $_match[0][$i];
        preg_match($this->tplRegs['all_vars'],$_var1,$_var);
        $_var = isset($_var[0])?$_var[0]:$_var1;
        $_var1 = substr($_var1,1);
        $_var = substr($_var,1);
        if(isset($this->tplVars[$_var])) {
          if(is_array($this->tplVars[$_var])) {
            $subs = $this->_parseArray('$'.$_var1,$this->tplVars[$_var]);
            $subs = (is_string($subs))?'"'.$subs.'"':$subs;
            if(!is_array($subs)) {
              $inData = str_replace('$'.$_var1,$subs,$inData);		
            }else {
            	$inData = str_replace('$'.$_var1.'.','',$inData);		
            }
          }
        }
      }
    }
		$inData = str_replace('".','"',$inData);
    return $inData;
  }
  
  function _preparseArray($inTag) {
    $inTag = str_replace('["','[',$inTag);
    $inTag = str_replace('"]',']',$inTag);
    $inTag = str_replace('[','.',$inTag);
    $inTag = str_replace('].',']',$inTag);
    $inTag = str_replace(']','.',$inTag);
    $inTag = str_replace('..','.',$inTag);
    if(substr($inTag,-1)=='.') {
    	$inTag = substr($inTag,0,-1);
    }
    return $inTag;  	
  }

  /*
  * Translates array string into corresponding assigned value
  */
  function _parseArray($inTag,$inVal, $inNullify = false) {
    $inTag = str_replace('[','.',$inTag);
    $inTag = str_replace('].',']',$inTag);
    $inTag = str_replace(']','.',$inTag);
    $inTag = str_replace('..','.',$inTag);
    if(substr($inTag,-1)=='.') {
      $inTag = substr($inTag,0,-1);
    }
    $dims = explode('.',substr($inTag,1));
    $found = true;
    if(count($dims)>1) {
      $inTag = $inVal;
      for($i=1,$max = count($dims); $i<$max; $i++) {
        if(isset($inTag[$dims[$i]])) {
          $inTag = $inTag[$dims[$i]];
        }else {
          $inTag = $inTag;
          $found = false;
          break;
        }
      }
    }else {
      $inTag = $inVal;
    }
    if($inNullify&&($found==false)) {
      return '';    	
    }else {
      return $inTag;	
    }
  }

  /*
  * Parses pre-defined function call
  */
  function _parseFunction($inTagIndex) {
    $inFunc = explode('(',str_replace(')','',$this->tplTags[$inTagIndex]));
    if(!(strpos($inFunc[1],',')===false)) {
      $inFunc = array_merge($inFunc , explode(',',$inFunc[1]));	
    }
    
    foreach($inFunc as $key=>$val) {
    	$inFunc[$key] = str_replace("'",'',str_replace('"','',trim($inFunc[$key])));
    }

    switch(strtolower($inFunc[0])) {
			case 'iff':
				if(isset($inFunc[2])&&isset($inFunc[3])&&isset($inFunc[4])) {
					$inFunc[5] = isset($inFunc[5])?$inFunc[5]:'';
					$inFunc[2] = $this->_parseString($inFunc[2]);
					$inFunc[3] = $this->_parseString($inFunc[3]);
					if(str_replace('"','',$inFunc[2])==str_replace('"','',$inFunc[3])) {
						return $inFunc[4];
					}else {
						return $inFunc[5];
					}
        }
			break;
    	case 'assign':
        if(isset($inFunc[2])&&isset($inFunc[3])) {
          $this->assign($inFunc[2],str_replace('"','',$this->_parseString($inFunc[3])));
        }
      break;
    	case 'concat':
        if(isset($inFunc[2])&&isset($inFunc[3])) {
          return str_replace('"','',$this->_parseString($inFunc[2]).$this->_parseString($inFunc[3]));
        }
      break;
    	case 'get_random':
				if(isset($inFunc[1])) {	
					if(isset($this->tplVars[substr($inFunc[1],1)])) {
						$mvar = &$this->tplVars[substr($inFunc[1],1)];
						if(is_array($mvar)&&count($mvar)) {
							srand((float)microtime()*1000000); 
							shuffle($mvar); 
							return array_pop($mvar);
						}
					}
				}
      break;
    	case 'get_next':
				if(isset($inFunc[1])) {	
					if(isset($this->tplVars[substr($inFunc[1],1)])) {
						$mvar = &$this->tplVars[substr($inFunc[1],1)];
						if(is_array($mvar)&&count($mvar)) {
							return array_shift($mvar);
						}
					}
				}
      break;
      default:
        return 'Function "'.$this->tplTags[$inTagIndex].'" undefined';
      break;
    }
    return '';
  }

  /*
  * Variable modifier apply
  */
  function _varmodApply($inData, $inMod) {
  	$inMod = explode(':',$inMod);
    foreach($inMod as $key=>$val) {
    	$inMod[$key] = str_replace("'",'',str_replace('"','',trim($inMod[$key])));
    }
    switch($inMod[0]) {
  		case 'replace':
        if(isset($inMod[1])&&isset($inMod[2])) {
          return str_replace($inMod[1],$inMod[2],$inData);
        }
      break;
  		case '+':
        if(isset($inMod[1])) {
          return (int)($inData+$this->_parseString($inMod[1]));
        }
      break;
  		case '-':
        if(isset($inMod[1])) {
          return (int)($inData-$this->_parseString($inMod[1]));
        }
      break;
  		case '/':
        if(isset($inMod[1])) {
          $a = $inData;
          $b = (int)str_replace('"','',$this->_parseString($inMod[1]));
          if($b!=0) {
            $a =  $a/$b;	
          }
          return $a;
        }
      break;
  		case '*':
        if(isset($inMod[1])) {
          return (int)($inData*$this->_parseString($inMod[1]));
        }
      break;
  		case '%':
        if(isset($inMod[1])) {
          return (int)($inData%$this->_parseString($inMod[1]));
        }
      break;
      case 'strtoupper':
      case 'strtolower':
        if($inMod[0]{5}=='u') {
        	return strtoupper($inData);
        }else {
        	return strtolower($inData);
        }
      break;
      case 'ucfirst':
        return ucfirst($inData);
      break;
      case 'ucwords':
        return ucwords($inData);
      break;
      case 'nl2br':
        return nl2br($inData);
      break;
      default:
        return $inData;
      break;
  	}
    $this->errorThrow(get_class($this),'Modifier failed: "'.$inMod[0].'" on '.$this->tplDelimLeft.$this->tplTags[$this->_tagIndex].$this->tplDelimRight.' in "'.basename($this->hFile->filepath).'"',__FILE__,__LINE__);
  }

  /*
  * Parses special blocks (conditionals, loops etc)
  */
  function _parseBlock($inTagIndex) {
    $inTag = preg_replace("/[\s]+(=|==)[\s]+/",'\\1',$this->tplTags[$inTagIndex]);
  	$inKey = preg_split("/[\s]+/",$inTag);
    if(!isset($inKey[0])) {
    	$this->errorThrow(get_class($this),'Keyword used incorrectly: "'.$this->tplTags[$inTagIndex].'"',__FILE__,__LINE__);
    }
  
    if(in_array($inKey[0],$this->tplRegs['keywords_start'])) {
      if(isset($this->tplBlocks[count($this->tplBlocks)-1])) {
      	$_prev = $this->tplBlocks[count($this->tplBlocks)-1]['index'];
      }else {
      	$_prev = -1;
      }
      if($_prev!=$inTagIndex||$_prev==-1) {
        $this->tplBlocks[] = array('key'=>$inKey[0],'index'=>$inTagIndex,'depth'=>count($this->tplBlocks),'args'=>array());		
      }
      
    }
    //get reference to the last block
    if(isset($this->tplBlocks[count($this->tplBlocks)-1])) {
      $depth = $this->tplBlocks[count($this->tplBlocks)-1]['depth'];	
      $curBlock = &$this->tplBlocks[count($this->tplBlocks)-1];
    }else {
    	$depth = 0;
      $curBlock = array('key'=>'','index'=>0,'depth'=>0,'args'=>array());
    }
    
    $curData = '';
    /*
    if($this->debug) {
      echo '['.$inTagIndex.'] - '.$this->tplTags[$inTagIndex].'<br>';	
    }
    */
    
    switch($inKey[0]) {
    	case 'if':
        $this->tplBlocks[count($this->tplBlocks)-1]['args'] = array('cond'=>0);
        $cond = implode(' ',array_slice($inKey,1));
        $cond = $this->_parseString($cond);
        $cond = 'return (('.$cond.')?true:false);';
        $cond = @eval($cond); 
        if(!((bool)$cond)) {  //move tag parse pointer to corresponding "else","/if"
          $curBlock['args']['cond'] = 0;
          if(($np = $this->_tagLocate('else',$depth,$inTagIndex))!=-1) {//else located
          	$this->_tagIndex = $np;
          }elseif(($np = $this->_tagLocate('/if',$depth,$inTagIndex))!=-1) {//end if located
          	$this->_tagIndex = $np;
          }
        }else {//condition met procced
        	$curBlock['args']['cond'] = 1;
        }
      break;
      case '/if':
        if($curBlock['args']['cond']==0) {//condition was false => terminate current "if" (but look if we have "else")
          if(($np = $this->_tagLocate('else',$depth,$inTagIndex,'up'))!=-1) {//else block exitsed
            $curData = $this->_blockGetData($np,$inTagIndex);
          }
        }else {//condition was true => condition was true => process "if"
          $np = $curBlock['index'];
          if(($np1 = $this->_tagLocate('else',$depth,$inTagIndex,'up'))!=-1) {//else block existed
            $curData = $this->_blockGetData($np,$np1);
          }else {
            $curData = $this->_blockGetData($np,$inTagIndex);
          }
        }

        $this->_blockClearData($curBlock['index'],$inTagIndex,$curData);		
        array_pop($this->tplBlocks);
      break;
      case 'else':
          if($curBlock['args']['cond']==0) {//condition was false => process current "else"
            $this->_tagIndex++;
          }else {//condition was true => terminate current "else"
            if(($np = $this->_tagLocate('/if',$depth,$inTagIndex))!=-1) {
              $this->_tagIndex = $np;
            }
          }
      break;
      case 'section':
        $this->tplBlocks[count($this->tplBlocks)-1]['args']['pars'] = array();
        for($i=1,$max = count($inKey); $i<$max; $i++) {
        	if(!(strpos($inKey[$i],'=')===false)) {
        	  list($var,$val) = explode('=',$inKey[$i]);	
            $this->tplBlocks[count($this->tplBlocks)-1]['args']['pars'][$var] = $val;
        	}
        }
        if(!isset($this->tplBlocks[count($this->tplBlocks)-1]['args']['pars']['loop'])) {
        	$this->errorThrow(get_class($this),'Invalid use of tag: "'.$this->tplTags[$inTagIndex].'"',__FILE__,__LINE__);
        }
        $_section = &$this->tplBlocks[count($this->tplBlocks)-1]['args'];

        $_loop = $this->_parseRawVar($_section['pars']['loop']);



        //evaluate if loop should proceed
        
        if(!isset($this->tplBlocks[count($this->tplBlocks)-1]['args']['intr'])) {
          $this->tplBlocks[count($this->tplBlocks)-1]['args']['intr'] = array('iteration'=>1,'index'=>0,'total'=>0,'data'=>'');	
          $_section['intr']['var'] = $_loop;

          if(is_array($_loop)) {
            if(!isset($_section['pars']['name'])) {
            	$this->errorThrow(get_class($this),'Invalid use of tag: "'.$this->tplTags[$inTagIndex].'"',__FILE__,__LINE__);
            }
          	$_section['intr']['total'] = count($_loop);
            reset($_section['intr']['var']);
            $this->assign($_section['pars']['name'],key($_section['intr']['var']));
          }else {
          	$_section['intr']['total'] = (int)$_loop;
          }
        }else {
          if(is_array($_section['intr']['var'])) {
            next($_section['intr']['var']);
            $this->assign($_section['pars']['name'],key($_section['intr']['var']));
          }
        }

        $this->tplVars['tpl']['section']['iteration'] = $_section['intr']['iteration'];
        $this->tplVars['tpl']['section']['total'] = count($_section['intr']['var']);
        $this->tplVars['tpl']['section']['index'] = $_section['intr']['index'];
        
        if($_section['intr']['total']==0) {//no iterations
          if(($np = $this->_tagLocate('/section',$depth,$inTagIndex))!=-1) {
            $this->_tagIndex = $np;
          }else {
          	$this->errorThrow(get_class($this),'Invalid use of tag: "'.$this->tplTags[$inTagIndex].'"',__FILE__,__LINE__);
          }
        }else {
          $this->_tagIndex++;
        }
      break;
      case '/section':
        $curBlock['args']['intr']['data'] .= $this->_blockGetData($curBlock['index'],$inTagIndex);
        $curBlock['args']['intr']['total'] = $curBlock['args']['intr']['total'] - 1;
        $curBlock['args']['intr']['iteration']++;
        $curBlock['args']['intr']['index']++;

        if($curBlock['args']['intr']['total']<=0) {//no iterations
          if($curBlock['args']['intr']['total']<0) {//section quits with no single iteration
          	$curBlock['args']['intr']['data'] = '';
          }
          $this->_tagIndex++;
          $this->_blockClearData($curBlock['index'],$inTagIndex,$curBlock['args']['intr']['data']);
          array_pop($this->tplBlocks);
          $this->tplVars['tpl'] = array('section'=>array('iteration'=>0,'total'=>0,'index'=>0));
        }else {
          $this->_blockRecreate($curBlock['index'],$inTagIndex);
          $this->_tagIndex = $curBlock['index'];
        }
      break;
      default:
        $this->errorThrow(get_class($this),'Keyword is undefined: "'.$this->tplTags[$inTagIndex].'"',__FILE__,__LINE__);
      break;
    }

  }
  
  /*
  * Removes specified portion of tags/texts arrays
  */
  function _blockClearData($inStart,$inEnd,$inSwapData = '') {
    if($inStart==-1||$inEnd==-1) {
    	return 0;
    }
    for($i=$inStart; $i<$inEnd; $i++) {
      $this->tplTagsParsed[$i] = '';
      if($i==$inStart&&$inSwapData!='') {
        $this->tplTextsParsed[$i+1] = $inSwapData;  			
  		}else {
        $this->tplTextsParsed[$i+1] = '';
  		}
  	}
    if(isset($this->tplTagsParsed[$inEnd])) {
    	$this->tplTagsParsed[$inEnd] = '';
    }
  }

  /*
  * Returns as string combined tag/text postion of respective arrays
  */
  function _blockGetData($inStart,$inEnd) {
    $out = '';
    for($i=$inStart; $i<$inEnd; $i++) {
      $this->tplTextsParsed[$i+1] = preg_replace('~^(\r\n|\r|\n)~', '', $this->tplTextsParsed[$i+1]);
      if($i!=$inStart) {
      	$out .= $this->tplTagsParsed[$i].$this->tplTextsParsed[$i+1];
      }else {
        $out .= $this->tplTextsParsed[$i+1];	
      }
      
  	}

    //$out = preg_replace("/(if|section).*?(\/\\1)/si",'#blib_inner#',$out);
    return $out;
  }

  /*
  * Returns original stated of parsed arrays
  */
  function _blockRecreate($inStart, $inEnd) {
  	for($i=$inStart; $i<$inEnd; $i++) {
  		$this->tplTextsParsed[$i+1] = $this->tplTexts[$i+1];
      $this->tplTagsParsed[$i] = $this->tplTags[$i];
  	}
  }

  /*
  * Locates given tag
  */
  function _tagLocate($inTag,$inDepth,$inIndex,$inDir='down') {
  	$iStart = ($inDir=='down')?++$inIndex:--$inIndex;
  	$iEnd = ($inDir=='down')?count($this->tplTags)-1:0;
    $iCur = $iStart;
    $iDepth = $inDepth;
    $ret = -1;
    if($inDir=='down') {
      for($i=$iStart; $i<=$iEnd; $i++) {
        $tag = $this->tplTags[$i];
        $tag = preg_split("/[\s]+/",$tag);	
        if($inTag==$tag[0]&&$inDepth==$iDepth) {//tag located
          $ret = $i;
          break;
        }
        switch($tag[0]) {
          case 'if':
          case 'section':
            $iDepth++;
          break;
          case '/if':
          case '/section':
            $iDepth--;
          break;
        }
        if($iDepth<0||$iDepth<$inDepth) {
        	break;
        }
      }	
    }else {
      for($i=$iStart; $i>$iEnd; $i--) {
        $tag = $this->tplTags[$i];
        $tag = preg_split("/[\s]+/",$tag);	
        if($inTag==$tag[0]&&$inDepth==$iDepth) {//tag located
          $ret = $i;
          break;
        }
        switch($tag[0]) {
          case 'if':
          case 'section':
            $iDepth--;
          break;
          case '/if':
          case '/section':
            $iDepth++;
          break;
        }
        if($iDepth<0||$iDepth<$inDepth) {
        	break;
        }
      }    	
    }

    //echo '['.$inIndex.'-'.$inTag.'-'.$inDepth.'-'.$inDir.']=> '.$ret.'<br>';

    return $ret;
  }
  function _tagLocate1($inTag,$inDepth,$inIndex,$inDir='down') {
  	if($inIndex==15) {
  		return $this->_tagLocate1($inTag,$inDepth,$inIndex,$inDir);
  	}
    $iStart = ($inDir=='down')?++$inIndex:--$inIndex;
  	$iEnd = ($inDir=='down')?count($this->tplTags)-1:0;
    $iCur = $iStart;
    $iDepth = $inDepth;
    do {
      if(!isset($this->tplTags[$iCur])) {
      	break;
      }
      $tag = $this->tplTags[$iCur];
      if(is_array($tag)) {
      	$tag = 'Array';
      }else {
        $tag = preg_split("/[\s]+/",$tag);	
      }
      
      if($inTag==$tag[0]&&$inDepth==$iDepth) {//tag located
      	return $iCur;
      }

      switch($tag[0]) {
      	case 'if':
      	case 'section':
          $iDepth++;
        break;
        case '/if':
        case '/section':
          if($inDepth==$iDepth) {
          	exit;
            return $iCur;
          }
          $iDepth--;
          /*
          echo $inTag.'['.$inIndex.']<br>';
          print_r($tag);
          echo '['.$inDepth.']['.$iDepth.']<br>';
          */
          if($inDepth>=$iDepth) {
            if($inTag==$tag[0]) {
              $iCur = ($inDir=='down')?++$iCur:--$iCur;
          		return $iCur;//todo check out if "($inDir=='down')?++$iCur:--$iCur;" should be passed instead
          	}else {
          		return -1;
          	}
          }
          
        break;
      }      

      if($iCur==$iEnd) {
      	break;
      }else {
      	$iCur = ($inDir=='down')?++$iCur:--$iCur;
      }
    }while(true);

    return -1;
  }
}

//file: blibTabs.class.php
class blibTabs extends blibControl {
  var $hTpl;                    //pointer to templating engine    
  var $tabsStatusLine = '';     //status line
  var $tabsHeight = '';     //dims/height
	var $tabsWidth = '100%';     //dims/width
  var $tabsData = array();      //list of assigned tabs
  var $tabsSubLinksTitle = '';
  var $tabsSubLinks = array();  //links under main tabs
  var $tabsHelpIndex = -1;      
  var $tabsNav = array('xpane'=>1,'spane'=>0,'fpane'=>'');
  var $tabsContent = '';
  var $tabsContentHead = array();
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'tabs';
    $this->cntCssFile = $this->cntBaseUrl.'blibTabs/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibTabs/blibTabs.tpl.php';
	}
  
  function setContent($inData) {
  	$this->tabsContent = $inData;
  }

  function addHeader($inHead, $inDesc = '', $inImage = '') {
    $this->tabsContentHead = array('head'=>$inHead, 'desc'=>$inDesc, 'img'=>$inImage);
  }

  function updateHeader($inKey,$inVal, $append = false) {
  	if(isset($this->tabsContentHead[$inKey])) {
  		if($append) {
        $this->tabsContentHead[$inKey] .= $inVal;
  		}else {
        $this->tabsContentHead[$inKey] = $inVal;
  		}
  	}
  }

  /*
  * Adds single tab
  */
  function addTab($inField, $inCaption, $inType = 1 , $inPos = -1) {
    $inPos = ($inPos==-1)?count($this->tabsData)+1:$inPos;
    $this->tabsData[] = array('name'=>$inField, 'caption'=>$inCaption, 'type'=>$inType,'pos'=>$inPos);
  }

  function getTabIndex($inTab) {
    foreach($this->tabsData as $k=>$tab) {
  		if($tab['name']==$inTab) {
  			return ++$k;
  		}
  	}
    return -1;
  }

  function getSubTabIndex($inTab) {
		foreach($this->tabsSubLinks as $k=>$tab) {
  		if($tab['name']==$inTab) {
  			return ++$k;
  		}
  	}
    return -1;
  }

	function &getTabObject($inTab) {
		if(isset($this->tabsData[$this->getTabIndex($inTab)-1])) {
			return $this->tabsData[$this->getTabIndex($inTab)-1];
		}elseif(isset($this->tabsSubLinks[$this->getSubTabIndex($inTab)-1])) {
			return $this->tabsSubLinks[$this->getSubTabIndex($inTab)-1];
		}else {
			return null;
		}
		
	}
  
  /*
  * Clears all tabs
  */
  function clearTabs($inType = 0) {
    $this->tabsData = array();
  }

  function addSubLinkTitle($inTitle) {
  	$this->tabsSubLinksTitle = $inTitle;
  }
  function addSubLink($inField, $inCaption, $inUrl = '', $inSubUrl = '') {
  	$this->tabsSubLinks[] = array('name'=>$inField, 'caption'=>$inCaption, 'url'=>$inUrl, 'pos'=>count($this->tabsSubLinks)+1,'surl'=>$inSubUrl);
  }
  
  function clearSubLinks() {
    $this->tabsSubLinksTitle = '';
  	$this->tabsSubLinks = array();
  }

  function setHelpUrl($inUrl) {
    $this->tabsHelpIndex = $inUrl;  	
  }

  function getQueStr() {
  	$out = $this->cntId.'xpane='.$this->tabsNav['xpane'];
    if($this->tabsNav['spane']) {
    	$out .= '&'.$this->cntId.'spane='.$this->tabsNav['spane'];
    }
    if($this->tabsNav['fpane']) {
    	$out .= '&'.$this->cntId.'fpane='.$this->tabsNav['fpane'];
    }
    return $out;
  }

  function getPane($inType = 'x') {
    $this->_processQueStr();
		if($this->tabsNav['fpane']==''&&count($this->tabsSubLinks)&&isset($this->tabsSubLinks[0]['name'])) {
			$this->tabsNav['fpane'] = $this->tabsSubLinks[0]['name'];
		}
    switch($inType) {
    	case 'x':return $this->tabsNav['xpane']; break;
    	case 's':return $this->tabsNav['spane']; break;
    	case 'f':return $this->tabsNav['fpane']; break;
    }
  }
  
  function setDims($inW,$inH=0) {
  	$this->tabsWidth = $inW;
    $this->tabsHeight = ($inH)?$inH:$this->tabsHeight;
  }
  
  function redirect($inUrl) {
    $out = '<form method=post name="'.$this->cntId.'Frm1" action=""></form><script language="JavaScript">';
    $out .= 'document.forms["'.$this->cntId.'Frm1"].action = "'.$inUrl.'";';
    $out .= 'document.forms["'.$this->cntId.'Frm1"].submit();</script>';
    echo $out;
    exit;
  }

  function _make() {
    $this->_processQueStr();
    $this->_processGlobals();
    
    //sort data
    $sortarray = array();
    foreach ($this->tabsData as $row) {
       $sortarray[] = $row['pos'];
    }
    array_multisort($sortarray, SORT_ASC, SORT_REGULAR, $this->tabsData);
    
    $tabsRight = $tabsLeft = array();
    foreach($this->tabsData as $tab) {
    	if($tab['type']==1) {
    		$tabsLeft[] = $tab;
    	}else {
    		$tabsRight[] = $tab;
    	}
    }
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('CONTENT',$this->tabsContent);
    $this->hTpl->assign('M_links_title',$this->tabsSubLinksTitle);
    $this->hTpl->assign('M_tabs_left',$tabsLeft);
    $this->hTpl->assign('M_tabs_right',$tabsRight);
    $this->hTpl->assign('tabs_count',count($tabsRight)+count($tabsLeft));
    $this->hTpl->assign('M_links',$this->tabsSubLinks);
    $this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  }

  function _processQueStr() {
    $this->tabsNav['xpane'] = (int)(isset($_GET[$this->cntId.'xpane'])?$_GET[$this->cntId.'xpane']:1);
  	$this->tabsNav['spane'] = (int)(isset($_GET[$this->cntId.'spane'])?$_GET[$this->cntId.'spane']:1);
  	$this->tabsNav['fpane'] = (isset($_GET[$this->cntId.'fpane'])?$_GET[$this->cntId.'fpane']:'');
  }

  function _processGlobals() {
    $this->cntGlobals = array();
    parent::_processGlobals();
    $this->cntGlobals['DIR_IMG'] = $this->cntBaseUrl.'/blibTabs/images/';
    $this->cntGlobals['HELP_URL'] = $this->tabsHelpIndex;
    $this->cntGlobals['CONTENT_HEAD'] = (count($this->tabsContentHead))?1:0;
    $this->cntGlobals['CONTENT_HEAD_DATA'] = $this->tabsContentHead;
    $this->cntGlobals['CUR_TAB'] = $this->tabsNav['xpane'];
    $this->cntGlobals['CUR_STAB'] = $this->tabsNav['spane'];
    $this->cntGlobals['CUR_FTAB'] = $this->tabsNav['fpane'];
    $this->cntGlobals['TAB_WIDTH'] = $this->tabsWidth;
    $this->cntGlobals['TAB_STATUS_LINE'] = $this->tabsStatusLine;
    if($this->tabsHeight) {
      $this->cntGlobals['TAB_HEIGHT'] = $this->tabsHeight;	
    }
    
  }
}

//file: blibPager.class.php
class blibPager extends blibClass {
    var $elementCount = 0;
    var $pageCount, $perPage, $currentPage, $currentElement;
    var $firstPageElement, $lastPageElement, $nextPageElement;
    var $firstPageLink, $lastPageLink, $nextPageLink;

    function init($elementCount, $currentPage = 1, $elementsPerPage = 10, $maxLinks = '', $currentElement = 0) {
        if ($elementCount > 0) {
            $this -> elementCount = $elementCount;
            $this -> perPage = $elementsPerPage;
        }else {
        	$this -> perPage = 1;
        }
        
        $this -> _setPageCount();
        
        // Calculate current page and element numbers
        $this -> currentElement = $currentElement;
        if ($currentElement > 0) {
            $this -> _setCurrentPage();
            $this -> _setFirstPageElement();
        }
        else {
            $this -> currentPage = $currentPage;
            if ($this -> currentPage < 1) {
                $this -> currentPage = 1;
            }
            elseif ($this -> currentPage > $this -> pageCount) {
                $this -> currentPage = $this -> pageCount;
            }
            $this -> _setFirstPageElement();
            $this -> currentElement = $this -> firstPageElement;
        }
        $this -> lastPageElement = $this -> firstPageElement + $this -> perPage - 1;
        if ($this -> lastPageElement >= $this -> elementCount) {
            $this -> lastPageElement = $this -> elementCount - 1;
        }
        $this -> nextPageElement = $this -> firstPageElement;
        
        // Calculate which pages should be linked to
        if (empty($maxLinks) or ($maxLinks >= $this -> pageCount)) {
            $this -> firstPageLink = 1;
            $this -> lastPageLink = $this -> pageCount;
        }
        else {
            if ($maxLinks < 3) {
                $maxLinks = 3;
            }
            $this -> lastPageLink = $this -> currentPage + floor($maxLinks / 2);
            if ($this -> lastPageLink > $this -> pageCount) {
                $this -> lastPageLink = $this -> pageCount;
            }
            $this -> firstPageLink = $this -> lastPageLink - ($maxLinks - 1);
            if ($this -> firstPageLink < 1) {
                $this -> firstPageLink = 1;
                $this -> lastPageLink = $maxLinks;
            }
        }
        $this -> nextPageLink = $this -> firstPageLink;
    } // constructor
    
    /*
    Public functions
    */
    
    // Page numbers
    function hasNextPage() {
        return ($this -> nextPageLink <= $this -> lastPageLink);
    }
    
    function nextPage() {
        return $this -> nextPageLink++;
    }
    
    function firstPage() {
        $this -> nextPageLink = $this -> firstPageLink;
        return $this -> nextPage();
    }
    
    function getPreviousPageNumber() {
        if ($this -> currentPage <= 1)
            return false;
        else return $this -> currentPage - 1;
    }
    
    function getNextPageNumber() {
        if ($this -> currentPage >= $this -> pageCount)
            return false;
        else return $this -> currentPage + 1;
    }
    
    function getFirstPageNumber() {
        return $this -> firstPageLink;
    }
    
    function getLastPageNumber() {
        return $this -> lastPageLink;
    }
    
    function getCurrentPageNumber() {
        return $this -> currentPage;
    }
    
    function getPageCount() {
        return $this -> pageCount;
    }

    // Element numbers
    function hasNextElement() {
        return ($this -> nextPageElement <= $this -> lastPageElement);
    }
    
    function nextElement() {
        return $this -> nextPageElement++;
    }
    
    function firstElement() {
        $this -> nextPageElement = $this -> firstPageElement;
        return $this -> nextElement();
    }
    
    function getFirstElementNumber() {
        return $this -> firstPageElement;
    }
    
    function getLastElementNumber() {
        return $this -> lastPageElement;
    }
    
    function getElementCount() {
        return $this -> elementCount;
    }
    /*
    Private methods
    */
    function _setPageCount() {
        if (!$this -> elementCount) $this -> pageCount = 0;
        else {
            $this -> pageCount = floor($this -> elementCount / $this -> perPage);
            if (($this -> elementCount % $this -> perPage) > 0) {
                $this -> pageCount++;
            }
        }
    } // _setPageCount()

    function _setCurrentPage() {
    // Calculate current page number from current element number
        if (!$this -> elementCount) {
            $this -> currentPage = 0;
        }
        else {
            $this -> currentPage = floor($this -> currentElement / $this -> perPage);
            if (($this -> currentElement % $this -> perPage) > 0) {
                $this -> currentPage++;
            }
            // Make sure currentPage is not off limits
            if ($this -> currentPage < 1) {
                $this -> currentPage = 1;
            }
            if ($this -> currentPage > $this -> pageCount) {
                $this -> currentPage = $this -> pageCount;
            }
        }
    } // _setCurrentPage()
    
    function _setFirstPageElement() {
    // Find the first element in the current page
        $this -> firstPageElement = ($this -> currentPage - 1) * $this -> perPage;
    } // _setFirstPageElement()
    function getLimit() {
      return ($this->currentPage-1)*$this->perPage.','.(int)$this->perPage;
    }
} // class blibPager


function getPageLinks(&$paginator,$inUrl,$pageNo, $emitFirstLast=false) {
  $out_str = '';
  
  $recStart = ($pageNo-1)*$paginator->perPage;
  $recStartPrev = ($pageNo-1-1)*$paginator->perPage;
  $recStartNext = ($pageNo-1+1)*$paginator->perPage;
  $recStartLast = ($paginator->getPageCount()-1)*$paginator->perPage;
  
  $links = array();

  if ($paginator -> getPageCount() > 1) {
      if($emitFirstLast) {
        if ($pageNo == 1) {
            $links[] = '&lt;&lt;';
            $links[] = '&lt;';
        }
        else {
            $links[] = '<a href="'.$inUrl.'0" target="_self" title="First page">&lt;&lt;</a>';
            $links[] = '<a href="'.$inUrl.''.$recStartPrev.'" target="_self" title="Previous page">&lt;</a>';
        }
      }
      $i = 0;
      while ($paginator->hasNextPage()) {
          if($i!=0) {
            $ndx = $paginator->nextPage();	
          }else {
          	$ndx = $paginator->firstPage();
            $i++;
          }
          
          if ($ndx == $pageNo) {
              $links[] =   '<span style="color:#CC3300;">'.$ndx.'</span>';
          }
          else {
              $links[] = '<a href="'.$inUrl.''.(($ndx-1)*$paginator->perPage). '" target="_self" title="Page '.$ndx.'">'.$ndx.'</a>';
          }
      }
      if($emitFirstLast) {
        if ($pageNo == $paginator->getPageCount()) {
            $links[] =   '&gt;';
            $links[] =   '&gt;&gt;';
        }
        else {
            $links[] = '<a href="'.$inUrl.''.$recStartNext.'" target="_self" title="Next page">&gt;</a>';
            $links[] = '<a href="'.$inUrl.''.$recStartLast.'" target="_self" title="Last page">&gt;&gt;</a>';
        }
      }
  }	
  $paginator->firstPage();
  
  return implode('&nbsp;&nbsp;',$links);
}

//file: blibGrid.class.php
/**
* Grid generation control
*/
class blibGrid extends blibControl{
  var $hTpl;                          //pointer to templating engine    
  var $hPager;                        //pointer to blibPager
  var $gridData = array();            //array of rows
  var $gridDataParsed = array();      //array of rows (ready to be used in templates)
  var $gridCols = array();
  var $gridActs = array();
  var $gridSortCol = array();         //column by which other rows are sorted
  var $gridSearchCol = array('term'=>'','type'=>'');					//term searched
  var $gridLimitValue = 0;         //selected rows limit filter
  var $gridLimitValues = array(10,20,30,40,50,60,75,100,150);         //selected rows limit filter
  var $gridShowIds = true;            //defines whether id column should be auto-appended
  var $gridShowChecks = false;            //defines whether checkbox column should be auto-appended
  var $gridPaging = array('pageTotal'=>1,'pageCurrent'=>1,'recsLimit'=>10,'recStart'=>0);   //keeps page related info (grid could be multipage)
  var $gridLinks = '';                //appendable links
  var $gridLinksBottom = '';          //appendable links
  var $gridAssumedRows = 0;           //assumed number of rows this grid containes
  var $gridAllowSlice = true;         //set true if you pass all data and only imitate paging 
  var $contHeight = '';         //dims/height
	var $contWidth = '100%';      //dims/width

  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'grd';
    $this->cntCssFile = $this->cntBaseUrl.'blibGrid/style.css';
		
		$this->setRowsLimit($this->gridLimitValues[0]);

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibGrid/blibGrid.tpl.php';
    $this->hPager = new blibPager();
    parent::_processGlobals();
  }

  function setDims($inW,$inH=0) {
  	$this->contWidth = $inW;
    $this->contHeight = ($inH)?$inH:$this->contHeight;
  }
  
  function setData($inData) {
  	$this->gridData = $inData;
  }
  
  function setRowsLimit($inNum) {
		$this->gridLimitValue = $inNum;
  	$this->gridPaging['recsLimit'] = $inNum;
  }

  function addCol($inField, $inCaption = '', $inRefId = -1, $inQue = '', $inSearchable = 0) {
  	$this->gridCols[$inField] = array('name'=>$inField, 'caption'=>$inCaption, 'rid'=>$inRefId, 'que'=>$inQue, 'search'=>$inSearchable);
  }

  function addAct($inField, $inCaption = '', $inRefId = -1, $inQue = '') {
  	$this->gridActs[$inField] = array('name'=>$inField, 'caption'=>$inCaption, 'rid'=>$inRefId, 'que'=>$inQue);
  }
  
  /*
  * Sorts data according to certain column
  */
  function sortCol($inCol, $inSortOrder = SORT_ASC) {
    $this->gridSortCol = array('name'=>$inCol, 'sort'=>$inSortOrder);
  }

  /*
  * Returns current query string related to ITEM functioning (used to restore the state once returned from linked page)
  */
  function getQueStr($inPage = 1, $inOrd = 1, $inLim = 1, $inSearch = 1) {
  	$this->_processQueStr();
    $out = '';
		if(isset($this->gridPaging['recStart'])&&$inPage) {
    	$out .= $this->cntId.'recStart='.$this->gridPaging['recStart'];
    }
    $out .= $inOrd?$this->_compileOrderStr():'';
    $out .= $inLim?$this->_compileRecLim():'';
    $out .= $inSearch?$this->_compileSearchStr():'';
    $out .= (substr($this->cntQueStr,0,1)=='&')?$this->cntQueStr:'&'.$this->cntQueStr;
    return $out;
  }

  function _processQueStr() {
    //process ordering
    if(isset($_GET[$this->cntId.'Srt'])&&isset($_GET[$this->cntId.'SrtO'])) {
      $inField = mysql_escape_string($_GET[$this->cntId.'Srt']);
      $inFieldO = (int)($_GET[$this->cntId.'SrtO']);
      $this->sortCol($inField,$inFieldO);
    }

    //process paging
    if(isset($_GET[$this->cntId.'recStart'])) {
      $this->gridPaging['recStart']	= (int)$_GET[$this->cntId.'recStart'];
    }

		//process limiting
		if(isset($_GET[$this->cntId.'recLim'])) {
			$this->setRowsLimit(((int)$_GET[$this->cntId.'recLim'])?(int)$_GET[$this->cntId.'recLim']:10);
		}

		//process searching
		$this->gridSearchCol['term']	= isset($_GET[$this->cntId.'srchTerm'])?str_replace('"',"'",addslashes($_GET[$this->cntId.'srchTerm'])):'';
		$this->gridSearchCol['type']	= isset($_GET[$this->cntId.'srchType'])?addslashes($_GET[$this->cntId.'srchType']):'';
    
  }


  /*
  * Compiles item output
  */
  function _make() {
    if(count($this->gridCols)==0) {
      return -1;
    }
    
    $this->_processQueStr();
    $this->_processGlobals();
    $this->_processPaging();
    
    $colActs = array();
    foreach($this->gridActs as $act) {
      for($i=0,$m=count($this->gridData); $i<$m; $i++) {
        if($act['rid']!=-1&&isset($this->gridData[$i][$act['rid']])&&$act['que']!='') {
          $colActs[$i][$act['name']]['que'] = $act['que'].$this->gridData[$i][$act['rid']];
        }else {
          $colActs[$i][$act['name']]['que'] = '';
        }
      }    	
    }

    $colFound = $this->gridCols;
		$showSearch = false;
    foreach($this->gridCols as $col) {
			if($colFound[$col['name']]['search']) {
				$showSearch = true;
			}
      if(isset($this->gridSortCol['name'])&&$this->gridSortCol['name']==$col['name']) {//current column is sorted
        $colFound[$col['name']]['que_head'] = $this->cntId.'Srt='.$col['name'].'&'.$this->cntId.'SrtO=';
        if($this->gridSortCol['sort']==3) {
        	$colFound[$col['name']]['que_head'] .= '4';
        }else {
        	$colFound[$col['name']]['que_head'] .= '3';
        }
      }else {
        $colFound[$col['name']]['que_head'] = $this->cntId.'Srt='.$col['name'].'&'.$this->cntId.'SrtO=4';
      }

      if(isset($this->gridPaging['recStart'])) {
      	$colFound[$col['name']]['que_head'] .= '&'.$this->cntId.'recStart='.$this->gridPaging['recStart'];
      }

      for($i=0,$m=count($this->gridData); $i<$m; $i++) {
        if(isset($this->gridData[$i][$col['name']])) {
          $this->gridDataParsed[$i][$col['name']]['val'] = $this->gridData[$i][$col['name']];	
          if($col['rid']!=-1&&isset($this->gridData[$i][$col['rid']])&&$col['que']!='') {
          	$this->gridDataParsed[$i][$col['name']]['que'] = $col['que'].$this->gridData[$i][$col['rid']];
          }else {
          	$this->gridDataParsed[$i][$col['name']]['que'] = '';
          }
        }else {
          if(isset($colFound[$col['name']])) {
            unset($colFound[$col['name']]);	
            break;
          }
        }
      }
    }

    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('M_rows_head', $colFound);
    $this->hTpl->assign('M_rows_acts', $colActs);
    $this->hTpl->assign('SHOW_SEARCH',$showSearch);
    $this->hTpl->assign('M_rows', $this->gridDataParsed);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  }

  
  function _processGlobals() {
    $this->cntGlobals = array();
    parent::_processGlobals();
    $this->cntGlobals['_GET'] = $_GET;
    $this->cntGlobals['QUE_STR'] = $this->getQueStr();
    $this->cntGlobals['QUE_STR_LIMIT'] = $this->getQueStr(0,1,1,1);
    $this->cntGlobals['QUE_STR_SEARCH'] = $this->getQueStr(0,1,1,0);
    $this->cntGlobals['DIR_IMG'] = $this->cntBaseUrl.'/blibGrid/images/';
    $this->cntGlobals['LIMIT_VALUES'] = $this->gridLimitValues;
    $this->cntGlobals['LIMIT_VALUE'] = $this->gridLimitValue;
    $this->cntGlobals['sortCol'] = $this->gridSortCol;
    $this->cntGlobals['GRID_ID'] = $this->cntId;
    $this->cntGlobals['SEARCH_COL'] = $this->gridSearchCol;
    $this->cntGlobals['SHOW_IDS'] = $this->gridShowIds;
    $this->cntGlobals['SHOW_CHECKS'] = $this->gridShowChecks;
    $this->cntGlobals['SHOW_ACTS'] = count($this->gridActs)?1:0;
    $this->cntGlobals['LINKS'] = $this->gridLinks;
    $this->cntGlobals['NAV'] = $this->_compilePagingNav();
    $this->cntGlobals['PAGING'] = $this->gridPaging;
    $this->cntGlobals['M_acts'] = $this->gridActs;
    $this->cntGlobals['COLW'] = (count($this->gridCols))?ceil(100/count($this->gridCols)).'%':'0';
    $this->cntGlobals['REC_START'] = $this->gridPaging['recStart'];
    $this->cntGlobals['LINKS_BOTTOM'] = $this->gridLinksBottom;
    $this->cntGlobals['CONT_WIDTH'] = $this->contWidth;
    if($this->contHeight) {
      $this->cntGlobals['CONT_HEIGHT'] = $this->contHeight;	
    }

  }
  
  function _processPaging() {
    if($this->gridPaging['recsLimit']!=-1&&$this->gridAllowSlice) {
      $this->gridData = array_slice($this->gridData,$this->gridPaging['recStart'],$this->gridPaging['recsLimit']);	
    }
  }

  
  function _compilePagingVars() {
    if($this->gridPaging['recsLimit']==-1) {
    	return '';
    }
    $cntRows = $this->gridAssumedRows;
    $this->gridPaging['pageTotal'] = (intval($cntRows/$this->gridPaging['recsLimit']))
            +(($cntRows%$this->gridPaging['recsLimit'])?1:0);
    $this->gridPaging['recStart'] = (isset($_GET['recStart']))?((int)$_GET['recStart']):$this->gridPaging['recStart'];
    $this->gridPaging['pageCurrent'] = ($this->gridPaging['pageTotal']!=0)?(($this->gridPaging['recStart']/$this->gridPaging['recsLimit']) + 1):0;
    $this->gridPaging['recPrev'] = $this->gridPaging['recStart'] - $this->gridPaging['recsLimit'];
    $this->gridPaging['recNext'] = $this->gridPaging['recStart'] + $this->gridPaging['recsLimit'];
    $this->gridPaging['recLast'] = $this->gridPaging['recsLimit']*$this->gridPaging['pageTotal']-$this->gridPaging['recsLimit'];
    $this->hPager->init($this->gridAssumedRows,$this->gridPaging['pageCurrent'],$this->gridPaging['recsLimit'],7);
  }

  function _compileOrderStr() {
    if(isset($this->gridSortCol['name'])) {
    	$orderBy = '&'.$this->cntId.'Srt='.$this->gridSortCol['name'].'&'.$this->cntId.'SrtO='.$this->gridSortCol['sort'];
    }else {
    	$orderBy = '';
    }
    return $orderBy;  	
  }
  
  function _compileSearchStr() {
		return  (isset($this->gridSearchCol['term'])?'&'.$this->cntId.'srchTerm='.$this->gridSearchCol['term']:'').(isset($this->gridSearchCol['type'])?'&'.$this->cntId.'srchType='.$this->gridSearchCol['type']:'');
	}

  function _compileRecLim() {
		if(isset($this->gridLimitValue)) {
			return '&'.$this->cntId.'recLim='.$this->gridLimitValue;
		}else {
			return '';
		}
  }
  
  function _compilePagingNav() {
  	$out = '';
    $this->_compilePagingVars();
    
    $orderBy = $this->_compileOrderStr();
    $orderBy .= $this->_compileRecLim();
    $orderBy .= $this->_compileSearchStr();

    $this->gridLinksBottom = getPageLinks($this->hPager,$this->cntGlobals['PHP_SELF'].'?'.$this->cntQueStr.$orderBy.'&'.$this->cntId.'recStart=',$this->gridPaging['pageCurrent']);

    //first page
    $out .= 
      ($this->gridPaging['pageCurrent']==1||$this->gridPaging['pageCurrent']==0)
      ?'<img src="'.$this->cntGlobals['DIR_IMG'].'bFirstInactive.gif" border="0" alt="First Page" title="First '.$this->gridPaging['recsLimit'].' records"/>'
      :'<a href="'.$this->cntGlobals['PHP_SELF'].'?'.$this->cntQueStr.'&'.$this->cntId.'recStart=0'.$orderBy.'"><img src="'.$this->cntGlobals['DIR_IMG'].'bFirstActive.gif" border="0" alt="First Page" title="First '.$this->gridPaging['recsLimit'].' records"/></a>';
    
    //previous page
    $out .= 
      ($this->gridPaging['pageCurrent']==1||$this->gridPaging['pageCurrent']==0)
      ?'<img src="'.$this->cntGlobals['DIR_IMG'].'bPrevInactive.gif" border="0" alt="Previous Page" title="Previous '.$this->gridPaging['recsLimit'].' records"/>'
      :'<a href="'.$this->cntGlobals['PHP_SELF'].'?'.$this->cntQueStr.'&'.$this->cntId.'recStart='.$this->gridPaging['recPrev'].$orderBy.'"><img src="'.$this->cntGlobals['DIR_IMG'].'bPrevActive.gif" border="0" alt="Previous Page" title="Previous '.$this->gridPaging['recsLimit'].' records"/></a>';

      //next page
      $out .= 
        ($this->gridPaging['pageCurrent']==$this->gridPaging['pageTotal'])
        ?'<img src="'.$this->cntGlobals['DIR_IMG'].'bNextInactive.gif" border="0" alt="Next Page" title="Next '.$this->gridPaging['recsLimit'].' records"/>'
        :'<a href="'.$this->cntGlobals['PHP_SELF'].'?'.$this->cntQueStr.'&'.$this->cntId.'recStart='.$this->gridPaging['recNext'].$orderBy.'"><img src="'.$this->cntGlobals['DIR_IMG'].'bNextActive.gif" border="0" alt="Next Page" title="Next '.$this->gridPaging['recsLimit'].' records"/></a>';
      //last page
      $out .= 
        ($this->gridPaging['pageCurrent']==$this->gridPaging['pageTotal'])
        ?'<img src="'.$this->cntGlobals['DIR_IMG'].'bLastInactive.gif" border="0" alt="Last Page" title="Last '.$this->gridPaging['recsLimit'].' records"/>'
        :'<a href="'.$this->cntGlobals['PHP_SELF'].'?'.$this->cntQueStr.'&'.$this->cntId.'recStart='.$this->gridPaging['recLast'].$orderBy.'"><img src="'.$this->cntGlobals['DIR_IMG'].'bLastActive.gif" border="0" alt="Last Page" title="Last '.$this->gridPaging['recsLimit'].' records"/></a>';

    return $out;
  }


}

//file: blibDbGrid.class.php
/**
* Grid generation control
*/
class blibDbGrid extends blibGrid{
  var $hSql;  //pointer to database manipulation object
  var $queRaw;
  var $queLim;
  var $queOrd;
  
  function init(&$inSql, $inName) {
  	parent::init($inName);
    //never data incoming out of db come in unfiltered fashion
    $this->gridAllowSlice = false;
    $this->hSql = &$inSql;
  }

  function setData($inQue) {
    $this->queRaw = $inQue;
  }

  function _prepareData($inQue) {
    if(!preg_match("/(from).*/si",$inQue,$_match)) {
      $this->gridAssumedRows = 0;
      $this->gridData = array();
      return -1;
    }
    $this->gridAssumedRows = $this->hSql->getVar('SELECT COUNT(*) '.$_match[0]);


    $this->_processQueStr();
    $this->_compilePagingVars();
    
    if(isset($this->gridSortCol['name'])) {
      $inQue .= ' ORDER BY '.$this->gridSortCol['name'].' ';	
      $inQue .= $this->gridSortCol['sort']==3?'DESC':'ASC';	

    }
    $inQue .= ' LIMIT '.$this->hPager->getLimit();
    $this->gridData = $this->hSql->getRows($inQue);
  }

	function _prepareQue($inQue, $withOrd = true, $withLimit = true) {
    if(!preg_match("/(from).*/si",$inQue,$_match)) {
      $this->gridAssumedRows = 0;
      $this->gridData = array();
      return -1;
    }
    $this->gridAssumedRows = $this->hSql->getVar('SELECT COUNT(*) '.$_match[0]);


    $this->_processQueStr();
    $this->_compilePagingVars();
    if($withOrd) {
			if(isset($this->gridSortCol['name'])) {
				$inQue .= ' ORDER BY '.$this->gridSortCol['name'].' ';	
				$inQue .= $this->gridSortCol['sort']==3?'DESC':'ASC';	
			}
    	
    }
		if($withLimit) {
	    $inQue .= ' LIMIT '.$this->hPager->getLimit();
		}
    return $inQue;
  }
	
	function _getCheckedItems() {
		if(isset($_POST['g']['checks'])&&is_array($_POST['g']['checks'])) {
			$rows = $this->hSql->getRows($this->_prepareQue($this->queRaw));
			$rows_d = array();
			foreach($_POST['g']['checks'] as $key=>$val) {
				if($rows) {
					$rows_d = array_merge($rows_d,array_slice($rows,$key-1,1));
				}
			}
			foreach($rows_d as $key=>$val) {
				$rows_d[$key] = $val['id'];
			}
			return $rows_d;
		}else {
			return array();
		}
	}
  function _make() {
  	$this->_prepareData($this->queRaw);
    parent::_make();
  }
  
  function sortCol($inCol, $inSortOrder = SORT_ASC) {
    $this->gridSortCol = array('name'=>$inCol, 'sort'=>$inSortOrder);
  }


}

//file: blibFForm.class.php
class blibFForm extends blibControl {
  var $hTpl;                   //pointer to templating engine    
  var $hCont;									 //base form container    
  var $hEConts = array();      //elements containers
  var $hEls = array();
  var $frmHeight = '';         //dims/height
	var $frmWidth = '100%';      //dims/width
  var $frmData = array();      
  var $frmPars = array();  
  var $frmName;
  var $frmCaption = '';
  var $frmMethod = 'POST';
  var $frmEnctype = '';
  var $frmAction;
  var $frmButton;
  var $frmVarsPreserved = array();
  var $frmError = 'Please, correct errors and resubmit the form.';
  var $frmDataSource = array();
  var $frmFileDataSource = array();
  var $frmEWrapper = 'TopTitle';
  var $frmSteps = array();
  var $frmStep = 1;
  var $frmStepHalt = 0;
  var $frmValid = true;
  var $frmFinished = 0;
  
  function init($inName = '') {
    //frmrol setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'frm';
    $this->cntCssFile = $this->cntBaseUrl.'blibFForm/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFForm/blibFForm.tpl.php';
    
    $this->hCont = new blibContainer();
    $this->hCont->init();
    $this->hCont->setType('Blank');
    
    $this->addStep();

    if(count($this->cntGlobals)==0) {
    	$this->_processGlobals();
    }

	}

  function addPage() {
		$this->addStep();
	}

	function newPage() {
		$this->addStep();
	}

  function addStep() {
  	$this->frmSteps[] = array();
  }

  function &addContainer($inCaption = '', $inDesc = '', $inType = '', $inExtra = '') {
  	$this->hEConts[] = new blibContainer();
    $cnt = &$this->hEConts[count($this->hEConts)-1];
    $cnt->init();
    $cnt->setExtra($this->frmName, $inExtra);
    $cnt->setType($inType);
    $cnt->setCaptions($inCaption, $inDesc);
    $this->frmSteps[count($this->frmSteps)-1][] = count($this->hEConts)-1;
    $x = &$this->hEConts[count($this->hEConts)-1];
    return $x;
  }
  
  function getValues() {
  	$out = array();
    for($i=0,$m=count($this->hEls); $i<$m; $i++) {
  		$out[$this->hEls[$i]['name']] = $this->hEls[$i]['obj']->getValue(); 
  	}
    return $out;
  }
  function getValue($inName) {
    for($i=0,$m=count($this->hEls); $i<$m; $i++) {
  		if($this->hEls[$i]['name']==$inName) {
  		  return $this->hEls[$i]['obj']->getValue(); 	
  		}
  	}
    return '';
  }

  /*
  * Shortcut funcs
  */
  //file
  function &addFE($inField, $inCaption, $inDest = '', $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '', $inExtra = array()) {
    $this->frmEnctype = 1;
    if($this->frmMethod!='POST') {
      $this->frmMethod = 'POST';
      $this->_initData();
    }
    $inExtra['Dest'] = $inDest;
    return $this->addElement('file', $inField, $inCaption, '' , $inRequired , $inComment , $inError , $inRegex , $inExtraTxt , $inExtra );	
  }
  //TextField
  function &addTF($inField, $inCaption, $inValue = '', $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '', $inExtra = array()) {
    return $this->addElement('textbox', $inField, $inCaption, $inValue , $inRequired , $inComment , $inError , $inRegex , $inExtraTxt , $inExtra );	
  }
  //check box
  function addCE($inField, $inCaption, $inValue = '', $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '', $inExtra = array()) {
    $this->addElement('checkbox', $inField, $inCaption, $inValue , $inRequired , $inComment , $inError , $inRegex , $inExtraTxt , $inExtra );	
  }
  //datepicker
  function addDP($inField, $inCaption, $inValue = '', $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '', $inExtra = array()) {
    $inExtra['Visibility'] = count($this->frmSteps);
    $this->addElement('dpicker', $inField, $inCaption, $inValue , $inRequired , $inComment , $inError , $inRegex , $inExtraTxt , $inExtra );	
  }
  //popdatepicker
  function addPDP($inField, $inCaption, $inValue = '', $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '', $inExtra = array()) {
    $this->addElement('pdpicker', $inField, $inCaption, $inValue , $inRequired , $inComment , $inError , $inRegex , $inExtraTxt , $inExtra );	
  }
  //password
  function &addPE($inField, $inCaption, $inValue = '', $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '', $inExtra = array()) {
    return $this->addElement('pass', $inField, $inCaption, $inValue , $inRequired , $inComment , $inError , $inRegex , $inExtraTxt , $inExtra );	
  }
  //hidden
  function addHE($inField, $inValue = '',$inExtraTxt = '') {
    $this->addElement('hidden', $inField, '', $inValue , '', '', '', '', $inExtraTxt);	
  }
  //combo box
  function &addCB($inField, $inCaption, $inOpts = array(),$inValue = array(), $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '', $inExtra = array()) {
  	$inExtra['Options'] = $inOpts;
    $obj = &$this->addElement('combo', $inField, $inCaption, $inValue , $inRequired , $inComment , $inError , $inRegex , $inExtraTxt , $inExtra );	
		return $obj;
  }
  //radio buttons
  function &addRB($inField, $inOpts = array(),$inValue = 0, $inComment = '', $inError = '', $inExtraTxt = '', $inExtra = array()) {
    $inExtra['Options'] = $inOpts;
    $obj = &$this->addElement('radio', $inField, '', $inValue , true , $inComment , $inError ,'', $inExtraTxt , $inExtra );	
		return $obj;
  }
  //submit buttons
  function &addSB($inField, $inCaption, $inButtonType = 'submit', $inButtonId = 'btn',$inExtraTxt = 'style=""', $inExtra = array()) {
		$w = $this->frmEWrapper;
		$this->changeWrapper('Empty');
		$inExtra['ButtonType'] = $inButtonType;
		$inExtra['ButtonId'] = $inButtonId;
		$obj = &$this->addElement('button', $inField, $inCaption, '' , '' , '' , '' , '' , $inExtraTxt , $inExtra );	  
		$this->frmEWrapper = $w;
		return $obj;
	}
  //textarea
  function &addTA($inField, $inCaption = '', $inValue = '', $inCharsLimit=0, $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '') {
    $inExtra['CharsLimit'] = $inCharsLimit;
    return $this->addElement('textarea', $inField, $inCaption, $inValue , $inRequired , $inComment , $inError , $inRegex , $inExtraTxt , $inExtra );	
  }
  //text
  function &addTE($inValue,$inExtraTxt='') {
		$w = $this->frmEWrapper;
		$this->changeWrapper();
    $obj = &$this->addElement('text', '', '', $inValue,1,'','','',$inExtraTxt);	
		$this->frmEWrapper = $w;
		return $obj;
  }

  function &addElement($inType, $inField, $inCaption, $inValue = '', $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '', $inExtra = array()) {
    $obj = null;
    switch($inType) {
      case 'button':
        $obj = new blibFSubmitButton();
      break;
      case 'file':
        $obj = new blibFFile();
      break;
      case 'checkbox':
        $obj = new blibFCheckBox();
      break;
      case 'hidden':
        $obj = new blibFHidden();
      break;
      case 'dpicker':
        $obj = new blibFDatePicker();
      break;
      case 'pdpicker':
        $obj = new blibFPopDatePicker();
      break;
      case 'pass':
      case 'password':
        $obj = new blibFPassword();
      break;
    	case 'textbox':
    	case 'textfield':
        $obj = new blibFTextField();
      break;
    	case 'textarea':
        $obj = new blibFTextArea();
      break;
    	case 'text':
        $obj = new blibFText();
      break;
      case 'text':
        $obj = new blibFTextField();
      break;
      case 'select':
      case 'combo':
        $obj = new blibFSelect();
      break;
      case 'radio':
        $obj = new blibFRadio();
      break;
    }
    if($obj!=null) {
      $inExtraTxt = ($inExtraTxt!='')?$inExtraTxt:'style="width:100%;"';
      $obj->init();
      $obj->setWrapper($this->frmEWrapper);
      $obj->hWrapper->setCssClasses( (($inRequired)?'blibWrapHeadRequired':'blibWrapHead') );
      $obj->cntCaption = $inCaption;
      $obj->cntDesc = $inComment;
      $obj->elForm = $this->frmName;
      $obj->setup($inField, $inCaption, $inValue, $inRequired , $inComment , $inError , $inRegex , $inExtraTxt, $inExtra);
      $this->hEls[] = $this->hEConts[count($this->hEConts)-1]->addItem($inField,$obj);    	
			return $this->hEls[count($this->hEls)-1];
    }else {
    	return $obj;
    }
  }

  function changeWrapper($inWrapper = 'TopTitle') {
  	$this->frmEWrapper = $inWrapper;
  }

  
  function setup($inName, $inCaption, $inAction, $inMethod = 'POST',$inButton = '',$inComment='') {
  	$this->frmName = $inName;
    $this->frmCaption = $inCaption;
    if($inAction=='') {
    	$this->frmAction = $this->cntGlobals['PHP_SELF'].((isset($_SERVER['QUERY_STRING']))?'?'.$_SERVER['QUERY_STRING']:'');
    }else {
      $this->frmAction = $inAction;	
    }
    $this->frmMethod = $inMethod;
    $this->frmButton = $inButton;
    $this->hCont->setCaptions($inCaption,$inComment);
    $this->hCont->addItem('frm',$this);
    $this->_initData();
  }

  function setPars($inArr) {
  	foreach($inArr as $key=>$val) {
  		$this->frmPars['P_'.$key] = $val;
  	}
  }

  function addItem($inField, &$inObj) {
    $this->frmData[] = array('name'=>$inField, 'obj'=>&$inObj);
  }
  
  function clearItems() {
    $this->frmData = array();
  }

  function setDims($inW,$inH=0) {
  	$this->frmWidth = $inW;
    $this->frmHeight = ($inH)?$inH:$this->frmHeight;
    $this->hCont->setDims($inW,$inH);
  }

  function formDisplay() {
  	echo $this->formFetch();
  }

  function formFetch() {
    return $this->hCont->fetch();
  }
  
  function validate() {
    if(!$this->frmValid) {
    	return false;
    }
    $this->frmValid = true;
    if(!isset($this->frmSteps[$this->frmStep-1])) {
    	$this->frmValid = false;
      return false;
    }
    if(($this->frmDataSource[$this->frmName.'ST']<>$this->frmStep)) {
    	return true;
    }
    $curStepConts = $this->frmSteps[$this->frmStep-1];
    foreach($curStepConts as $contInd) {
    	$cont = &$this->hEConts[$contInd];
      foreach($cont->getItems() as $objData) {
        $objData['obj']->elName;
        $objData['obj']->cntError = '';
      	$objData['obj']->validate();
        if($objData['obj']->cntError) {
          $this->frmValid = false;
        }
      }
    }
    $this->frmError = ($this->frmValid)?'':'Please, correct errors and resubmit the form.';
    $this->hCont->cntGlobals['CONT_CAP_BOTTOM'] = '<span class=\'blibFFormError\'>'.$this->frmError.'</span>';
    return $this->frmValid;
  }

  function setFormError($inError, $inDisp = false) {
    $this->frmValid = false;
    $this->frmError = $inError;
    $this->hCont->setCaptions($this->hCont->contCaptionTop,'<span class=\'blibFFormError\'>'.$this->frmError.'</span>');
    if($inDisp) {
      $this->formDisplay();
    }
  }

  function isFinished() {
  	$this->_make();
    return (bool)$this->frmFinished;
  }
  
	function getStep() {
		$tmp = $this->frmStepHalt;
		$this->frmStepHalt = $this->frmStep;
		$this->_make();
		$this->frmStepHalt = $tmp;
		return $this->frmStep;
	}

  function _initData() {
    if(isset($_SERVER['REQUEST_METHOD'])&&$this->frmMethod==$_SERVER['REQUEST_METHOD']) {
      switch($this->frmMethod) {
        case 'POST':
          $this->frmDataSource = &$GLOBALS['HTTP_POST_VARS'];
          $this->frmFileDataSource = &$GLOBALS['HTTP_POST_FILES'];
        break;
        case 'GET':
          $this->frmDataSource = &$GLOBALS['HTTP_GET_VARS'];
        break;
      }
    }  	
    if(isset($this->frmDataSource[$this->frmName.'ST'])) {
    	$this->frmStep = $this->frmDataSource[$this->frmName.'ST'];
    }else {
    	$this->frmStep = 1;
    }
  }

  function _restoreVars() {
    foreach($this->hEls as $objData) {
      if($this->isInstanceOf($objData['obj'],'blibFFile')) {
        if(isset($this->frmFileDataSource[$objData['obj']->elName])) {
          $objData['obj']->setValue($this->frmFileDataSource[$objData['obj']->elName]);
        }
      }elseif($this->isInstanceOf($objData['obj'],'blibFCheckBox')) {
        if(isset($this->frmDataSource[$objData['obj']->elName])) {
					$objData['obj']->setValue($this->frmDataSource[$objData['obj']->elName]);
        }else {
					if(count($this->frmDataSource)) {
	          $objData['obj']->setValue(0);
					}
        }
      }else {
        if(isset($this->frmDataSource[$objData['obj']->elName])) {
          $objData['obj']->setValue($this->frmDataSource[$objData['obj']->elName]);
        }
      }
    }
  }

  function _preserveVars() {
    $pres = array();
    foreach($this->hEls as $objData) {
      $pres[] = array('name'=>$this->frmName.$objData['obj']->elName,'val'=>$objData['obj']->getValue());
    }
    return $pres;  	
  }



  function _make() {
    $content = '';
		$this->_restoreVars();
    $pres = $this->_preserveVars();
    if(isset($this->frmDataSource[$this->frmName.'SI'])) {//form was submitted
		  if($this->validate()) {
				if(count($this->frmSteps)>$this->frmStep) {
        	if(isset($this->frmDataSource[$this->frmName.'STP'])&&$this->frmDataSource[$this->frmName.'STP']==1) {
        		//preserve current step..move back is performed
        	}else {
						if($this->frmStepHalt) {
							$this->frmStep = $this->frmStepHalt;
						}else {
							$this->frmStep = $this->frmDataSource[$this->frmName.'ST'] + 1;	
						}
						
        	}
          
        }else {
          $this->frmFinished = 1;        	
        }
      }	
    }else {
    	$this->frmStep = 1;
    }
    
    foreach($this->frmSteps as $step=>$conts) {
      $content .= '<div style="" class="'.(($step+1==$this->frmStep)?'show':'hide').'">';
    	foreach($conts as $contInd) {
    		if(isset($this->hEConts[$contInd])) {
    			$content .= $this->hEConts[$contInd]->fetch();
    		}
    	}
      $content .= '</div>';	
    }
    

    $this->_processGlobals();

    $fEls = array();
    $fEls['name'] = $this->frmName;
    $fEls['caption'] = $this->frmCaption;
    $fEls['method'] = $this->frmMethod;
    $fEls['enctype'] = $this->frmEnctype;
    $fEls['action'] = $this->frmAction;
    $fEls['steps'] = count($this->frmSteps);
    $fEls['step'] = $this->frmStep;
    $fEls['button'] = $this->frmButton;
    $fEls['finished'] = $this->frmFinished;
		$fEls['GET_STP'] = array(
					'SI'=>(isset($this->frmDataSource[$this->frmName.'SI'])?$this->frmDataSource[$this->frmName.'SI']:1),
					'ST'=>(isset($this->frmDataSource[$this->frmName.'ST'])?$this->frmDataSource[$this->frmName.'ST']:1),
					'STP'=>(isset($this->frmDataSource[$this->frmName.'STP'])?$this->frmDataSource[$this->frmName.'STP']:0)
		);
    foreach($this->hEls as $objData) {
      if($this->isInstanceOf($objData['obj'],'blibFDatePicker')) {
    		$objData['obj']->elVisibility = ($objData['obj']->elVisibility==$this->frmStep)?1:0;
    	}
    }
    
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('F',$fEls);
    //$this->hTpl->assign('M_pres',$pres);
    $this->hTpl->assign('CONTENT',$content);
    $this->cntOut = $this->hTpl->fetch($this->cntTplFile);
    
  }
  
  function _processGlobals() {
    $this->cntGlobals = array();
    parent::_processGlobals();
    $this->cntGlobals['DIR_IMG'] = $this->cntBaseUrl.'/blibFForm/images/';
    $this->cntGlobals['FRM_WIDTH'] = $this->frmWidth;
    if($this->frmHeight) {
      $this->cntGlobals['FRM_HEIGHT'] = $this->frmHeight;	
    }
    foreach($this->frmPars as $key=>$val) {
    	$this->cntGlobals[$key] = $val;
    }
  }
}

//file: blibContainer.class.php
class blibContainer extends blibControl {
  var $hTpl;                    //pointer to templating engine    
  var $contFrm = '';         
  var $contExtra = '';         
  var $contHeight = '';         //dims/height
	var $contWidth = '100%';      //dims/width
  var $contCaptionTop = '';
  var $contCaptionBottom = '';
  var $contData = array();      
  var $contPars = array();      
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'cont';
    $this->cntCssFile = $this->cntBaseUrl.'blibContainer/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibContainer/blibContainer.tpl.php';
    $this->setType();
	}

  function setCaptions($inCapTop, $inCapBot = '') {
  	$this->contCaptionTop = $inCapTop;
  	$this->contCaptionBottom = $inCapBot;
  }
  
  function setType($inType = '') {
  	switch($inType) {
  		case 'SubGrid':
        $this->cntTplFile = '/blibContainer/blibContainerSubGrid.tpl.php';
      break;
  		case 'Grid':
        $this->cntTplFile = '/blibContainer/blibContainerGrid.tpl.php';
      break;
  		case 'Row':
        $this->cntTplFile = '/blibContainer/blibContainerRow.tpl.php';
      break;
  		case 'Invi':
        $this->cntTplFile = '/blibContainer/blibContainerInvi.tpl.php';
      break;
  		case 'Blank':
        $this->cntTplFile = '/blibContainer/blibContainerBlank.tpl.php';
      break;
  		case 'Buttoner':
        $this->cntTplFile = '/blibContainer/blibContainerButtoner.tpl.php';
      break;
  		case 'Box':
        $this->cntTplFile = '/blibContainer/blibContainerBox.tpl.php';
      break;
  		case 'Dived':
        $this->cntTplFile = '/blibContainer/blibContainerDived.tpl.php';
      break;
      default:
        $this->cntTplFile = '/blibContainer/blibContainer.tpl.php';
      break;
  	}
  }
  
  function setPars($inArr) {
  	foreach($inArr as $key=>$val) {
  		$this->contPars['P_'.$key] = $val;
  	}
  }

  /*
  * Adds single item
  */
  function &addItem($inField, &$inObj) {
    $this->contData[] = array('name'=>$inField, 'obj'=>&$inObj);
		return $this->contData[count($this->contData)-1];
  }
  
  /*
  * Clears all items
  */
  function clearItems() {
    $this->contData = array();
  }

  function getItems() {
  	return $this->contData;
  }

  function setDims($inW,$inH=0) {
  	$this->contWidth = $inW;
    $this->contHeight = ($inH)?$inH:$this->contHeight;
  }

  function setExtra($inFrm, $inExtra) {
  	$this->contFrm = $inFrm;
  	$this->contExtra = $inExtra;
  }

  function _make() {
    $this->_processGlobals();
    $items = array();
    foreach($this->contData as $itm) {
      $items[] = array('name'=>$itm['name'],'val'=>$itm['obj']->fetch());
    }


    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }
    $this->hTpl->assign('M_items',$items);
    $this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  }

  function _processGlobals() {
    $this->cntGlobals = array();
    parent::_processGlobals();
    $this->cntGlobals['DIR_IMG'] = $this->cntBaseUrl.'/blibContainer/images/';
    $this->cntGlobals['CONT_UNIQUE'] = md5 (uniqid (rand()));
    $this->cntGlobals['CONT_FRM'] = $this->contFrm;
    $this->cntGlobals['CONT_EXTRA'] = $this->contExtra;
    $this->cntGlobals['CONT_WIDTH'] = $this->contWidth;
    if($this->contHeight) {
      $this->cntGlobals['CONT_HEIGHT'] = $this->contHeight;	
    }
    $this->cntGlobals['CONT_CAP_TOP'] = $this->contCaptionTop;
    $this->cntGlobals['CONT_CAP_BOTTOM'] = $this->contCaptionBottom;
    foreach($this->contPars as $key=>$val) {
    	$this->cntGlobals[$key] = $val;
    }
  }
}

//file: blibFElement.class.php
class blibFElement extends blibControl {
  var $hTpl;                    //pointer to templating engine    
  var $elForm = '';
  var $elName = '';
  var $elCaption = '';
  var $elValue = '';      
  var $elValueParsed = '';      
  var $elComment = '';
  var $elRequired = false;
  var $elError = '';
  var $elCssClass = 'blibFElement';
  var $elRegex = '';          //regular expression to validate the value
  var $elExtra = '';
  var $elPars = array();     
  
  /*
  * Prepares control functioning
  */
  function setup($inField, $inCaption, $inValue, $inRequired = false, $inComment = '', $inError = '', $inRegex = '', $inExtraTxt = '', $inExtra = array()) {
    $this->elName = $inField;
    $this->elCaption = $inCaption;
    $this->elValue = $inValue;
    $this->elRequired = $inRequired;
    $this->elError = $inError;
    $this->elComment = $inComment;
    $this->elRegex = $inRegex;
    $this->elExtra = $inExtraTxt;
    foreach($inExtra as $key=>$val) {
      $key = 'el'.$key;
      if(array_key_exists($key,get_class_vars(get_class($this)))===true) {
      	$this->$key = $val;
      }
    }
	}
  
  function setPars($inArr) {
  	foreach($inArr as $key=>$val) {
  		$this->elPars['P_'.$key] = $val;
  	}
  }

  function setValue($inVal) {
    $this->_errorAbstract('setValue');
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue() {
  	$this->_errorAbstract('_processValue');
  }
  
  function validate() {
  	$this->_errorAbstract('validate');
  }
  
  function _make() {
    $fEls = array();
    
    $fEls['form'] = $this->elForm;
    $fEls['name'] = $this->elName;
    $fEls['caption'] = $this->elCaption;
    $fEls['required'] = $this->elRequired;
    $fEls['comment'] = $this->elComment;
    $fEls['error'] = $this->elError;
    $fEls['regex'] = $this->elRegex;
    $fEls['extra'] = $this->elExtra;
    $fEls['value'] = $this->elValueParsed;

  	
    return $fEls;
  }

  function _processGlobals() {
    $this->cntGlobals = array();
    parent::_processGlobals();
    $this->cntGlobals['DIR_IMG'] = $this->cntBaseUrl.'/blibFElement/images/';
    foreach($this->elPars as $key=>$val) {
    	$this->cntGlobals[$key] = $val;
    }
  }
}

//file: blibFTextField.class.php
class blibFTextField extends blibFElement {
  var $elSize = '';
  var $elReadonly = 0;
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFTextField/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFTextField/blibFTextField.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = $this->_processValue($this->elValue = $inVal);
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue($inValue) {
    return stripslashes(trim($inValue));
  }
  
  function validate() {
  	if($this->elRequired&&$this->elValue=='') {
  		$this->cntError = 'Field is required.';
      return false;
  	}else {
  		return true;
  	}
  }
  
  function _make() {
    $this->elValueParsed = $this->setValue($this->elValue);
    $fEls = parent::_make();
    $fEls['size'] = $this->elSize;
    $fEls['readonly'] = $this->elReadonly;
    
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibWrapper.class.php
class blibWrapper extends blibControl {
  var $hTpl;                    //pointer to templating engine    
  var $wrapHeight = '';         //dims/height
	var $wrapWidth = '0';      //dims/width
  var $wrapData = array();      
  var $wrapPars = array();    
  var $wrapCaptionTop = '';
  var $wrapCaptionBottom = '';
  var $wrapCaptionBottomError = '';
  var $wrapCssClasses = array('HEAD'=>'blibWrapHead','DATA'=>'blibWrapData','FOOT'=>'blibWrapFoot','FOOT_E'=>'blibWrapFootError');

  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'wrap';
    $this->cntCssFile = $this->cntBaseUrl.'blibWrapper/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibWrapper/blibWrapper.tpl.php';
    $this->setType();
	}

  function setCaptions($inCapTop, $inCapBot = '', $inCapBotE='') {
  	$this->wrapCaptionTop = $inCapTop;
  	$this->wrapCaptionBottom = $inCapBot;
  	$this->wrapCaptionBottomError = $inCapBotE;
  }

  function setCssClasses($inTop = 'blibWrapHead', $inData = 'blibWrapData', $inBot = 'blibWrapFoot', $inBotE = 'blibWrapFootError') {
    $this->wrapCssClasses = array('HEAD'=>$inTop,'DATA'=>$inData,'FOOT'=>$inBot,'FOOT_E'=>$inBotE);
  }

  function setType($inType = '') {
  	switch(strtolower($inType)) {
      case 'lefttitle':
        $this->cntTplFile = '/blibWrapper/blibWrapperLeft.tpl.php';
      break;
      case 'righttitle':
        $this->cntTplFile = '/blibWrapper/blibWrapperRight.tpl.php';
      break;
      case 'blank':
        $this->cntTplFile = '/blibWrapper/blibWrapperBlank.tpl.php';
      break;
      case 'empty':
        $this->cntTplFile = '/blibWrapper/blibWrapperEmpty.tpl.php';
      break;
      default:
        $this->cntTplFile = '/blibWrapper/blibWrapper.tpl.php';
      break;
  	}
  }
  
  function setPars($inArr) {
  	foreach($inArr as $key=>$val) {
  		$this->wrapPars['P_'.$key] = $val;
  	}
  }

  /*
  * Adds single item
  */
  function addContent(&$inCont, $inOverWrite = false) {
    if($inOverWrite) {
      $this->wrapData = array();	
    }
    $this->wrapData[] = $inCont;
  }
  
  function setDims($inW,$inH=0) {
  	$this->wrapWidth = $inW;
    $this->wrapHeight = ($inH)?$inH:$this->wrapHeight;
  }

  function _make() {
    $this->_processGlobals();
    
    $content = implode('',$this->wrapData);
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('CONTENT',$content);
    $this->hTpl->assign('C',$this->wrapCssClasses);
    $this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  }

  function _processGlobals() {
    $this->cntGlobals = array();
    parent::_processGlobals();
    $this->cntGlobals['DIR_IMG'] = $this->cntBaseUrl.'/blibWrapper/images/';
    $this->cntGlobals['WRAP_WIDTH'] = $this->wrapWidth;
    if($this->wrapHeight) {
      $this->cntGlobals['WRAP_HEIGHT'] = $this->wrapHeight;	
    }
    $this->cntGlobals['WRAP_CAP_TOP'] = $this->wrapCaptionTop;
    $this->cntGlobals['WRAP_CAP_BOTTOM'] = $this->wrapCaptionBottom;
    $this->cntGlobals['WRAP_CAP_BOTTOM_ERROR'] = $this->wrapCaptionBottomError;
    foreach($this->wrapPars as $key=>$val) {
    	$this->cntGlobals[$key] = $val;
    }
  }
}

//file: blibFTextArea.class.php
class blibFTextArea extends blibFElement {
  var $elCharsLimit = 0;
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFTextArea/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFTextArea/blibFTextArea.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = $this->_processValue($this->elValue = $inVal);
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue($inValue) {
    return stripslashes(trim($inValue));
  }
  
  function validate() {
  	if($this->elRequired&&$this->elValue=='') {
  		$this->cntError = 'Field is required.';
      return false;
  	}else {
  		return true;
  	}
  }
  
  function _make() {
    $this->elValueParsed = $this->setValue($this->elValue);
    $fEls = parent::_make();
    $fEls['maxLen'] = (int)$this->elCharsLimit;
    
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibFHidden.class.php
class blibFHidden extends blibFElement {
  var $elSize;
  var $elPreserve = 1;
  var $elReadonly = 0;
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFHidden/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFHidden/blibFHidden.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = $this->_processValue($this->elValue = $inVal);
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue($inValue) {
    return stripslashes(trim($inValue));
  }
  
  function validate() {
    return true;
  }
  
  function _make() {
    $this->elValueParsed = $this->setValue($this->elValue);
    $fEls = parent::_make();
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibFSelect.class.php
class blibFSelect extends blibFElement {
  var $elSize = '';
  var $elMultiple = 0;
  var $elOptions = array();
  var $elSelectExact;
  var $elSelectMin;
  var $elSelectMax;
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFSelect/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFSelect/blibFSelect.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = $this->_processValue($this->elValue = $inVal);
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue($inValue) {
    return $inValue;
  }
  
  function validate() {
  	if($this->elRequired&&count($this->getValue())==0) {
  		$this->cntError = 'Field is required.';
      return false;
  	}else {
  		return true;
  	}
  }
  
  function _make() {
    $opts = array();
    $this->elValueParsed = $this->_processValue($this->setValue($this->elValue));
    $fEls = parent::_make();
    $fEls['size'] = $this->elSize;
    $fEls['multiple'] = $this->elMultiple;
    foreach($this->elOptions as $key=>$val) {
    	$opts[] = array('val'=>$val,'key'=>$key, 'selected'=>in_array($key,$this->getValue()));
    }

    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('M_opts', $opts);
    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibFSubmitButton.class.php
class blibFSubmitButton extends blibFElement {
  var $elSize = '';
  var $elReadonly = 0;
  var $elButtonType = 'submit';
  var $elButtonId = 'btn_ok';

  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFSubmitButton/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFSubmitButton/blibFSubmitButton.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = stripslashes(trim($this->elValue));
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue() {
  	$this->_errorAbstract('_processValue');
  }
  
  function validate() {
  	return true;
  }
  
  function _make() {
    $this->elValueParsed = htmlspecialchars($this->setValue($this->elValue));
    $fEls = parent::_make();
    $fEls['size'] = $this->elSize;
    $fEls['readonly'] = $this->elReadonly;
    $fEls['button_type'] = $this->elButtonType;
    $fEls['button_id'] = $this->elButtonId;
    
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibFText.class.php
class blibFText extends blibFElement {
 
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFText/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFText/blibFText.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = $this->_processValue($this->elValue = $inVal);
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue($inValue) {
    return stripslashes(trim($inValue));
  }
  
  function validate() {
    return true;
  }
  
  function _make() {
    $this->elValueParsed = $this->setValue($this->elValue);
    $fEls = parent::_make();
    
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibFRadio.class.php
class blibFRadio extends blibFElement {
  var $elOptions = array();
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFRadio/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFRadio/blibFRadio.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = $this->_processValue($this->elValue = $inVal);
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue($inValue) {
    return $inValue;
  }
  
  function validate() {
  	if($this->elRequired&&count($this->getValue())==0) {
  		$this->cntError = 'Field is required.';
      return false;
  	}else {
  		return true;
  	}
  }
  
  function _make() {
    $opts = array();
    $this->elValueParsed = $this->_processValue($this->setValue($this->elValue));
    $fEls = parent::_make();
    foreach($this->elOptions as $key=>$val) {
    	$opts[] = array('val'=>$val,'key'=>$key, 'selected'=>($key==$this->getValue()));
    }

    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('M_opts', $opts);
    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibFCheckBox.class.php
class blibFCheckBox extends blibFElement {
  var $elChecked = 0;
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFCheckBox/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFCheckBox/blibFCheckBox.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = $this->_processValue($this->elValue = $inVal);
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue($inValue) {
    return stripslashes(trim($inValue));
  }
  
  function validate() {
		if($this->elRequired&&$this->elValue=='') {
  		$this->cntError = 'Field is required.';
			return false;
  	}else {
  		return true;
  	}
  }
  
  function _make() {
    $this->elValueParsed = htmlspecialchars($this->setValue($this->elValue));
    $fEls = parent::_make();
    $fEls['checked'] = $this->elChecked;
    
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibFFile.class.php
class blibFFile extends blibFElement {
  var $elSize;
  var $elMaxSize = 10048576;
  var $elContTypes = array('Zip Files (*.zip)'=>'application/x-zip-compressed');
  var $elDest = '';
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFFile/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFFile/blibFFile.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = $this->_processValue($this->elValue = $inVal);
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue($inValue) {
    $out = array();
    if(isset($inValue)&&is_array($inValue)&&$inValue['size']>0) {
      $out = array();
      $out['contentType'] = $inValue['type'];
      $out['tempFilename'] = $inValue['tmp_name'];
      $out['remoteFilename'] = $inValue['name'];
      $out['filesize'] = $inValue['size'];
      $out['error'] = $inValue['error'];
    }
    return $out;
  }
  
  function validate() {
    if(isset($this->elValueParsed['tempFilename'])) {
			if(!is_uploaded_file($this->elValueParsed['tempFilename'])) {
				//$this->cntError = 'Malicious request. Hacking attack suspected.';
        //return false;
      }
      $max_size = (isset($this->elMaxSize))?$this->elMaxSize:10048576;
      if($this->elValueParsed['filesize']>$max_size) {
        $this->cntError = 'File size is too big. Maximum size allowed is '.$max_size.' bytes.';
        return false;
      }
      if(isset($this->elContTypes)&&sizeof($this->elContTypes)
          &&!in_array($this->elValueParsed['contentType'],$this->elContTypes)) {
        $this->cntError = 'File type is not allowed. Allowed types:<br>'.implode('; ',array_keys($this->elContTypes));
        return false;
      }
      if(isset($this->elDest)&&$this->elDest!='') {
        if(!move_uploaded_file($this->elValueParsed['tempFilename'],$this->elDest)) {
          $this->cntError = 'Can not move uploaded file.';
          return false;
        }
      }
    }else {
      if($this->elRequired) {
        $this->cntError = 'File name is not specified.';
      }
    }
    return true;
  }
  
  function _make() {
    $this->elValueParsed = $this->setValue($this->elValue);
    $fEls = parent::_make();
    $fEls['size'] = $this->elSize;
    
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibFPassword.class.php
class blibFPassword extends blibFElement {
  var $elSize = '';
  var $elPreserve = 1;
  var $elReadonly = 0;
	var $LenControl = true;
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'ftf';
    $this->cntCssFile = $this->cntBaseUrl.'blibFPassword/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibFPassword/blibFPassword.tpl.php';
  }

  function setValue($inVal) {
    return $this->elValueParsed = $this->_processValue($this->elValue = $inVal);
  }

  function getValue() {
  	return $this->elValueParsed;
  }
  
  function _processValue($inValue) {
    return stripslashes(trim($inValue));
  }
  
  function validate() {
  	if($this->elRequired&&$this->elValue=='') {
  		$this->cntError = 'Field is required.';
      return false;
  	}elseif($this->elRequired&&strlen($this->elValue)<6&&$this->LenControl) {
  		$this->cntError = 'Minimum length is 6 chars.';
      return false;
  	}else {
  		return true;
  	}
  }
  
  function _make() {
    $this->elValueParsed = htmlspecialchars($this->setValue($this->elValue));
    $fEls = parent::_make();
    $fEls['size'] = $this->elSize;
    $fEls['readonly'] = $this->elReadonly;
    if(!$this->elPreserve) {
    	$fEls['value'] = "";
    }
    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('F', $fEls);
  	$this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  	
  }
}

//file: blibDataGrid.class.php
/**
* Grid generation control
*/
class blibDataGrid extends blibGrid{

  function setData($inData) {
  	$this->gridData = $inData;
    $this->gridAssumedRows = count($this->gridData);
  }
  
  function sortCol($inCol, $inSortOrder = SORT_ASC, $inSortType = SORT_REGULAR) {
  	if(count($this->gridData)) {
			foreach ($this->gridData as $row) {
				 $sortarray[] = $row[$inCol];
			}
			array_multisort($sortarray,$inSortOrder,$inSortType,$this->gridData);
			$this->gridSortCol = array('name'=>$inCol, 'sort'=>$inSortOrder);
  	}
  }

	function _getCheckedItems() {
		if(isset($_POST['g']['checks'])&&is_array($_POST['g']['checks'])) {
			$rows = $this->gridData;
			$rows_d = array();
			foreach($_POST['g']['checks'] as $key=>$val) {
				if($rows) {
					$rows_d = array_merge($rows_d,array_slice($rows,$key-1,1));
				}
			}
			foreach($rows_d as $key=>$val) {
				$rows_d[$key] = $val['id'];
			}
			return $rows_d;
		}else {
			return array();
		}
	}
}

//file: blibList.class.php
class blibList extends blibControl {
  var $hTpl;                    //pointer to templating engine    
  var $listHeight = '';         //dims/height
	var $listWidth = '100%';      //dims/width
  var $listData = array();      //list of assigned items
  var $listCols = 1;						//# of cols list should be transformed into
  
  function init($inName = '') {
    //control setup
    $this->setBaseUrl();
    $this->cntId = ($inName!='')?$inName:'lst';
    $this->cntCssFile = $this->cntBaseUrl.'blibList/style.css';

  	$this->hTpl = new blibTemplate();
    $this->hTpl->init(dirname(__FILE__).'/');
    $this->cntTplFile = '/blibList/blibList.tpl.php';
	}
  
  function addItem($inField, $inCaption, $inUrl = '', $inComment = '', $inType = 0, $inExtra = '', $inPos = -1,$inStatus = '') {
    $inPos = ($inPos==-1)?count($this->listData)+1:$inPos;
    $this->listData[] = array('name'=>$inField, 'caption'=>$inCaption, 'pos'=>$inPos, 'type'=>$inType, 'url'=>$inUrl, 'comment'=>$inComment,'extra'=>$inExtra,'cstatus'=>$inStatus);
  }
  
  function clearList($inType = 0) {
    $this->listData = array();
  }

 
  function setDims($inW,$inH=0) {
  	$this->listWidth = $inW;
    $this->listHeight = ($inH)?$inH:$this->listHeight;
  }

	function setCols($inCols) {
		$this->listCols = $inCols;
	}
  
  /*
  * Template
  */
  function getMsgBox($inHead, $inMsg) {
  	$this->clearList();
    $this->addItem('head',$inHead,'',1);
    $this->addItem('head',$inMsg);
    return $this->fetch();
  }

  function _make() {
    $this->_processQueStr();
    $this->_processGlobals();
    
    //sort data
    $sortarray = array();
    foreach ($this->listData as $row) {
       $sortarray[] = $row['pos'];
    }
    array_multisort($sortarray, SORT_ASC, SORT_REGULAR, $this->listData);

    foreach($this->cntGlobals as $k=>$v) {
      $this->hTpl->assign($k,$v);	
    }

    $this->hTpl->assign('M_items',$this->listData);
    $this->cntOut = $this->hTpl->fetch($this->cntTplFile);
  }

  function _processQueStr() {
    $this->listNav['xi'] = (int)(isset($_GET[$this->cntId.'xi'])?$_GET[$this->cntId.'xi']:1);
  }

  function _processGlobals() {
    $this->cntGlobals = array();
    parent::_processGlobals();
    $this->cntGlobals['DIR_IMG'] = $this->cntBaseUrl.'/blibList/images/';
    $this->cntGlobals['CUR_ITM'] = $this->listNav['xi'];
    $this->cntGlobals['LST_COLS'] = $this->listCols;
    $this->cntGlobals['LST_COLSW'] = (100/$this->listCols).'%';
    $this->cntGlobals['LST_WIDTH'] = $this->listWidth;
    if($this->listHeight) {
      $this->cntGlobals['LST_HEIGHT'] = $this->listHeight;	
    }
    
  }
}


?>