<?
require_once(dirname(__FILE__).'/../../blibFrame.lib.php');

//file:blibDbTable.class.php
/**
* Dynamic Table
*/

class blibDbTable extends blibClass{
  var $hSql;
  var $els;
  var $_els;
  var $_data;
  var $_tbl;
  var $_id;

  function init(&$hSql) {
  	$this->hSql = $hSql;
  }

  function setFields($inFields = array()) {
    $this->_els = $inFields;
    $this->els = array();
    foreach($inFields as $key=>$val) {
  		$this->els[$val] = '';
  	}
  }

  function setValue($inField,$inValue) {
  	$this->_els[] = $inField;
    $this->els[$inField] = $inValue;
  }

  function clearValue($inField) {
  	if(isset($this->els[$inField])) {
  		unset($this->els[$inField]);
  	}
    if(in_array($inField,$this->_els)) {
    	unset($this->_els[array_search($inField,$this->_els)]);
    }
  }

  function setData($inTbl,$inId) {
    $this->_tbl = $inTbl;
    $this->_id = $inId;
  	$inSql = 'SELECT '.implode(', ',$this->_els).' FROM '.dext($inTbl).' WHERE id="'.$inId.'"';
    $this->_data = $this->hSql->getRow($inSql);
    $this->_setData();
  }

  function setDataRaw($inSql) {
  	$this->_data = $this->hSql->getRow($inSql);
    $this->_setData();
  }

  function updateData($inData) {
    foreach($this->els as $key=>$val) {
    	if(isset($inData[$key])) {
    		if(is_array($inData[$key])) {
    			if(isset($inData[$key][0])) {
    			  $this->els[$key] = $inData[$key][0];		
    			}else {
    				$this->els[$key] = '';	
    			}
    		}else {
    		  $this->els[$key] = $inData[$key];	
    		}
        $this->els[$key] = addslashes($this->els[$key]);	
    	}
    }  	
  }

  function sqlUpdate($inTbl = '', $inId = '') {
  	$que = 'UPDATE '.dext(($inTbl?$inTbl:$this->_tbl)).' SET ';
    foreach($this->els as $key=>$val) {
    	$que .= $key.'="'.$val.'",';
    }
    $que = substr($que,0,-1);
    $que .= ' WHERE id="'.($inId?$inId:$this->_id).'"';
    return $this->hSql->query($que,0);
  }
  
  function sqlInsert($inTbl = '') {
  	$que = 'INSERT INTO '.dext(($inTbl?$inTbl:$this->_tbl)).'('.implode(',',array_keys($this->els)).') VALUES("'.implode('","',$this->els).'")';
    return $this->hSql->query($que,0);
  }

  function sqlDelete($inTbl = '', $inId = '') {
  	$que = 'DELETE FROM '.dext(($inTbl?$inTbl:$this->_tbl));
    $que .= ' WHERE id="'.($inId?$inId:$this->_id).'"';
    return $this->hSql->query($que,0);
  }

  function _setData() {
    foreach($this->els as $key=>$val) {
    	if(isset($this->_data[$key])) {
        if(!(strpos($key,'date')===false)) {
        	$this->els[$key] = con_date($this->_data[$key],2);
        }else {
          $this->els[$key] = $this->_data[$key];	
        }
    		
    	}
    }  	
  }
}

//file: blibDbTxtUtils.inc.php
//Functions used by plain-text database

/***********************************
	 	Char Functions
************************************/
function last_char($string) {
	$len = strlen($string);
	if($len < 1) {
		return '';
	}
	return $string{strlen($string)-1};
}

function remove_last_char(&$string) {
	$string=substr($string,0,strlen($string)-1);
}


/***********************************
	 	String Functions
************************************/
// returns $length chars from the right side of $string
function substr_right($string,$length) {
	return substr($string, strlen($string)-$length);
}



/***********************************
	 	Array Functions
************************************/
function array_walk_trim(&$value, &$key) {
	$value=trim($value);
}

function create_array_fill($size, $value) {
	$arr=array();
	for($i=0;$i<$size;++$i)
		$arr[]=$value;
	return $arr;
}

// searches the first n chars of $string in $array
// where n is the length of reach $array element
// returns the value of $array if found or false
function array_search_str_start($string, $array) {
	for($i=0;$i<count($array);++$i) {
		////$this->msgThrow(get_class($this),"Searching " . $array[$i] . " in " . $string . "<br>");
		if(strncmp($array[$i],$string, strlen($array[$i]))==0)
			return $array[$i];
	}
	return false;
}

// as above but case insenitive
function array_search_stri_start($string, $array) {
    for($i=0;$i<count($array);++$i) {
		////$this->msgThrow(get_class($this),"Searching " . $array[$i] . " in " . $string . "<br>");
		if(strncmp(strtoupper($array[$i]),strtoupper($string), strlen($array[$i]))==0)
			return $array[$i];
	}
	return false;
}

/***********************************
	 	Type Functions
************************************/
function dump_retval_type($var) {
  if(is_bool($var) && !$var) 
    echo "The value is FALSE<br>"; 
  if(is_int($var) && !$var) 
    echo "The value is 0<br>"; 
  if(!isset($var)) 
    echo "The value is NULL<br>"; 
  if(is_string($var) && $var=="") 
    echo "The value is \"\"<br>"; 
  if(is_string($var) && $var=="0") 
    echo "The value is \"0\"<br>"; 
  if($var)
  	echo "The value is a TRUE or something other then 0 or FALSE<br>"; 
} 

function is_false($var) {
	return (is_bool($var) && !$var);
}
function is_0($var) {
	return (is_int($var) && !$var);
}
// _ at the front, cause is_null exists
function _is_null($var) {
	return (!isset($var)) ;
}
function is_empty_str($var) {
	return (is_string($var) && $var=="");
}

/***********************************
	 	SQL Util Functions
************************************/
// compares 2 values by $operator, and returns true or false
function compare($value1,$value2,$operator) {
	
	if($operator=="=")
		return ($value1 == $value2);

	if($operator==">")
		return ($value1 > $value2);
		
	if($operator=="<")
		return ($value1 < $value2);
		
	if($operator=="<>" || $operator=="!=")
		return ($value1 != $value2);
		
	if($operator==">=")
		return ($value1 >= $value2);
		
	if($operator=="<=")
		return ($value1 <= $value2);
		
	if($operator=="LIKE") {
		return compare_like($value1,$value2);
	}
	if($operator=="NOT LIKE") { 
		return !compare_like($value1,$value2); 
	} 
	if($operator=="IN") {
		$list = preg_split ("/[(,) ]+/",$value2,-1,PREG_SPLIT_NO_EMPTY);
		foreach($list as $listVal) {
			if(!is_numeric($listVal)) {
				if(has_quotes($listVal)) {
					remove_quotes($listVal);
				}
				if("$listVal" == "$value1") {
					return 1;
				}
			} else if($listVal == $value1) {
				return 1;
			}
		}
		return 0;
	}
	if($operator=="NOT IN") {
		$list = preg_split ("/[(,) ]+/",$value2,-1,PREG_SPLIT_NO_EMPTY);
		foreach($list as $listVal) {
			if(!is_numeric($listVal)) {
				if(has_quotes($listVal)) {
					remove_quotes($listVal);
				}
				if("$listVal" == "$value1") {
					return 0;
				}
			} else if($listVal == $value1) {
				return 0;
			}
		}
		return 1;
	}
		
	return false;
}


function compare_like($value1,$value2) { 
	static $patterns = array(); 

	// Lookup precomputed pattern 
	if(isset($patterns[$value2])) { 
		$pat = $patterns[$value2]; 
	} else { 
		// Calculate pattern 
		$rc=0; 
		$mod = ""; 
		$prefix = "/^"; 
		$suffix = "$/"; 
       
		// quote regular expression characters 
		$str=preg_quote($value2,"/"); 
       
		// unquote \ 
		$str=str_replace ("\\\\", "\\",$str); 
       
		// Optimize leading/trailing wildcards 
		if(substr($str, 0, 1) == '%') { 
			$str = substr($str, 1); 
			$prefix = "/"; 
		} 
		if(substr($str, -1) == '%' && substr($str, -2, 1) != '\\') { 
			$str = substr($str, 0, -1); 
			$suffix = "/"; 
		} 
       
		// case sensitive ? 
		if(!DBTXT_LIKE_CASE_SENSITIVE) 
			$mod="i"; 
          
		// setup a StringParser and replace unescaped '%' with '.*' 
		$sp=new StringParser(); 
		$sp->setConfig(array() ,"\\",array()); 
		$sp->setString($str); 
		$str=$sp->replaceCharWithStr("%",".*"); 
		// replace unescaped '_' with '.' 
		$sp->setString($str); 
		$str=$sp->replaceCharWithStr("_","."); 
		$pat = $prefix . $str . $suffix . $mod; 

		// Stash precomputed value 
		$patterns[$value2] = $pat; 
	} 
       
	return preg_match ($pat, $value1); 
}

// splits a full column name into its subparts (name, table, function)
// return true or false on error
function split_full_colname($fullColName,&$colName,&$colTable,&$colFunc) {
	
	$colName="";
	$colTable="";
	$colFunc="";
	
	// direct value ?
	if(is_numeric($fullColName) || has_quotes($fullColName)) {
		$colName=trim($fullColName);
		return true;
	}
	
	if(!is_false ($pos=strpos($fullColName,"(")) ) {
		$colFunc=strtoupper(trim(substr($fullColName,0,$pos)));
		$fullColName=substr($fullColName,$pos+1);
	}

	if(!is_false ($pos=strpos($fullColName,".")) && $colFunc!="EVAL") {
		$colTable=substr($fullColName,0,$pos);
		$colName=substr($fullColName,$pos+1);
	}  else {
		$colName=$fullColName;
	}

	$colName=trim($colName);
	if($colFunc) {
		if(last_char($colName)==")") {
			remove_last_char($colName);
		} else {
			$this->errorThrow(get_class($this),") expected after $colName!");
			return false;
		}
	}
	$colName=trim($colName);
	$colTable=trim($colTable);
	return true;
}


function execFunc($func, $param) {
	switch($func) {
		case "MD5":
			return doFuncMD5($param);
		case "NOW":
			return doFuncNOW();
		case "UNIX_TIMESTAMP":
			return doFuncUNIX_TIMESTAMP();
		case "ABS":
			return doFuncABS($param);
		case "LCASE":
		case "LOWER":
			return doFuncLCASE($param);
		case "UCASE":
		case "UPPER":
			return doFuncUCASE($param);
		case "INC":
			return $param+1;
		case "DEC":
			return $param-1;
		case "EVAL":
			if(is_empty_str($param))
				return 0;
			return eval("return ($param);");
		default:
			$this->errorThrow(get_class($this),"function '$func' not supported!");
			return $param;
	}
	return $col;
}

function doFuncMD5($param) {
	return md5($param) ;
}

function doFuncNOW() {
	return date("Y-m-d H:i:s",get_static_timestamp());
}

function doFuncUNIX_TIMESTAMP() {
	return get_static_timestamp();
}

function doFuncABS($param) {
	return abs($param);
}

function doFuncLCASE($param) {
	return strtolower($param);
}

function doFuncUCASE($param) {
	return strtoupper($param);
}

function execGroupFunc($func, $params) {
	switch($func) {
		//case "":
		//	return $params[0];
		case "MAX":
			return doFuncMAX($params);
		case "MIN":
			return doFuncMIN($params);
		case "COUNT":
			return doFuncCOUNT($params);
		case "SUM":
			return doFuncSUM($params);
		case "CONCAT":
			return doFuncCONCAT($params);
		case "AVG":
			return doFuncAVG($params);
			
		default:
			$this->errorThrow(get_class($this),"Function '$func' not supported!!!");
	}
	return $col;
}

function doFuncMAX($params) {
	$maxVal=$params[0];
	for($i=1;$i<count($params);++$i) {
		$maxVal=max($maxVal,$params[$i]);
	}
	return $maxVal;
}

function doFuncMIN($params) {
	$minVal=$params[0];
	for($i=1;$i<count($params);++$i) {
		$minVal=min($minVal,$params[$i]);
	}
	return $minVal;
}

function doFuncCOUNT($params) {
	return count($params);
}

function doFuncCONCAT($params) {
	$str = '';
	for($i=0;$i<count($params);++$i) {
		$str.=$params[$i];
	}
	return $str;
}
function doFuncSUM($params) {
	$sum=0;
	for($i=0;$i<count($params);++$i) {
		$sum+=$params[$i];
	}
	return $sum;
}

function doFuncAVG($params) {
	$sum=doFuncSUM($params);
	return $sum / count($params);
}

/***********************************
	 	Error Functions
************************************/

// returns true if errors occurred
function txtdbapi_error_occurred() {
	global $gDbTxt_txtdbapi_errors;
	return (count($gDbTxt_txtdbapi_errors)>0);
}

function txtdbapi_get_last_error() {
	global $gDbTxt_txtdbapi_errors;
	if(!txtdbapi_error_occurred())
	    return "";
	return array_pop($gDbTxt_txtdbapi_errors);
}

function txtdbapi_get_errors() {
	global $gDbTxt_txtdbapi_errors;
	
	if(!txtdbapi_error_occurred())
	    return array();
	$arr=$gDbTxt_txtdbapi_errors;
	$gDbTxt_txtdbapi_errors=array();
	return $arr;
}

function txtdbapi_clear_errors() {
	global $gDbTxt_txtdbapi_errors;
	$gDbTxt_txtdbapi_errors=array();
}

// error handler function
function txtdbapi_error_handler ($errno, $errstr, $errfile, $errline) {
	$prefix="PHP Error: ";
	switch ($errno) {
  		case E_USER_ERROR:
    		$this->errorThrow(get_class($this),$prefix . "FATAL [$errno] $errstr [Line: ".$errline."] [File: ". $errfile . "]");
    		break;
  		default:
    		$this->errorThrow(get_class($this),$prefix . "[$errno] $errstr [Line: ".$errline."] [File: ". $errfile . "]");
    		break;
	}
}



/***********************************
	 	Quote Functions
************************************/
function has_quotes($str) {
	if(is_empty_str($str))
		return false;
	return ($str[0]=="'" || $str[0]=="\"") && (last_char($str)=="'" || last_char($str)=="\"");
}

function remove_quotes(&$str) {
	$str=substr($str,1);
	remove_last_char($str);
}

function array_walk_remove_quotes(&$value, &$key) {
	if(has_quotes($value))
		remove_quotes($value);
}


/***********************************
	 	Time Functions
************************************/
function getmicrotime(){ 
    list($usec, $sec) = explode(" ",microtime()); 
    return ((float)$usec + (float)$sec); 
} 

// ensures that all timestamp requests of one execution have the same time
function get_static_timestamp() {
	static $t = 0;
	if($t==0)
		$t=time();
	return $t;
}

//file: blibDbTxtParsers.class.php
/**********************************************************************
							ExpressionParser
***********************************************************************/

// Used to filter a ResultSet ($masterResultSet) 
// by the Where-Expression in the SqlQuery Object ($sqlQuery)
class ExpressionParser  extends blibClass{

	// A tree of Expression Objects is built, and then they
	// are filtered recursive
	// Returns a ResultSet filtered by the Where-Expression in $sqlQuery
	// $masterResultSet is left unchanged (I'm not sure about this)
	
	function getExpressionTree($expr) {
		
		global $gDbTxt_sqlSingleRecFuncs;

		$parser=new SqlParser($expr);
		$king_expr=new Expression();
		$current_expr=&$king_expr;
		
		while(!is_empty_str($elem=$parser->parseNextElementRaw())) {
			
			// function or IN / NOT IN?
			if(in_array(strtoupper($elem),$gDbTxt_sqlSingleRecFuncs) || strtoupper($elem) == "IN" || strtoupper($elem) == "NOT IN") {
				$current_expr->expr_str .= ($elem . " ");
				$elem=$parser->parseNextElementRaw();
				if($elem!="(") {
					$this->errorThrow(get_class($this),"( expected after " . $current_expr->expr_str,__FILE__,__LINE__);
					return null;
				}
				$current_expr->expr_str .= $elem;
				
				while(!is_empty_str($elem=$parser->parseNextElementRaw()) && $elem!=")") {
					$current_expr->expr_str .= $elem;
				}
				$current_expr->expr_str .= $elem . " ";
				
				continue;
				
			}
			
			if($elem=="(") {
				$current_expr->expr_str .= " % ";
				unset($new_expr);
				$new_expr=new Expression("");
				$current_expr->addChild($new_expr);
				$new_expr->setParent($current_expr); 
				unset($current_expr);
				$current_expr=&$new_expr;
			
			} else if($elem==")") {
				
				unset($tmp);
				$tmp=&$current_expr->getParent();
				unset($current_expr);
				$current_expr=&$tmp;				
			} else {
				// no spaces on .'s
				if($elem==".") {
					remove_last_char($current_expr->expr_str);
					$current_expr->expr_str .= $elem;
				} else {
					$current_expr->expr_str .= ($elem . " ");
				}
			}
		}
		return $king_expr;
	}
}

/**********************************************************************
							Expression
***********************************************************************/

class Expression  extends blibClass{
	
	/***********************************
		 	Member Vars
	************************************/
	
	var $expr_str;
	var $childs=array();
	var $parent;
	var $resultSetsFromChilds=array();
	var $childResultSetPos=0;
		
	/***********************************
		 		Constructor
	************************************/
	
	function Expression($expr_str="") {
		$this->expr_str=$expr_str;
	}
	
	/***********************************
		 		get/set Functions
	************************************/
	
	function setParent(&$parent_ref) {
		$this->parent=&$parent_ref;
	}
	
	function &getParent() {
		return $this->parent;
	}
	
	function setExprStr($expr_str) {
		$this->expr_str=$expr_str;
	}
	
	function getExprStr() {
		return $this->expr_str;
	}
	
	function getChildCount() {
		return count($this->childs);
	}
	
	function addChild(&$child_ref)  {
		////$this->msgThrow(get_class($this),"addChild called<br>",__FILE__,__LINE__);
		////$this->msgThrow(get_class($this),$this->expr_str . " has new Child: " . $child_ref->getExprStr() . "<br>",__FILE__,__LINE__); 
		$this->childs[]=&$child_ref;
	}
	
	/***********************************
		 	Recursive Filter 
	************************************/
	
	function getFilteredResultSet(&$resultSet) {	
		
		global $gDbTxt_sqlComparisonOperators;
		
		for($i=0;$i<$this->getChildCount();++$i) {
			$child=$this->childs[$i];
			$this->resultSetsFromChilds[]=$child->getFilteredResultSet($resultSet);
		}
		
		$sp=new StringParser();
		
		//$or_expr=explode_resp_quotes(" OR ",$this->expr_str);
		$sp->setConfig(array("'","\""), "\\", array() , array(" OR "),false,false);
		$sp->setString($this->expr_str);
        $or_expr=$sp->splitWithSpecialElements();     
				
		$andResultSets=array();
		
		for($i=0;$i<count($or_expr);++$i) {
			$fieldValuePair=array();
			$fields=array();
			$values=array();
			$operators=array();
			$childsToInclude=0;
						
			//$and_expr=explode_resp_quotes(" AND ",$or_expr[$i]);
			$sp->setConfig(array("'","\""), "\\", array() , array(" AND "),false,false);
			$sp->setString($or_expr[$i]);
            $and_expr=$sp->splitWithSpecialElements();     
			
			
			array_walk($and_expr,"array_walk_trim");
			for($j=0;$j<count($and_expr);++$j) {
				if($and_expr[$j]=="%")
					$childsToInclude++;
				else {
					
					//$operators[]=explode_resp_quotes_multisep($gDbTxt_sqlComparisonOperators,$and_expr[$j],$fieldValuePair);
					$usedOps=array();
					$sp->setConfig(array("'","\""), "\\", array() , $gDbTxt_sqlComparisonOperators,false,false);
					
			        $sp->setString($and_expr[$j]);
			        $fieldValuePair=$sp->splitWithSpecialElementsRetUsed($usedOps);  
			        $operators[]=trim($usedOps[0]);
					
					// Remove escape chars (because parseNextElementRaw() was used
					// to parse Where Statements)
					list($field,$value)=$fieldValuePair;
					$fields[] = stripslashes(trim($field));
					// like bugfix: don't remove escape chars on the LIKE value
					if(strtoupper(trim($operators[count($operators)-1]))=="LIKE") {
					    $values[] = trim($value);   
					} else {
					    $values[] = stripslashes(trim($value));
					}
				}
			}
			if($this->blibVoiceMessages) {
				echo "<br>fields and values to use for AND filter:<br>";
				print_r($fields);
				echo "<br>";
				print_r($values);
				echo "<br>";
				print_r($operators);
				echo "<br>";
				echo "childsToInclude:  ". $childsToInclude . "<br>";
			}
			$andResultSets[]=$resultSet->filterRowsByAndConditions($fields,$values,$operators);
			////$this->msgThrow(get_class($this),"filterRowsByAndConditions done<br>",__FILE__,__LINE__);
			for($j=0;$j<$childsToInclude;++$j) {
				$andResultSets[$i]->filterResultSetAndWithAnother($this->resultSetsFromChilds[$this->childResultSetPos++]);
			}
			
			if($this->blibVoiceMessages) {
				echo "Filtered ResultSet:<br>";
				$andResultSets[$i]->dump();
			}
			
		}
		$finalResultSet=$andResultSets[0];
		for($i=1;$i<count($andResultSets);++$i) {
			$andResultSets[$i]->reset();
			while($andResultSets[$i]->next()) 
				$finalResultSet->appendRow($andResultSets[$i]->getCurrentValues(),$andResultSets[$i]->getCurrentRowId());
		}
		if($this->blibVoiceMessages) {
			echo "<br><br>FINAL RESULT SET:<br>";
			$finalResultSet->dump();
		}
		return $finalResultSet;
	}
}

/**********************************************************************
							StringParser
***********************************************************************/
// The StringParser can be used to split up a string into it's elements.
// The StringParser uses an array of whitespace chars ($whitespaceChars)
// to split up the string. Escape chars, quotes and special elements 
// (elements which aren't separeted trought whitespaces) are handled.
// For more infos see the comments of the Member Variables and functions.

// HOWTO use the StringParser (Step 2 is optional, you may also use the default parsing-config):
// 1. Get an instance: $sp=new StringParser();
// 2. Set the parsing-config: $sp->setConfig(array("'","\"") ,"\\", array(" ") ,array(),false,true);
// 3. Set the string: $sp->setString("parse me");
// 4. Parse the string with one of the functions, for example parseNextElement()
// NOTE: always call setString() or restart after setConfig, or the new specialElements wont be used!
// The other vars of the parsing-config can be changed on the fly.
// NOTE: the special elements are always case insensitive, and made to UPPERCASE before compared

class StringParser  extends blibClass{

    /***********************************
		 	Mebmer Variables
	************************************/
	
	// Parsing Config
	var $quoteChars=array();        // array of 1 char strings with quote chars
	var $escapeChar="";             // 1 char string whith the escape char
	var $whitespaceChars=array();   // array of 1 char strings with whitespace chars
	                                // whitespaces do split up a String into single Elements.
	
	var $specialElements=array();   // array of strings with elements which have to be parsed but are
	                                // not in all cases separated trough whitespaces. for example . or > in SQL.
	                                // The order of the elements is critical, for example add <= before <, 
	                                // because else if a <= is in a string, it will be matched as <
	                                // ONLY set specialElements if you use the functions parse/peek/skipNextElement() !!
	                                
    var $removeQuotes=false;
    var $removeEscapeChars=true;
    
    
    // parseNextChar() state vars
    var $currentPos=-1;             // current parsing position (index into workingStr)
    var $currentChar="";            // current char
    var $inQuotes=array();          // in which Quotes are we ?
    var $lastWasEscape=false;       // the last parsed char was an escape char
    var $currentIsEscape=false;     // the current char is an escape char
    var $currentElement="";         // the current element
    var $elementFinished=false;     // contains currentElement a finished element ?
    
    
    // Internal Vars                        
    var $originalStr;
    var $workingStr;
    var $specialElementsMaxLen=0;
    var $peekCache="";
    
    /***********************************
		 	General functions
	************************************/ 
	
	// Constructor
	function StringParser() {
	    // default config
	    $this->quoteChars=array("'","\"");
	    $this->escapeChar="\\";
	    $this->whitespaceChars=array(" ","\n","\r","\t"); 
	    $this->specialElements=array();
	    $this->peekCache="";
	}
	
	// Set's the current parsing configuration
    // ATTENTION: always call setConfig() before setString() !!!
    function setConfig( $arrQuoteChars=array("'","\"") , $escapeChar="\\", 
                        $arrWhiteSpaceChars=array(" ") , $arrSpecialElements=array(),
                        $removeQuotes=false, $removeEscapeChars=true) {
        $this->quoteChars=$arrQuoteChars;
        $this->escapeChar=$escapeChar;
        $this->whitespaceChars=$arrWhiteSpaceChars;
        $this->specialElements=$arrSpecialElements;
        $this->removeQuotes=$removeQuotes;
        $this->removeEscapeChars=$removeEscapeChars;

    }
	
	// Set's the String which has to be parsed
	// If you want another parsing-config then the default config, call
	// setConfig() before setString(), or the specialElements won't be 
	// correctly handled
    function setString($str) {
        $this->originalStr=$str;
        $this->restart();
    }
    
       
    // (Re)starts parsing, $workingStr is replaced with $originalStr	
    // calculates specialElementsMaxLen and reset's the parseNextChar()
    // state vars
    function restart() {
        $this->workingStr=$this->originalStr; 
        
        //calc specialElementsMaxLen
        $this->specialElementsMaxLen=0;
        for($i=0;$i<count($this->specialElements);++$i) {
            $len=strlen($this->specialElements[$i]);
            if($len>$this->specialElementsMaxLen) {
                $this->specialElementsMaxLen=$len;
            }
        }
        ////$this->msgThrow(get_class($this),"specialElementsMaxLen: " . $this->specialElementsMaxLen . "<br>",__FILE__,__LINE__);
        
        // reset parseNextChar() state vars
        $this->currentPos=-1;
        $this->currentChar="";
        $this->inQuotes=create_array_fill(count($this->quoteChars), 0);
        $this->lastWasEscape=false;
        $this->currentIsEscape=false;
        $this->currentElement="";
        $this->elementFinished=false;
        
        $this->peekCache="";
    }
    
    
	/***********************************
		 	Parsing functions
	************************************/
	
	// parses the next char and appends it to $this->currentElement and updates the 
	// parseNextChar() state vars
	// returns false if the end of the string is reached, if all went ok true is returned
	// this function is a helper for all other parsing functions.
	// use it directly ONLY if you have NO specialElements defined!
	function parseNextChar() {
	   
        if(! (++$this->currentPos<strlen($this->workingStr)))
	        return false;
	        
        $this->currentChar=$this->workingStr{$this->currentPos};
        $c=$this->currentChar;
		////$this->msgThrow(get_class($this),"StringParser:: current char: '" . $c . "' <br>",__FILE__,__LINE__);
		
		// update escape char tracking vars
		if($this->currentIsEscape) {
		    $this->lastWasEscape=true;
		    $this->currentIsEscape=false;
		} else {
		    $this->lastWasEscape=false;
		    $this->currentIsEscape=false;
		}
		
		// escape char:
		if($c==$this->escapeChar) {
		    ////$this->msgThrow(get_class($this),"StringParser:: escape char matched: " . $c . "<br>",__FILE__,__LINE__);
		    // last was escape: 2 escape chars => the char is used, and the escapement meaning is lost
		    if($this->lastWasEscape) {
		        $this->currentIsEscape=false;
		        $this->lastWasEscape=false;
		        $this->currentElement.=$c;
		    // last was not escape, so the current has escape meaning
		    }  else {
		        $this->currentIsEscape=true;
		        // add only if we don't remove escape chars
		        if(!$this->removeEscapeChars) {
			        $this->currentElement.=$c;
		        }
            }
		    return true;
		}
		
		
		// handle quote chars (only if the last was no escape char)
		if(!$this->lastWasEscape) {
		    for($j=0;$j<count($this->quoteChars);++$j) {
			    if($c==$this->quoteChars[$j]) {
			        
		            // are we in this quotes OR not in other quotes => swap quote var
		            if($this->inQuotes[$j] || is_false(in_array(1,$this->inQuotes))) {
		                $this->inQuotes[$j]= !$this->inQuotes[$j];
		                // add only if $this->removeQuotes isn't set
		                if(!$this->removeQuotes) {
		                    $this->currentElement.=$c;
		                }
		            // else ignore the quotes meaning, but add it anyway
		            } else {
		                $this->currentElement.=$c;
		            }
		            return true; 			   
		        }
            }
        }
        
        // handle whitespace chars (if we are not in quotes)
        if(is_false(in_array(1,$this->inQuotes))) {
            for($j=0;$j<count($this->whitespaceChars);++$j) {
                if($c==$this->whitespaceChars[$j]) {
                    ////$this->msgThrow(get_class($this),"StringParser:: whitespace matched: '" . $c . "' nr: " . $j . "<br>",__FILE__,__LINE__);
                    // whitespace found, return element if the strlen() is > 0
                    if(strlen($this->currentElement)>0) {
                       //++$this->currentPos; // skip the whitespace
                       // break all for's an return $element:
                       //break 2;
                       $this->elementFinished=true;
                       return true;
                    }
                    // ignore the whitespace => continue
                    return true;
                }
            }
        } 
        
        // search for specialElements, but only if we are not in quotes
        if(is_false(in_array(1,$this->inQuotes))) {
            $testStr=substr($this->workingStr,$this->currentPos,$this->specialElementsMaxLen);
            ////$this->msgThrow(get_class($this),"StringParser:: testStr is " . $testStr . "<br>",__FILE__,__LINE__);
            if(!is_false($specialElem=array_search_stri_start($testStr,$this->specialElements))) {
                ////$this->msgThrow(get_class($this),"special Element found: " . $specialElem . "<br>",__FILE__,__LINE__);
                // specialElement found!
                // strlen(element)>0 ? return current element 
                if(strlen($this->currentElement)>0) {
                    ////$this->msgThrow(get_class($this),"returning last Element !<br>",__FILE__,__LINE__);
                    $this->elementFinished=true;
                    --$this->currentPos;
                    return true;
				    
				// make the specialElement the current element and return it
			    } else {
			        ////$this->msgThrow(get_class($this),"returning specialElement !<br>",__FILE__,__LINE__);
					$this->currentElement=$specialElem;
					$this->currentPos+=strlen($specialElem);
					--$this->currentPos;
				    $this->elementFinished=true;
				    return true;
			    }
            }
        }
            
        // none of the previous tests matches, add the current char to the element
        ////$this->msgThrow(get_class($this),"StringParser:: normal char...<br>",__FILE__,__LINE__);
        $this->currentElement.=$c;
        return true;
               
    } // function
			

	
	
	
    // returns the next Element and remove's it
    function parseNextElement() {   
                
        if(!is_empty_str($this->peekCache)) {
        	////$this->msgThrow(get_class($this),"<font color='green'>StringParser:: cache hit for " .  $this->peekCache . "</font><br>",__FILE__,__LINE__);
        	$tmp=$this->peekCache;
        	$this->peekCache="";
        	return $tmp;
        }
        
        $this->currentElement="";
        while($this->parseNextChar() && !$this->elementFinished) {        
            
        }
           
        ////$this->msgThrow(get_class($this), "StringParser:: workingStr before: '" . $this->workingStr . "'<br>",__FILE__,__LINE__);
        
        
      
        // remove
		$this->workingStr=substr($this->workingStr,$this->currentPos);
		
		////$this->msgThrow(get_class($this), "StringParser:: workingStr after: '" . $this->workingStr . "'<br>",__FILE__,__LINE__);
		////$this->msgThrow(get_class($this), "StringParser:: returning Element: '<b><k><font color='red'>" . $this->currentElement . "</font></b></k>'<br>",__FILE__,__LINE__);
		$this->currentPos=0;
		$this->elementFinished=false;
		return $this->currentElement;
        
    } // function
    
    
    // returns the next Element but doesn't remove it
    function peekNextElement() {
    	if(!is_empty_str($this->peekCache)) {
    		////$this->msgThrow(get_class($this),"<font color='green'>StringParser:: cache hit for " .  $this->peekCache . "</font><br>",__FILE__,__LINE__);
    		return $this->peekCache;
    	}
    	$this->peekCache=$this->parseNextElement();
        return $this->peekCache;
    }
    
    // skips the next Element
    function skipNextElement() {
    	if(!is_empty_str($this->peekCache)) {
    		////$this->msgThrow(get_class($this),"<font color='green'>StringParser:: nothing to skip, erasing cache...</font><br>",__FILE__,__LINE__);
    		$this->peekCache="";
    		return;
    	}
        $this->parseNextElement();
    }
    
    // parses the next Elements until $separatorElement or one of the $finishElements
    // it found.
    // The parsed values are returned in the array $arrParsedElements
    // Returns true if elements were parsed, else false is returned
    function parseNextElements($separatorElement,$finishElements, &$arrParsedElements) {
    	$arrParsedElements=array();
    	while(!is_empty_str($elem=$this->peekNextElement())) {
    		
    		if(strtoupper($elem)==strtoupper($separatorElement)) {
    			$this->skipNextElement();
    			break;
    		}
    		for($i=0;$i<count($finishElements);++$i) {
    			if(strtoupper($elem)==strtoupper($finishElements[$i])) {
    				break 2;
    			}
    		}
    		$arrParsedElements[]=$elem;
    		$this->skipNextElement();
    	}
    	if(count($arrParsedElements)>0)
    		return true;
    	return false;
    }




    /***********************************
		 	Replace functions
	************************************/
	
    // returns a String where $searchChar is replaced with replaceStr,
    // expect places where $searchChar is escaped
    // make sure that NO specialElements are set, else this function will not work correctly.
    function replaceCharWithStr($searchChar,$replaceStr) {
        $this->restart();
        $resStr="";
        while($this->parseNextChar()) {
            $c=$this->currentChar;
            if($searchChar==$c && !$this->lastWasEscape) {
                $resStr.= $replaceStr;
            } else {
                $resStr .= $c;
            }  
        }
        return $resStr;     
    }
    
    
    /***********************************
		 	Split functions
	************************************/
	
	// returns an array with the splitted strings.
    // The specialElements are used to split the string up.
    // You may also define quoteChars and escapeChar so no specielElements 
    // in Quotes are used. But do NOT set any whitespaceChars!
    function splitWithSpecialElements() {
        $arr=array();
        $arrPos=0;
 
        while($elem=$this->parseNextElement()) {
            $isSpecial=false;
            ////$this->msgThrow(get_class($this),"splitWithSpecialElements elem: " . $elem . "<br>",__FILE__,__LINE__);
            for($i=0;$i<count($this->specialElements);++$i) {
                if(strtoupper($elem)==strtoupper($this->specialElements[$i])) {
                    $isSpecial=true;
                    break;    
                }
            }
            if($isSpecial) {
                $arr[++$arrPos]="";      
            } else {
            	if(!isset($arr[$arrPos])) // pos 0 bugfix...
            		$arr[$arrPos]="";
            		
                $arr[$arrPos].=$elem;  
            }
        }        
        return $arr;
    }
    
    
    // same as splitWithSpecialElements, but you have to pass an array
    // as parameter, which is filled with the specialElements which
    // where found in the string and used to split (all are in UPPERCASES).
    function splitWithSpecialElementsRetUsed(&$arrUsedSpecElements) {
        $arr=array();
        $arrPos=0;
 
        while($elem=$this->parseNextElement()) {
            $isSpecial=false;
            ////$this->msgThrow(get_class($this),"splitWithSpecialElementsRetUsed elem: " . $elem . "<br>",__FILE__,__LINE__);
            for($i=0;$i<count($this->specialElements);++$i) {
                if(strtoupper($elem)==strtoupper($this->specialElements[$i])) {
                    $isSpecial=true;
                    if(!in_array(strtoupper($this->specialElements[$i]),$arrUsedSpecElements)) {
                        $arrUsedSpecElements[]=strtoupper($this->specialElements[$i]);
                    }
                    
                    break;    
                }
            }
            if($isSpecial) {
                $arr[++$arrPos]="";      
            } else {
            	if(!isset($arr[$arrPos])) // pos 0 bugfix...
            		$arr[$arrPos]="";
                $arr[$arrPos].=$elem;  
            }
        }        
        return $arr;
    }
    
} 
//file: blibDbTxtSQL.class.php
/**********************************************************************
							Global vars 
***********************************************************************/

// Special Strings in SQL Queries
// Insert Strings before Single Chars !! (e.g. >= before >)
$gDbTxt_sqlComparisonOperators=array("<>","!=",">=","<=","=","<",">"," LIKE ", " NOT LIKE ", " IN ", " NOT IN ");
$gDbTxt_sqlQuerySpecialStrings = array_merge($gDbTxt_sqlComparisonOperators, array("(",")",";",",","."));
$gDbTxt_sqlQuerySpecialStringsMaxLen =6;

// Functions for SQL Queries
// SingleRec functions need no grouped ResultSet
$gDbTxt_sqlSingleRecFuncs=array("UNIX_TIMESTAMP","MD5","NOW","ABS","LCASE","UCASE","LOWER","UPPER", "INC", "DEC", "EVAL");
$gDbTxt_sqlGroupingFuncs=array("MAX","MIN","COUNT","SUM", "AVG","CONCAT");

// Math Operators
$gDbTxt_sqlMathOps=array("+","-","*","/","(",")");



/**********************************************************************
							SqlParser
***********************************************************************/
// Used to parse an SQL-Query (as String) into an SqlObject
class SqlParser extends StringParser {
	

	/***********************************
		 		Constructor
	************************************/
	function SqlParser($sql_query_str) {
	    
		//$this->msgThrow(get_class($this),"New SqlParser instance: $sql_query_str<br>",__FILE__,__LINE__);
		global $gDbTxt_sqlQuerySpecialStrings;

	    $this->quoteChars=array("'","\"");
	    $this->escapeChar="\\";         
	    $this->whitespaceChars=array(" ","\n","\r","\t");   
	    $this->specialElements=$gDbTxt_sqlQuerySpecialStrings;
	    $this->removeQuotes=false;
        $this->removeEscapeChars=true;
        $this->setString($sql_query_str);
	}
	
	/***********************************
		 	Parse Dispatcher
	************************************/
	// Returns a SqlQuery Object or null if an error accoured
	function parseSqlQuery() {
		$type="";
		if(!$type=$this->parseNextElement()) 
			return null;
		$type=strtoupper($type);
		switch($type) {
			case "SELECT":
				return $this->parseSelectQuery();
			case "INSERT":
				return $this->parseInsertQuery();
			case "DELETE":
				return $this->parseDeleteQuery();
			case "UPDATE":
				return $this->parseUpdateQuery();
			case "CREATE":
				if(strtoupper($this->peekNextElement())=="TABLE") {
					$this->skipNextElement();
					return $this->parseCreateTableQuery();
				}	
				if(strtoupper($this->peekNextElement())=="DATABASE") {
					$this->skipNextElement();
					return $this->parseCreateDatabaseQuery();
				}	
				$type .= " " . $this->peekNextElement();
				break;
			case "DROP":
				if(strtoupper($this->peekNextElement())=="TABLE") {
					$this->skipNextElement();
					return $this->parseDropTableQuery();
				}	
				if(strtoupper($this->peekNextElement())=="DATABASE") {
					$this->skipNextElement();
					return $this->parseDropDatabaseQuery();
				}	
				$type .= " " . $this->peekNextElement();
				break;
			case "LIST":
				if(strtoupper($this->peekNextElement())=="TABLES") {
					$this->skipNextElement();
					return $this->parseListTablesQuery();
				}	
				$type .= " " . $this->peekNextElement();
				break;
		}
		$this->errorThrow(get_class($this),"SQL Type $type not supported",__FILE__,__LINE__);
		return null;
	}
	
	
	/***********************************
		 Select Query Parse Function
	************************************/
	
	// SELECT must be removed here (do not call this Function directly !!!)
	// returns a SqlQuery Object
	function parseSelectQuery() {
				
		$colNames=array();
		$colTables=array();
		$colAliases=array();
		$colFuncs=array();
		$fieldValues=array();
		$tables=array();
		$tableAliases=array();
		$groupColumns=array();
		$orderColumns=array();
		$orderTypes=array();
		$where_expr="";
		$distinct=0;
		$joins=array();
		
		
		// parse Distinct
		if(strtoupper($this->peekNextElement())=="DISTINCT") {
			$distinct=1;
			$this->skipNextElement();
		}
	
		
		// parse Columns
		$arrElements=array();
		$colIndex=-1;
		
		while($this->parseNextElements(",",array("FROM"),$arrElements)) {
			
			++$colIndex;
			$colNames[$colIndex]="";
			$colTables[$colIndex]="";
			$colAliases[$colIndex]="";
			$colFuncs[$colIndex]="";
			
			// FUNC() | FUNC(col) | FUNC(table.col) | FUNC(col) AS alias | FUNC(table.col) AS alias | FUNC() AS alias
			// function ?
			if(count($arrElements)>=3 && $arrElements[1]=="(") {
				$colFuncs[$colIndex]=strtoupper($arrElements[0]);
				
				// remove function from $arrElements
				array_splice($arrElements,0,2);
				$pos=array_search (")",$arrElements);
				if(!is_false($pos) && !_is_null($pos)) {
					array_splice($arrElements,$pos,1);
				}	
			}
			
			// *empty array* | col | table.col | col AS alias | table.col AS alias | AS alias
			// table ?
			if(count($arrElements)>=3 && $arrElements[1]==".") {
				$colTables[$colIndex]=$arrElements[0];
				array_splice($arrElements,0,2);
			}

			// *empty array* | col | col AS alias | AS alias
			// alias ?
			if(count($arrElements)>=3 && strtoupper($arrElements[1])=="AS") {
				$colAliases[$colIndex]=$arrElements[2];
				array_splice($arrElements,1,2);
			}

			// *empty array* | col | AS alias
			// alias on function without column
			if(count($arrElements)>=2 && strtoupper($arrElements[0])=="AS") {
				$colAliases[$colIndex]=$arrElements[1];
				array_splice($arrElements,0,2);
			}
			
			// *empty array* | col 
			// column name ? 
			if(count($arrElements)>=1) {
				$colNames[$colIndex]=$arrElements[0];
				array_splice($arrElements,0,1);
			}
			
			if(count($arrElements)>0) {
				$errStr="Unexpected Element(s): ";
				for($i=0;$i<count($arrElements);++$i) {
					$errStr.= $arrElements[$i] . " ";
				}
				$this->errorThrow(get_class($this),$errStr,__FILE__,__LINE__);
				return null;
			}
		}
		
		// skip FROM
		$this->skipNextElement();
			
		// parse Tables
		$arrElements=array();
		$tableIndex=0;
		$joinIndex=0;
		while($elem=$this->peekNextElement()) {
			$elemUpper=strtoupper($elem);
			if(in_array($elemUpper,array("GROUP","WHERE","ORDER","LIMIT",";"))) {
				break;
			}
			if($elemUpper=="AS") {
				$this->skipNextElement();
				$tableAliases[$tableIndex]=$this->parseNextElement();
				continue;
			}
			if($elemUpper=="LEFT") {
				if(!isset($joins[$joinIndex])) $joins[$joinIndex]=new Join();
				$joins[$joinIndex]->type=DBTXT_JOIN_LEFT;
				$this->skipNextElement();
				continue;
			}
			if($elemUpper=="RIGHT") {
				if(!isset($joins[$joinIndex])) $joins[$joinIndex]=new Join();
				$joins[$joinIndex]->type=DBTXT_JOIN_RIGHT;
				$this->skipNextElement();
				continue;				
			}
			if($elemUpper=="INNER") {
				if(!isset($joins[$joinIndex])) $joins[$joinIndex]=new Join();
				$joins[$joinIndex]->type=DBTXT_JOIN_INNER;
				$this->skipNextElement();
				continue;				
			}
			if($elemUpper=="JOIN") {
				if(!isset($joins[$joinIndex])) $joins[$joinIndex]=new Join();
				$joins[$joinIndex]->leftTableIndex=$tableIndex;
				$this->skipNextElement();
				$tables[++$tableIndex]=$this->parseNextElement();
				$tableAliases[$tableIndex]="";
				$joins[$joinIndex]->rightTableIndex=$tableIndex;				
				continue;
			}
			if($elemUpper=="OUTER") {
				$this->skipNextElement();
				// ignore
				continue;
			}
			if($elemUpper==",") {
				++$tableIndex;
				$this->skipNextElement();
				continue;
			}
			if($elemUpper=="ON") {
				$exprElements=array();
				$this->skipNextElement();
				$this->parseNextElements("",array(",", "GROUP","WHERE","ORDER","LIMIT",";", "LEFT", "RIGHT", "INNER", "OUTER", "JOIN"), $exprElements);
				foreach($exprElements as $exprElem) {
					// no spaces on .'s
					if($exprElem==".") {
						remove_last_char($joins[$joinIndex]->expr);
						$joins[$joinIndex]->expr .= $exprElem;
					} else {
						$joins[$joinIndex]->expr .= ($exprElem . " ");
					}
				}
				$joinIndex++;
				continue;
			}
			
			// if table is allready set its an alias without AS, else its the table name
			if(isset($tables[$tableIndex])) {
				$tableAliases[$tableIndex]=$elem;
				$this->skipNextElement();
			} else {
				$tables[$tableIndex]=$elem;
				$tableAliases[$tableIndex]="";
				$this->skipNextElement();
			}

		}
		
		
				
		// parse Where statement (Raw, because the escape-chars are needend in the ExpressionParser)
		if(strtoupper($this->peekNextElement()) == "WHERE") {
			$this->skipNextElement();
			while(!is_empty_str($elem=$this->peekNextElementRaw())) {
				if(strtoupper($elem)=="GROUP" || strtoupper($elem)=="ORDER" || $elem==";" || strtoupper($elem)=="LIMIT" )
					break;
					
				$this->skipNextElement();
		
				// no " " on points
				if($elem==".") {
					remove_last_char($where_expr);
					$where_expr .= $elem;
				} else {
					$where_expr .= $elem . " ";
				}
			}
		}
		//$this->msgThrow(get_class($this), "WHERE EXPR: $where_expr<br>",__FILE__,__LINE__);
		
		// parse GROUP BY
		$groupColumnIndex=0;
		if(strtoupper($this->peekNextElement()) == "GROUP") {
			$this->skipNextElement();
			if(strtoupper($this->parseNextElement())!="BY") {
				$this->errorThrow(get_class($this),"BY expected",__FILE__,__LINE__);
				return null;
			}
			
			while(!is_empty_str($elem=$this->peekNextElement())) {
				if($elem==";" || strtoupper($elem)=="LIMIT" || strtoupper($elem)=="ORDER")
					break;
				$this->skipNextElement();
				if($elem==",") {
					$groupColumnIndex++;
				}
				else {
					if(!isset($groupColumns[$groupColumnIndex])) 
						$groupColumns[$groupColumnIndex]=$elem;
					else
						$groupColumns[$groupColumnIndex].=$elem;
				}	
			}
		}
		
		// parse ORDER BY
		$orderColumnIndex=0;
		if(strtoupper($this->peekNextElement()) == "ORDER") {
			$this->skipNextElement();
			if(strtoupper($this->parseNextElement())!="BY") {
				$this->errorThrow(get_class($this),"BY expected",__FILE__,__LINE__);
				return null;
			}
			
			while(!is_empty_str($elem=$this->peekNextElement())) {
				if($elem==";" || strtoupper($elem)=="LIMIT")
					break;
				$this->skipNextElement();
				if($elem==",") {
					$orderColumnIndex++;
				}
				else if(strtoupper($elem)=="ASC") 
					$orderTypes[$orderColumnIndex]=DBTXT_ORDER_ASC;
				else if(strtoupper($elem)=="DESC")
					$orderTypes[$orderColumnIndex]=DBTXT_ORDER_DESC;
				else {
					if(!isset($orderColumns[$orderColumnIndex])) 
						$orderColumns[$orderColumnIndex]=$elem;
					else
						$orderColumns[$orderColumnIndex].=$elem;
					$orderTypes[$orderColumnIndex]=DBTXT_ORDER_ASC;
				}	
			}
		}
		// parse LIMIT
		$limit = array();
		if(strtoupper($this->peekNextElement()) == "LIMIT") {
			$this->skipNextElement();
			while(!is_empty_str($elem=$this->peekNextElement())) {
				if($elem==";")
					break;
				$this->skipNextElement();
				if($elem!=",") {
					$limit[] = $elem;
				}
			}
		}

		$sqlObj = new SqlQuery("SELECT", $colNames, $tables, $colAliases, $colTables, $where_expr, $groupColumns, $orderColumns, $orderTypes, $limit);
		$sqlObj->tableAliases=$tableAliases;
		$sqlObj->colFuncs=$colFuncs;
		$sqlObj->distinct=$distinct;
		$sqlObj->joins=$joins;
		
		return $sqlObj;

	}


	/***********************************
		 Insert Query Parse Function
	************************************/
	
	// INSERT must be removed here (do not call this Function directly !!!)
	// returns a SqlQuery Object
	function parseInsertQuery() {
		
		$colNames=array();
		$colTables=array();
		$colAliases=array();
		$fieldValues=array();
		$tables=array();
		$insertType="";
		
		
		// remove INTO
		if(strtoupper($this->peekNextElement())=="INTO") 
			$this->skipNextElement();
				
		// Read Table				
		$tables[0]=$this->parseNextElement();
		
		
		// Read Column Names between ()'s
		$colIndex=0;
		if($this->peekNextElement()=="(") {
			$this->skipNextElement();
			while(($elem=$this->parseNextElement())!=")") {
				if($elem==",")
					$colIndex++;
				else 
					$colNames[$colIndex]=$elem;
			}
		}
		
		
		
		// read Insert Type
		$insertType=$this->parseNextElement();
		
		switch(strtoupper($insertType)) {
			case "SET":
				// Read Columns and Values
				$colIndex=0;
				$writeToValue=false;
				while( !is_empty_str(($elem=$this->parseNextElement())) && ($elem != ";")) {
					if($elem==",") {
						$colIndex++;
						$writeToValue=false;
					} else if($elem=="=") {
						$writeToValue=true;
					} else {
						if($writeToValue) {
							if(!isset($fieldValues[$colIndex])) {
								$fieldValues[$colIndex]="";
							}
							$fieldValues[$colIndex].=$elem;
						} else {
							if(!isset($fieldValues[$colIndex])) {
								$colNames[$colIndex]="";
							}
							$colNames[$colIndex].=$elem;
						}
						
					}
				}
				break;
				
			case "VALUES":
				if($this->parseNextElement()!="(") {
					$this->errorThrow(get_class($this),"VALUES in the INSERT Statement must be in Braces \"(,)\"",__FILE__,__LINE__);
					return null;
				}
				$openBraces=1;
				$fieldValuesIndex=0;
				while( !is_empty_str(($elem=$this->parseNextElement())) && ($elem != ";")) {
										
					if($elem=="(") {
						$openBraces++;
						$fieldValues[$fieldValuesIndex].=$elem;
					} else if($elem==")") {
						$openBraces--;
						if($openBraces<1) {
							break;
						}
						$fieldValues[$fieldValuesIndex].=$elem;
					} else if($elem==",") {
						$fieldValuesIndex++;
					} else {
						if(!isset($fieldValues[$fieldValuesIndex])) {
							$fieldValues[$fieldValuesIndex]="";
						}
						$fieldValues[$fieldValuesIndex].=$elem;
					}
				}
				break;
			default:
				$this->errorThrow(get_class($this),"Insert Type " . $insertType . " not supported",__FILE__,__LINE__);
				return null;
		}
		$sqlObj = new SqlQuery();
		$sqlObj->type = "INSERT";
		$sqlObj->colNames=$colNames;
		$sqlObj->colAlias=$colAliases;
		$sqlObj->colTables=$colTables;
		$sqlObj->fieldValues=$fieldValues;
		$sqlObj->insertType=$insertType;
		$sqlObj->tables=$tables;
		
		return $sqlObj;
	}
	
	
	/***********************************
		 Delete Query Parse Function
	************************************/
	
	// DELETE must be removed here (do not call this Function directly !!!)
	// returns a SqlQuery Object
	function parseDeleteQuery() {
		
		$tables=array();
		$where_expr="";
		
		if(strtoupper($this->parseNextElement())!="FROM") {
			$this->errorThrow(get_class($this),"FROM expected",__FILE__,__LINE__);
			return null;
		}
		$tables[0]=$this->parseNextElement();
		
		// Because the Where Statement is not parsed with 
		// the parseXX Functions, this equals a Raw-Parse,
		// as needed for the ExpressionParser
		if(strtoupper($this->parseNextElement())=="WHERE") {
			$where_expr=rtrim($this->workingStr);
			//$this->msgThrow(get_class($this),"where_expr: $where_expr<br>",__FILE__,__LINE__);
			if(last_char($where_expr)==";")
				remove_last_char($where_expr);
		} else if ($elem=$this->parseNextElement()) {
			$this->errorThrow(get_class($this),"Nothing more expected: $elem",__FILE__,__LINE__);
			return null;
		}
		
		$sqlObj = new SqlQuery();
		$sqlObj->type = "DELETE";
		$sqlObj->tables=$tables;
		$sqlObj->where_expr=$where_expr;
		
		return $sqlObj;
	}
	
	
	/***********************************
		 Update Query Parse Function
	************************************/
	
	// UPDATE must be removed here (do not call this Function directly !!!)
	// returns a SqlQuery Object
	function parseUpdateQuery() {
		
		$colNames=array();
		$fieldValues=array();
		$tables=array();
		$where_expr="";
		
		// Read Table				
		$tables[0]=$this->parseNextElement();
		
		// Remove SET
		if(strtoupper($this->parseNextElement())!="SET") {
			$this->errorThrow(get_class($this),"SET expected",__FILE__,__LINE__);
			return null;
		}
		
		// Read Columns and Values
		$colIndex=0;
		$writeToValue=false;
		while( !is_empty_str(($elem=$this->parseNextElement())) && ($elem != ";") && strtoupper($elem)!="WHERE") {
			if($elem==",") {
				$colIndex++;
				$writeToValue=false;
			} else if($elem=="=") {
				$writeToValue=true;
			} else {
				if($writeToValue) {
					if(!isset($fieldValues[$colIndex])) {
						$fieldValues[$colIndex]="";
					}
					$fieldValues[$colIndex].=$elem;
				} else {
					if(!isset($colNames[$colIndex])) {
						$colNames[$colIndex]="";
					}
					$colNames[$colIndex].=$elem;
				}
			}
		}
		
		// Raw-Parse Where Statement
		if(strtoupper($elem)=="WHERE") {
			$where_expr=rtrim($this->workingStr);
			//$this->msgThrow(get_class($this),"where_expr: $where_expr<br>",__FILE__,__LINE__);
			
			if(last_char($where_expr)==";")
				remove_last_char($where_expr);
		}


		$sqlObj = new SqlQuery();
		$sqlObj->type = "UPDATE";
		$sqlObj->colNames=$colNames;
		$sqlObj->fieldValues=$fieldValues;
		$sqlObj->tables=$tables;
		$sqlObj->where_expr=$where_expr;
		
		return $sqlObj;
	}
	
	
	/***********************************
	  Create Table Query Parse Function
	************************************/
	
	// CREATE TABLE must be removed here (do not call this Function directly !!!)
	// returns a SqlQuery Object
	function parseCreateTableQuery() {
		$colNames=array();
		$colTypes=array();
		$colDefaultValues=array();
		$tables=array();
	
		$tables[0]=$this->parseNextElement();	
		
		if($this->parseNextElement()!="(") {
			$this->errorThrow(get_class($this),"( expected",__FILE__,__LINE__);
			return null;
		}

		$index=0;
		
		$arrElements=array();
		while($this->parseNextElements(",",array(";"),$arrElements)) {
			$colNames[]=$arrElements[0];
			$colTypes[]=$arrElements[1];
			if(count($arrElements)>3 && strtoupper($arrElements[2])=="DEFAULT") {
				if(has_quotes($arrElements[3]))
					remove_quotes($arrElements[3]);
				$colDefaultValues[]=$arrElements[3];
			} else {
				$colDefaultValues[]="";
			}
		}
		
	
		
		
		$sqlObj = new SqlQuery();
		$sqlObj->type = "CREATE TABLE";
		$sqlObj->colNames=$colNames;
		$sqlObj->colTypes=$colTypes;
		$sqlObj->fieldValues=$colDefaultValues;
		$sqlObj->tables=$tables;
	
		return $sqlObj;		
	}
	
	/***********************************
	  Create Database Query Parse Function
	************************************/
	
	// CREATE DATABASE must be removed here (do not call this Function directly !!!)
	// returns a SqlQuery Object
	function parseCreateDatabaseQuery() {
	
		$dbName=$this->parseNextElement();	
		
		$sqlObj = new SqlQuery();
		$sqlObj->type = "CREATE DATABASE";
		$sqlObj->colNames=array($dbName);
		return $sqlObj;		
	}
	
	/***********************************
	  Drop Database Query Parse Function
	************************************/
	
	// DROP DATABASE must be removed here (do not call this Function directly !!!)
	// returns a SqlQuery Object
	function parseDropDatabaseQuery() {
	
		$dbName=$this->parseNextElement();	
		
		$sqlObj = new SqlQuery();
		$sqlObj->type = "DROP DATABASE";
		$sqlObj->colNames=array($dbName);
		return $sqlObj;		
	}
	
	/***********************************
	  Drop Table Query Parse Function
	************************************/
	
	// DROP TABLE must be removed here (do not call this Function directly !!!)
	// returns a SqlQuery Object
	function parseDropTableQuery() {
	
		$tables=array();
		$i=0;
		

		while($this->peekNextElement() != ";" && !is_empty_str($elem=$this->parseNextElement())) {
			if($elem==",")
				++$i;
			else
				$tables[$i]=$elem;
		}
		
		$sqlObj = new SqlQuery();
		$sqlObj->type = "DROP TABLE";
		$sqlObj->colNames=$tables;
		return $sqlObj;		
	}
	
	/***********************************
	  List Tables Query Parse Function
	************************************/
	
	// LIST TABLES must be removed here (do not call this Function directly !!!)
	// returns a SqlQuery Object
	function parseListTablesQuery() {
		$sqlObj = new SqlQuery();
		$sqlObj->type = "LIST TABLES";
		
		$colNames=array();
		$colTables=array();
		$colAliases=array();
		$fieldValues=array();
		$tables=array();
		$groupColumns=array();
		$orderColumns=array();
		$orderTypes=array();
		$where_expr="";
		$distinct=0;
		
		
		// parse Where statement (Raw, because the escape-chars are needend in the ExpressionParser)
		if(strtoupper($this->peekNextElement()) == "WHERE") {
			$this->skipNextElement();
			while(!is_empty_str($elem=$this->peekNextElementRaw())) {
				if(strtoupper($elem)=="ORDER" || $elem==";" || strtoupper($elem)=="LIMIT" )
					break;
				$this->skipNextElement();
				
				// no " " on points
				if($elem==".") {
					remove_last_char($where_expr);
					$where_expr .= $elem;
				} else {
					$where_expr .= $elem . " ";
				}
			}
		}
		
		// parse ORDER BY
		$orderColumnIndex=0;
		if(strtoupper($this->peekNextElement()) == "ORDER") {
			$this->skipNextElement();
			if(strtoupper($this->parseNextElement())!="BY") {
				$this->errorThrow(get_class($this),"BY expected",__FILE__,__LINE__);
				return null;
			}
			
			while(!is_empty_str($elem=$this->peekNextElement())) {
				if($elem==";" || strtoupper($elem)=="LIMIT")
					break;
				$this->skipNextElement();
				if($elem==",") {
					$orderColumnIndex++;
				}
				else if(strtoupper($elem)=="ASC") 
					$orderTypes[$orderColumnIndex]=DBTXT_ORDER_ASC;
				else if(strtoupper($elem)=="DESC")
					$orderTypes[$orderColumnIndex]=DBTXT_ORDER_DESC;
				else {
					if(!isset($orderColumns[$orderColumnIndex])) 
						$orderColumns[$orderColumnIndex]=$elem;
					else
						$orderColumns[$orderColumnIndex].=$elem;
					$orderTypes[$orderColumnIndex]=DBTXT_ORDER_ASC;
				}	
			}
		}
		// parse LIMIT
		$limit = array();
		if(strtoupper($this->peekNextElement()) == "LIMIT") {
			$this->skipNextElement();
			while(!is_empty_str($elem=$this->peekNextElement())) {
				if($elem==";")
					break;
				$this->skipNextElement();
				if($elem!=",") {
					$limit[] = $elem;
				}
			}
		}
		
		
		$sqlObj = new SqlQuery("LIST TABLES", $colNames, $tables, $colAliases, $colTables, $where_expr, $groupColumns, $orderColumns, $orderTypes, $limit);
		return $sqlObj;		
	}

	
	/***********************************
		 	Parse Helper Functions
	************************************/
		
	// does not remove Escape Chars
	function parseNextElementRaw() {
	    $this->removeEscapeChars=false;
		$ret= $this->parseNextElement();
		$this->removeEscapeChars=true;
		return $ret;
	}
	
	// does not remove Escape Chars
	function peekNextElementRaw() {
		$this->removeEscapeChars=false;
		$ret= $this->peekNextElement();
		$this->removeEscapeChars=true;
		return $ret;
	}
	
}


/**********************************************************************
								Join
***********************************************************************/

class Join {
	var $type = DBTXT_JOIN_INNER;
	var $leftTableIndex;
	var $rightTableIndex;
	var $expr;
}

/**********************************************************************
								SqlQuery
***********************************************************************/
// Represents an SQL Query 
// Fields should be accessed directly here -> faster 

class SqlQuery {
	
	
	/***********************************
			Member variables
	************************************/

	var $type;
	
	var $colNames=array();
	var $colAliases=array();
	var $colTables=array();
	
	var $colTypes=array();		// At the Moment only used in CREATE TABLE (int, string OR inc)
								// may also used in other Queries 
	var $colFuncs=array();
	
	var $fieldValues=array(); 	// Used in: INSERT, UPDATE, CREATE TABLE (as default values)
	
	var $insertType=""; 		// Used in: INSERT ("VALUES", "SET" or "SELECT")
	
	var $groupColumns=array();	// Used by: GROUP BY
	var $distinct=0;			// will be set if SELECT query contains a DISTINCT
	
	var $orderColumns=array(); 	// Used by: ORDER BY
	var $orderTypes=array();	// Used by: ORDER BY
	
	var $tables=array();
	var $joins=array();
	var $tableAliases=array();
	var $where_expr;
	
	var $limit=array();

	
	
	
	/***********************************
				Constructor
	************************************/
	
	function SqlQuery($type="SELECT", $colNames=array(), $tables=array(), $colAliases=array(), $colTables=array(), $where_expr="", $groupColumns=array(), $orderColumns=array(),$orderTypes=array(),$limit=array()) {
	
		$this->type=$type;
		$this->colNames=$colNames;
		$this->tables=$tables;
		
		$this->where_expr=$where_expr;
		$this->colAliases=$colAliases;
		$this->colTables=$colTables;
		$this->groupColumns=$groupColumns;
		$this->orderColumns=$orderColumns;
		$this->orderTypes=$orderTypes; 
		$this->limit=$limit;
		
	}
	
	function getSize() {
		return count($this->colNames);
	}
	
	
	/***********************************
				Test
	************************************/
	// NOT Up to Date
	// Test's if the SqlQuery is valid
	// TRUE if ok, FALSE if not ok
	function test() {
				
		return true; // return true, function is outdated TODO: update
		
		reset($this->colNames);
		for($i=0;$i<count($this->colNames);++$i) {
			if($this->colNames[$i]=="*")
			{
				if($this->colAliases[$i]) {
					$this->errorThrow(get_class($this),"Cannot define Alias by a *",__FILE__,__LINE__);
					return FALSE;
				}
				continue;
			}
			if($key=array_search  ($this->colNames[$i], $this->colNames)) {
				if($i==$key)
					continue;
				if($this->colAliases[$i] == $this->colAliases[$key] && $this->colFuncs[$i]==$this->colFuncs[$key]) {
					$this->errorThrow(get_class($this),"Two Columns with the same name use no or the same alias ('" . $this->colNames[$i] . "', '" . $this->colNames[$key] . "')",__FILE__,__LINE__);
					return FALSE;
				}
				if(!$this->colTables[$i]) {
					$this->errorThrow(get_class($this),"Column " . $this->colNames[$i] . " could belong to multiple Tables",__FILE__,__LINE__);
					return FALSE;
				}
			}
		}
		reset($this->colAliases);
		for($i=0;$i<count($this->colAliases);++$i) {
			if($key=array_search  ($this->colAliases[$i], $this->colAliases)) {
				if($i==$key || $this->colAliases[$i]=="")
					continue;
				$this->errorThrow(get_class($this),"Two Columns (" . $this->colNames[$i] . ", " . $this->colNames[$key] . ") use the same alias",__FILE__,__LINE__);
				return FALSE;
			}
		}
		
		reset($this->colNames);
		// TODO: error ..?!?  SELECT nr, tabelle1.nr As nr FROM ....
		// produces no Error !
		for($i=0;$i<count($this->colAliases);++$i) {
			if(($key=array_search($this->colAliases[$i], $this->colNames))) {
				if($i==$key) {
					continue;
				}
				if($this->colAliases[$i]=="")
					continue;
					
				$this->errorThrow(get_class($this),"Alias is the name from another column (" . $this->colAliases[$i] . ")",__FILE__,__LINE__);
				return FALSE;
			}
		}
		return TRUE;
		
	}
	
	function dump() {
		echo "<pre>";
		echo "SqlQuery dump:<br>";
		echo "type:  $this->type<br>";	
		echo "<br>colNames:<br>"; 
		print_r($this->colNames);
		echo "<br>colAliases:<br>"; 
		print_r($this->colAliases);
		echo "<br>colTables:<br>"; 
		print_r($this->colTables);
		echo "<br>colTypes:<br>"; 
		print_r($this->colTypes);
		echo "<br>colFuncs:<br>"; 
		print_r($this->colFuncs);
		echo "<br>fieldValues:<br>"; 
		print_r($this->fieldValues);
		echo "<br>insertType: " . $this->insertType . "<br>"; 
		echo "<br>groupColumns:<br>"; 
		print_r($this->groupColumns);
		echo "<br>distinct: " . $this->distinct . "<br>"; 
		echo "<br>orderColumns:<br>"; 
		print_r($this->orderColumns);
		echo "<br>orderTypes:<br>"; 
		print_r($this->orderTypes);
		echo "<br>tables:<br>"; 
		print_r($this->tables);
		echo "<br>tableAliases:<br>"; 
		print_r($this->tableAliases);
		echo "<br>limit:<br>"; 
		print_r($this->limit);
		echo "<br>where_expr: " . $this->where_expr ."<br>"; 
		echo "</pre>";
	}

}

//file: blibDbTxtResultSet.class.php
/**********************************************************************
								Row
***********************************************************************/

class Row  extends blibClass{
	var $id;   			 // unique id for the row
	var $fields=array(); // fields of the row
}

/**********************************************************************
							ResultSet
***********************************************************************/

// Represents a Table
class ResultSet  extends blibClass{
	
	/***********************************
		 	Mebmer Variables
	************************************/
	// columns
	var $colNames=array();
	var $colAliases=array();
	var $colTables=array();
	var $colTableAliases=array();
	var $colTypes=array();
	var $colDefaultValues=array();
	var $colFuncs=array();
	var $colFuncsExecuted=array();
	
	// rows 
	var $rows=array();  // to use as array of type Row (see above)
	
	// position in the ResultSet
	var $pos=-1;
		
	// informations how this resultSet is ordered 
	// at the momemt only used by cmpRows()
	var $orderColNrs=array(); // Column Nr
	var $orderTypes=array();  // DBTXT_ORDER_ASC or DBTXT_ORDER_DESC
	
	
	
	/***********************************
		 	row id functions 
	************************************/
	function setRowId($rowNr, $id) {
		$this->rows[$rowNr]->id=$id;
	}
	function getRowId($rowNr) {
		return $this->rows[$rowNr]->id;
	}
	function setCurrentRowId($id) {
		$this->rows[$this->pos]->id=$id;
	}
	function getCurrentRowId() {
		return $this->rows[$this->pos]->id;
	}
	function searchRowById($id) {
		for($i=0;$i<count($this->rows);++$i) {
			if(isset($this->rows[$i]->id) && $this->rows[$i]->id==$id)
				return $i;
		}
		return DBTXT_NOT_FOUND;
	}
	
	function generateRowIds() {
		$this->reset();
		$rId=-1;
		while((++$this->pos)<count($this->rows)) {
            $this->rows[$this->pos]->id=++$rId;
		}
        --$this->pos;
	}
	
	function setAllRowIds($val) {
		$this->reset();
		while((++$this->pos)<count($this->rows)) {
            $this->rows[$this->pos]->id=$val;
		}
        --$this->pos;
	}	
   
	
	/***********************************
		 	Navigate Functions
	************************************/
	function getPos() {
		return $this->pos;
	}
	function setPos($pos) {
		$this->pos=$pos;
	}
	function reset() {
		$this->pos=-1;
	}
	// Moves to the next row and returns true if there was a next row
	// or false if there was no next row
	function next() {
		if(!isset($this->rows))
			return false;
		if(++$this->pos<count($this->rows)) 
			return true;
		else {
			$this->pos--;
			return false;
		}
	}
	
 	function prev() {
		if(--$this->pos<count($this->rows) && $this->pos>-1)
			return true;
 		else
			return false;
	}
 	function end() {
		$this->pos= count($this->rows)-1;
 	}
 	function start() {
 		$this->reset();
 	}
 	
 	// Appends a row to the ResultSet
 	function append($setDefaultValues=true) {
 		$this->pos=count($this->rows)-1;
 		if(++$this->pos!= count($this->rows)) {
 			$this->errorThrow(get_class($this),"append() failed, not at the end of the ResultSet",__FILE__,__LINE__);
 			$pos--;
 			return false;
 		}
 		$this->rows[$this->pos] = new Row;
 		if(!$setDefaultValues)
 			return;
 			
 		// Set initial values
 		for($i=0;$i<count($this->colTypes);++$i) {
 			// inc
 			if($this->colTypes[$i]==DBTXT_COL_TYPE_INC) {
 				if($this->pos==0) {
 					$this->rows[$this->pos]->fields[$i]=1;
 				} else {
 					$this->rows[$this->pos]->fields[$i]=$this->rows[$this->pos-1]->fields[$i]+1;
 				}
 			// int
 			} else if($this->colTypes[$i]==DBTXT_COL_TYPE_INT) {			
 				// make sure the default value is a number
 				$this->rows[$this->pos]->fields[$i]=intval($this->colDefaultValues[$i]);
 			// str
 			} else {
 				$this->rows[$this->pos]->fields[$i]=$this->colDefaultValues[$i];;
 			}
 		}
	}
  
  

  	/***********************************
		 	Column Functions (find)
	************************************/
	
	// Find a column by its full name, which is in the format
	// FUNC(table.column). 'FUNC' and 'table.' are voluntary. 
	// Returns the column number or DBTXT_NOT_FOUND if the column was not found
	function findColNrByFullName($fullColName) {
		$colName="";
		$colTable="";
		$colFunc="";	
		split_full_colname($fullColName,$colName,$colTable,$colFunc);
		return $this->findColNrByAttrs($colName,$colTable,$colFunc);
	}
	
	// Find a the number of a column with a SqlQuery object and an index into it
	// Returns the column number or DBTXT_NOT_FOUND if the column was not found
	function findColNrBySqlQuery(&$sqlQuery,$index) {
		$colName=($sqlQuery->colAliases[$index]?$sqlQuery->colAliases[$index]:$sqlQuery->colNames[$index]);
		return $this->findColNrByAttrs($colName,$sqlQuery->colTables[$index],$sqlQuery->colFuncs[$index]);
	}
		
	// Find a column by its attributes (name, table, function)
	// Returns the column number or DBTXT_NOT_FOUND if the column was not found
	function findColNrByAttrs($colName, $colTable, $colFunc) {
		$colFunc=strtoupper($colFunc);
		//$this->msgThrow(get_class($this),"Searching for Column: $colName, $colTable, $colFunc...&nbsp;&nbsp;&nbsp;&nbsp;",__FILE__,__LINE__);
		
		// search for colName in the alias first
		if($colName) {
			for($i=0;$i<count($this->colAliases);++$i) {
				// a column can be matched per alias, but only is the $colFunc param is ""
				// or the column functions are the same
				if($colName==$this->colAliases[$i] && 
				  (!$colFunc || $colFunc==$this->colFuncs[$i])) {
					//$this->msgThrow(get_class($this),"found at pos $i<br>",__FILE__,__LINE__);
					return $i;
				}
			}
		}
		
		// colName and colTable params are set
		if($colName && $colTable) {
			for($i=0;$i<count($this->colNames);++$i) {
				if($colName==$this->colNames[$i] && 
				  ($colTable==$this->colTables[$i] || $colTable==$this->colTableAliases[$i]) && 
				  $colFunc==$this->colFuncs[$i]) {
				  	//$this->msgThrow(get_class($this),"found at pos $i<br>",__FILE__,__LINE__);
					return $i;
				}
			}
			//$this->msgThrow(get_class($this),"NOT found!<br>",__FILE__,__LINE__);
			return DBTXT_NOT_FOUND;
		}
		
		// only with colName param is set
		if($colName) {
			for($i=0;$i<count($this->colNames);++$i) {
				if($colName==$this->colNames[$i] &&  $colFunc==$this->colFuncs[$i]) {
					//$this->msgThrow(get_class($this),"found at pos $i<br>",__FILE__,__LINE__);
					return $i;
				}
			}
			//$this->msgThrow(get_class($this),"NOT found!<br>",__FILE__,__LINE__);
			return DBTXT_NOT_FOUND;
		}
		
		// only colFunc param is set
		if($colFunc) {
			for($i=0;$i<count($this->colFuncs);++$i) {
				if($colFunc==$this->colFuncs[$i] && (!$this->colNames[$i]) && (!$this->colAliases[$i])) {
					//$this->msgThrow(get_class($this),"found at pos $i<br>",__FILE__,__LINE__);
					return $i;
				}
			}
			//$this->msgThrow(get_class($this),"NOT found!<br>",__FILE__,__LINE__);
			return DBTXT_NOT_FOUND;
		}
		//$this->msgThrow(get_class($this),"NOT found!<br>",__FILE__,__LINE__);
		return DBTXT_NOT_FOUND;
	}
	

	
	
	/***********************************
		 Column Functions (set/get)
	************************************/
	
	// names
	function getColumnNames() {
		return $this->colNames;
	}
	function setColumnNames($colNames) {
		$this->colNames=$colNames;
	}
	
	// aliases
	function getColumnAliases() {
		return $this->colAliases;
	}
	function setColumnAliases($colAliases) {
		$this->colAliases=$colAliases;
	}
	function setColumnAlias($colNr, $colAlias) {
		$this->colAliases[$colNr]=$colAlias;
	}
	
	// tables
	function getColumnTables() {
		return $this->colTables;
	}
	function setColumnTables($colTables) {
		$this->colTables=$colTables;
	}
	function setColumnTableForAll($colTable) {
		$this->colTables=create_array_fill(count($this->colNames),$colTable);
	}
	
	// table aliases
	function getColumnTableAliases() {
		return $this->colTableAliases;
	}
	function setColumnTableAliases($colTableAliases) {
		$this->colTableAliases=$colTableAliases;
	}
	function setColumnTableAliasForAll($colTableAlias) {
		$this->colTableAliases=create_array_fill(count($this->colNames),$colTableAlias);
	}
	
	// types	
	function getColumnTypes() {
		return $this->colTypes;
	}
	function setColumnTypes($colTypes) {
		$this->colTypes=$colTypes;
	}
	
	// default values
	function getColumnDefaultValues() {
		return $this->colDefaultValues;
	}
	function setColumnDefaultValues($colDefaultValues) {
		$this->colDefaultValues=$colDefaultValues;
	}
	
	// functions
	function getColumnFunctions() {
		return $this->colFuncs;
	}
	function setColumnFunctions($colFuncs) {
		$this->colFuncs=$colFuncs;
	}
	function setColumnFunction($colNr, $colFunc) {
		$this->colFuncs[$colNr]=$colFunc;
	}

	
	
	/***********************************
		 Column Functions (other)
	************************************/
	
	// copies all column data from another ResultSet
	function copyColumData($otherResultSet) {
		$this->setColumnNames($otherResultSet->getColumnNames());
		$this->setColumnAliases($otherResultSet->getColumnAliases());
		$this->setColumnTables($otherResultSet->getColumnTables());
		$this->setColumnTableAliases($otherResultSet->getColumnTableAliases());
		$this->setColumnTypes($otherResultSet->getColumnTypes());
		$this->setColumnDefaultValues($otherResultSet->getColumnDefaultValues());
		$this->setColumnFunctions($otherResultSet->getColumnFunctions());
		$this->colFuncsExecuted=$otherResultSet->colFuncsExecuted;
	}
	
	
	// Adds a Column to the ResultSet 
	function addColumn($colName, $colAlias, $colTable, $colTableAlias, $colType, $colDefaultValue, $colFunc, $value, $setValues=true) {
		
		$this->colNames[]=$colName;
		$colNr=count($this->colNames)-1;
		
		$this->colAliases[$colNr]=$colAlias;
		$this->colTables[$colNr]=$colTable;
		$this->colTableAliases[$colNr]=$colTableAlias;
		$this->colTypes[$colNr]=$colType;
		$this->colDefaultValues[$colNr]=$colDefaultValue;
		$this->colFuncs[$colNr]=$colFunc;
		$this->colFuncsExecuted[$colNr]=false;
	
		if($setValues) {
			$rowCount=count($this->rows);
			for($i=0;$i<$rowCount;++$i) {
				$this->rows[$i]->fields[$colNr]=$value;
			}
		} else {
			// set values to an empty string or we will mess up the ResultSet
			$rowCount=count($this->rows);
			for($i=0;$i<$rowCount;++$i) {
				$this->rows[$i]->fields[$colNr]="";
			}		
		}
	}
	
	// Duplicates the column $colNr (column attributes and values are duplicated)
	// not used at the moment
	function duplicateColumn($colNr){
		
		$this->colNames[]=$this->colNames[$colNr];
		$this->colAliases[]=$this->colAliases[$colNr];
		$this->colTables[]=$this->colTables[$colNr];
		$this->colTableAliases[]=$this->colTableAliases[$colNr];
		$this->colTypes[]=$this->colTypes[$colNr];
		$this->colDefaultValues[]=$this->colDefaultValues[$colNr];
		$this->colFuncs[]=$this->colFuncs[$colNr];
		$this->colFuncsExecuted[]=$this->colFuncsExecuted[$colNr];
		
		$newColNr=count($this->colNames)-1;
	
		$rowCount=count($this->rows);
		for($i=0;$i<$rowCount;++$i) {
			$this->rows[$i]->fields[$newColNr]=$this->rows[$i]->fields[$colNr];
		}
	}
	
	// Copies the column header-data and column-values from $srcColNr to $destColNr
	// not used at the moment
	function copyColumn($srcColNr, $destColNr){
		
		$this->colNames[$destColNr]=$this->colNames[$srcColNr];
		$this->colAliases[$destColNr]=$this->colAliases[$srcColNr];
		$this->colTables[$destColNr]=$this->colTables[$srcColNr];
		$this->colTableAliases[$destColNr]=$this->colTableAliases[$srcColNr];
		$this->colTypes[$destColNr]=$this->colTypes[$srcColNr];
		$this->colDefaultValues[$destColNr]=$this->colDefaultValues[$srcColNr];
		$this->colFuncs[$destColNr]=$this->colFuncs[$srcColNr];
		$this->colFuncsExecuted[$destColNr]=$this->colFuncsExecuted[$srcColNr];
	
		$rowCount=count($this->rows);
		for($i=0;$i<$rowCount;++$i) {
			$this->rows[$i]->fields[$destColNr]=$this->rows[$i]->fields[$srcColNr];
		}
	}

	
	// Removes a Column from the ResultSet.
	// After removeColumn is called, the colNr's of the other Columns change !
	function removeColumn($colNr) {
		
		// save Pos
		$tmpPos=$this->pos;
		
		$this->reset();
		while($this->next()) {
			array_splice ($this->rows[$this->pos]->fields, $colNr,1);
		}
		
		// restore Pos
		$this->pos=$tmpPos;
		
		//$this->msgThrow(get_class($this),"Removing colum nr $colNr <br>",__FILE__,__LINE__);		

		// remove in Column Data
		array_splice($this->colNames,$colNr,1);
		array_splice($this->colAliases,$colNr,1);
		array_splice($this->colTables,$colNr,1);
		array_splice($this->colTableAliases,$colNr,1);
		array_splice($this->colTypes,$colNr,1);
		array_splice($this->colDefaultValues,$colNr,1);
		array_splice($this->colFuncs,$colNr,1);
		array_splice($this->colFuncsExecuted,$colNr,1);
		
	}
	

	

	// Orders the columns (themself e.g. [Nr] [Name] [UserId] -> [Name] [Nr] [UserId])
	// by the order the columns have in the SqlQuery object
	function orderColumnsBySqlQuery(&$sqlQuery) {
		
		$newColNames=array();
		$newColAliases=array();
		$newColTables=array();
		$newColTableAliases=array();
		$newColTypes=array();
		$newColDefaultValues=array();
		$newColFuncs=array();
		$newColFuncsExecuted=array();

		
		$colPos=-1;
		$currentColumn=-1; 
		$oldRows=$this->rows;
				
		$oldColUsed=create_array_fill(count($this->colNames),false);
	
			
		if(count($sqlQuery->colNames)==1 && $sqlQuery->colNames[0]=="*" && (!$sqlQuery->colTables[0])) {
			return true;
		}
		unset($this->rows); 
		
		for($i=0;$i<count($sqlQuery->colNames);++$i) {
			++$currentColumn;
			
			// Handling for table.*
			if($sqlQuery->colNames[$i]=="*" && $sqlQuery->colTables[$i]) {
			    for($j=0;$j<count($this->colTables);++$j) {
					if(	$sqlQuery->colTables[$i] && 
					   ($sqlQuery->colTables[$i]==$this->colTables[$j] || 				   
					   $sqlQuery->colTables[$i]==$this->colTableAliases[$j])) {
						
						//$this->msgThrow(get_class($this),"transfering col " . $i . " to " . $currentColumn . "<br>",__FILE__,__LINE__);
						
						$newColNames[$currentColumn]=$this->colNames[$j];
						$newColAliases[$currentColumn]=$this->colAliases[$j];
						$newColTables[$currentColumn]=$this->colTables[$j];
						$newColTableAliases[$currentColumn]=$this->colTableAliases[$j];
						$newColTypes[$currentColumn]=$this->colTypes[$j];
						$newColDefaultValues[$currentColumn]=$this->colDefaultValues[$j];
						$newColFuncs[$currentColumn]=$this->colFuncs[$j];
						$newColFuncsExecuted[$currentColumn]=$this->colFuncsExecuted[$j];
						
						$oldColUsed[$j]=true;	
						for($k=0;$k<count($oldRows);$k++) {
							if(!isset($this->rows[$k])) { 
								$this->rows[$k] = new Row; 
							} 
							$this->rows[$k]->id=$oldRows[$k]->id;
							$this->rows[$k]->fields[$currentColumn]=$oldRows[$k]->fields[$j];
						}			
						$currentColumn++;
					}					
				}
				$currentColumn--;
				continue;	
			}
			
			
			if( ($colPos=$this->findColNrBySqlQuery($sqlQuery,$i))==-1) {
				$this->errorThrow(get_class($this),"Column '" . $sqlQuery->colNames[$i] . "' not found!! (" 
				            . $sqlQuery->colFuncs[$i] . "," .$sqlQuery->colTables[$i].",".$sqlQuery->colAliases[$i] . ")",__FILE__,__LINE__);
				return false;
			}
			//$this->msgThrow(get_class($this),"transfering col " . $colPos . " to " . $currentColumn . "<br>",__FILE__,__LINE__);
			$newColNames[$currentColumn]=$this->colNames[$colPos];
			$newColAliases[$currentColumn]=$this->colAliases[$colPos];
			$newColTables[$currentColumn]=$this->colTables[$colPos];
			$newColTableAliases[$currentColumn]=$this->colTableAliases[$colPos];
			$newColTypes[$currentColumn]=$this->colTypes[$colPos];
			$newColDefaultValues[$currentColumn]=$this->colDefaultValues[$colPos];
			$newColFuncs[$currentColumn]=$this->colFuncs[$colPos];
			$newColFuncsExecuted[$currentColumn]=$this->colFuncsExecuted[$colPos];
			
			$oldColUsed[$colPos]=true;
			
			for($j=0;$j<count($oldRows);++$j) {
				if(!isset($this->rows[$j])) { 
					$this->rows[$j] = new Row; 
				}
				$this->rows[$j]->id=$oldRows[$j]->id;
				$this->rows[$j]->fields[$currentColumn]=$oldRows[$j]->fields[$colPos];
			}			
		}
		
		// add the remaining columns to the end 
		for($i=0;$i<count($oldColUsed);++$i) {
			if(!$oldColUsed[$i]) {
				$addColPos=count($newColNames);
				
				//$this->msgThrow(get_class($this),"transfering col " . $i . " to " . $addColPos . "<br>",__FILE__,__LINE__);
				$newColNames[$addColPos]=$this->colNames[$i];
				$newColAliases[$addColPos]=$this->colAliases[$i];
				$newColTables[$addColPos]=$this->colTables[$i];
				$newColTableAliases[$addColPos]=$this->colTableAliases[$i];
				$newColTypes[$addColPos]=$this->colTypes[$i];
				$newColDefaultValues[$addColPos]=$this->colDefaultValues[$i];
				$newColFuncs[$addColPos]=$this->colFuncs[$i];
				$newColFuncsExecuted[$addColPos]=$this->colFuncsExecuted[$i];
				
				for($j=0;$j<count($oldRows);++$j) {
					if(!isset($this->rows[$j])) { 
						$this->rows[$j] = new Row; 
					}
					$this->rows[$j]->id=$oldRows[$j]->id;
					$this->rows[$j]->fields[$addColPos]=$oldRows[$j]->fields[$i];
				}	
				
			}
		}

		$this->colNames=$newColNames;
		$this->colAliases=$newColAliases;
		$this->colTables=$newColTables;
		$this->colTableAliases=$newColTableAliases;
		$this->colTypes=$newColTypes;
		$this->colDefaultValues=$newColDefaultValues;
		$this->colFuncs=$newColFuncs;
		$this->colFuncsExecuted=$newColFuncsExecuted;
		
		return true;		
	}
	
	
	// In the WHERE expression might be FUNC(col), FUNC() 
	// variants which aren't listed after SELECT.
	// This function scans a WHERE-Expression and adds the columns
	// it finds.
	// Returns true if all went ok, or false on errors
	function generateAdditionalColumnsFromWhereExpr($where_expr) {
		
		global $gDbTxt_sqlSingleRecFuncs;
		
		$parser=new SqlParser($where_expr);
		$elem="";
		$colFuncs=array();
		$colNames=array();
		$colTables=array();
		$index=-1;
		
		while(!is_empty_str($elem=$parser->parseNextElementRaw())) {
		
			// function  ?
			if(in_array(strtoupper($elem),$gDbTxt_sqlSingleRecFuncs)) {
				
				++$index;
				$colNames[$index]="";
				$colTables[$index]="";
				$colFuncs[$index]=strtoupper($elem);

				$elem=$parser->parseNextElementRaw();
				if($elem!="(") {
					$this->errorThrow(get_class($this),"( expected after $elem",__FILE__,__LINE__);
					return false;
				}
		
				while(!is_empty_str($elem=$parser->parseNextElementRaw()) && $elem!=")") {
					if($elem==".") {
						$colTables[$index]=$colNames[$index];
						$colNames[$index]=$parser->parseNextElementRaw();
					} else {
						$colNames[$index] = $elem;
					}
				}
			}
		}
		return $this->generateAdditionalColumnsFromArrays($colNames,$colTables,$colFuncs);
	}
	
	
	// This function scans an array of full column names
	// for additional FUNC() or FUNC(col) variants
	// and adds the columns it finds.
	// Returns true if all went ok, or false on errors
	function generateAdditionalColumnsFromArray($arrFullColNames) {
		$colNames=array();
		$colTables=array();
		$colFuncs=array();
		for($i=0;$i<count($arrFullColNames);++$i) {
			$colNames[$i]="";
			$colTables[$i]="";
			$colFuncs[$i]="";
			split_full_colname($arrFullColNames[$i],$colNames[$i],$colTables[$i],$colFuncs[$i]);
		}
		return $this->generateAdditionalColumnsFromArrays($colNames, $colTables, $colFuncs);
	}

	
	// This function scans arrays of column names, tables and functions 
	// for additional FUNC() or FUNC(col) variants
	// and adds the columns it finds.
	// Returns true if all went ok, or false on errors
	function generateAdditionalColumnsFromArrays($colNames, $colTables, $colFuncs) {
		if($this->blibVoiceMessages) {
			//$this->msgThrow(get_class($this),"[generateAdditionalColumnsFromArrays] Trying to add the following columns:<br>",__FILE__,__LINE__);
			print_r($colNames); echo "<br>";
			print_r($colTables); echo "<br>";
			print_r($colFuncs); echo "<br>";
		}
				
		for($i=0;$i<count($colNames);++$i) {

			// EVAL
			if($colFuncs[$i]=="EVAL") {
				//$this->msgThrow(get_class($this),"Column <b>" . $colNames[$i] . ", " . $colTables[$i]. ", " . $colFuncs[$i] . "</b> : creating EVAL column!<br>",__FILE__,__LINE__);
				$this->addColumn($colNames[$i],"","","","str","",$colFuncs[$i],"",false);
				continue;
			}

			// does this column allready exist ?
			$colNr=$this->findColNrByAttrs($colNames[$i],$colTables[$i],$colFuncs[$i]);
			if($colNr!=DBTXT_NOT_FOUND) {
				//$this->msgThrow(get_class($this),"Column <b>" . $colNames[$i] . ", " . $colTables[$i]. ", " . $colFuncs[$i] . "</b> : allready exists!<br>",__FILE__,__LINE__);
				continue;
			}
					
			// create additional columns for non-param function
			if($colFuncs[$i] && (!$colNames[$i])) {
				//$this->msgThrow(get_class($this),"Column <b>" . $colNames[$i] . ", " . $colTables[$i]. ", " . $colFuncs[$i] . "</b> : creating additional Non-param-func column!<br>",__FILE__,__LINE__);
				
				$this->addColumn("","","","","str","",$colFuncs[$i],"",false);
			
			
			// create additional column for non-column-param function
			} else if($colFuncs[$i] && $colNames[$i] && ( is_numeric($colNames[$i]) || has_quotes($colNames[$i]))) {
				//$this->msgThrow(get_class($this),"Column <b>" . $colNames[$i] . ", " . $colTables[$i]. ", " . $colFuncs[$i] . "</b> : creating additional Non-column-param-func column!<br>",__FILE__,__LINE__);
				$this->addColumn($colNames[$i],"","","","str","",$colFuncs[$i],"",false);
			} else if($colFuncs[$i] && $colNames[$i]) {
				
				//$this->msgThrow(get_class($this),"Column <b>" . $colNames[$i] . ", " . $colTables[$i]. ", " . $colFuncs[$i] . "</b> : creating additional Param-func column!<br>",__FILE__,__LINE__);

				// search column (without function)
				$colNr=$this->findColNrByAttrs($colNames[$i],$colTables[$i],"");
				if($colNr==DBTXT_NOT_FOUND) {
					//$this->msgThrow(get_class($this),"Original NOT found!<br>");
					$this->errorThrow(get_class($this),"Column '".$colNames[$i]."' not found",__FILE__,__LINE__);
					return DBTXT_NOT_FOUND;
				}
				//$this->msgThrow(get_class($this),"Original found at $colNr<br>",__FILE__,__LINE__);
				
				// add column
				$this->addColumn($this->colNames[$colNr],$this->colAliases[$colNr],$this->colTables[$colNr],$this->colTableAliases[$colNr],"str","",$colFuncs[$i],"",false);
				$newCol=count($this->colNames)-1;
				// set function for new column
				$this->colFuncs[$newCol]=$colFuncs[$i];
				
			
			// add direct values ( no function)
			} else if( !$colFuncs[$i] && $colNames[$i] && ( is_numeric($colNames[$i]) || has_quotes($colNames[$i]))) {
				//$this->msgThrow(get_class($this),"Column <b>" . $colNames[$i] . ", " . $colTables[$i]. ", " . $colFuncs[$i] . "</b> : creating direct value column!<br>",__FILE__,__LINE__);
			   	$value=$colNames[$i];
			   	if(has_quotes($value)) {
			   		remove_quotes($value);
			   	}
			   	$this->addColumn($colNames[$i],"","","","str","","",$value,true);
				
			}
		}
	}
	
	
  	/***********************************
	Row Size Functions (Field Count per Row)
	************************************/
	function getRowSize() {
		if(count($this->colNames)>0)
			return count($this->colNames);
		else
			return 0;
	}
	
	/***********************************
			Row Count Functions
	************************************/
  	function getRowCount() {
  		return (isset($this->rows) ? count($this->rows) : 0);
 	}
 	
 	
 	/***********************************
			Field Access Functions
	************************************/

 	// Get Value by Name
 	function getCurrentValueByName($colName) {
 		if(($colNr=$this->findColNrByFullName($colName))==-1)	
 			return;
 		else 			
 			return $this->rows[$this->pos]->fields[$colNr];
 	}
 	function getValueByName($rowNr,$colName) {
 		 if(($colNr=$this->findColNrByFullName($colName))==-1)	
 			return;
 		else
 			return $this->rows[$rowNr]->fields[$colNr];
 	}
 	
 	// Get Value by Nr
 	function getCurrentValueByNr($colNr) {
 		return $this->rows[$this->pos]->fields[$colNr];
 	}
 	function getValueByNr($rowNr, $colNr) {
 		return $this->rows[$rowNr]->fields[$colNr];
 	}
 	
 	// Set Value by Name 
 	function setCurrentValueByName($colName, $value) {
 		if(($colNr=$this->findColNrByFullName($colName))==DBTXT_NOT_FOUND){
 			$this->errorThrow(get_class($this),"Column '$colName' not found!",__FILE__,__LINE__);
 			return false;
 		} else {
 			$this->rows[$this->pos]->fields[$colNr] = $value;
 			return true;
 		}
 	}
 	function setValueByName($rowNr,$colName,$value) {
 		if(($colNr=$this->findColNrByFullName($colName))==DBTXT_NOT_FOUND) {
 			$this->errorThrow(get_class($this),"Column '$colName' not found!",__FILE__,__LINE__);
 			return false;
 		} else {
 			$this->rows[$rowNr]->fields[$colNr]= $value;
 			return true;
 		}
 	}
 	
 	// Set Value by Nr 
 	function setCurrentValueByNr($colNr, $value) {
 		$this->rows[$this->pos]->fields[$colNr] = $value;
 	}
 	function setValueByNr($rowNr, $colNr, $value) {
 		$this->rows[$rowNr]->fields[$colNr] = $value;
 	}
 	
 	// Get whole row
	function getCurrentValues() {
		return $this->rows[$this->pos]->fields;
	}
	function getValues($rowNr) {
		return $this->rows[$rowNr]->fields;
	}
	
	// Get whole row as hash
	function getCurrentValuesAsHash()  {
		foreach ($this->rows[$this->pos]->fields as $key => $value) {
			if ($this->colAliases[$key]) {
				$newhash[$this->colAliases[$key]]=$value; 
			} else {
				$newhash[$this->colNames[$key]]=$value; 
			}
		}
		return $newhash; 
	} 


	
	// Set whole row
	function setCurrentValues($values) {
		$this->rows[$this->pos]->fields = $values;
	}
	function setValues($rowNr,$values) {
		$this->rows[$rowNr]=$values;
	}

	// Appends a row by using an array of values
	// Here inc values wont be set, caller must supply all values !
	function appendRow($values, $id=-1) {
		
		if(count($values)==count($this->getColumnNames()))
			$setDefaults = false;
		else                                                                      
			$setDefaults = true;



		// if id is -1 do a simple append
		if($id==-1) {
			$this->append($setDefaults);
			if($setDefaults) {
				array_splice($this->rows[$this->pos]->fields,0,count($values),$values);
			} else {
				$this->rows[$this->pos]->fields=$values;
			}
			$this->rows[$this->pos]->id=$id;
		// else, if the id exists let the ResultSet untouched..
		} else if($this->searchRowById($id)==-1) {
			$this->append($setDefaults);
			if($setDefaults) {
				array_splice($this->rows[$this->pos]->fields,0,count($values),$values);
			} else {
				$this->rows[$this->pos]->fields=$values;
			}
			$this->rows[$this->pos]->id=$id;
		} 
	}
	
		
	/***********************************
			Row Delete Functions
	************************************/
	function deleteRow($rowNr) {
		array_splice ($this->rows, $rowNr,1);
	}
	function deleteCurrentRow() {
		$this->deleteRow($this->pos);
	}
	function deleteAllRows() {
		$this->rows=array();
	}
	

	/***********************************
		 	Limit Functions
	************************************/
	
	// Limit's the ResultSet
	function limitResultSet($ar_limit) {
		if(!isset($ar_limit[0]) && !isset($ar_limit[1])) return $this;
		if(count($ar_limit) == 1) {
			$ar_limit[1] = $ar_limit[0];   // because LIMIT 30 is equal to
			$ar_limit[0] = 0;              // LIMIT 0,30
		}
		
		$rowCount = $this->getRowCount();
		if ($ar_limit[0]+$ar_limit[1] > $rowCount)
			$ar_limit[1] = $rowCount - $ar_limit[0];

		$rs=new ResultSet();
		$rs->copyColumData($this);
		
		$this->pos = $ar_limit[0];         // we begin at the offset

		for($i=0; $i<$ar_limit[1]; ++$i) {
			$rs->append(0);
			
			$rs->rows[$rs->pos]->fields=$this->rows[$this->pos]->fields;
			$rs->rows[$rs->pos]->id=$this->rows[$this->pos]->id;
			
			$this->next();
		}
		return $rs;
	}

	
	/***********************************
			Group Functions
	************************************/
	
	// Groups the ResultSet by using the groupColumns in $sqlQuery
	// and $this->colFuncs.
	// If $useLimit is true $sqlQuery->limit is used to stop grouping
	// after the result contains enough rows 
	function groupRows(&$sqlQuery,$useLimit=false) {
		
		//$this->msgThrow(get_class($this),"[groupRows] Grouping rows...<br>",__FILE__,__LINE__);
		global $gDbTxt_sqlGroupingFuncs;
		$ar_limit=$sqlQuery->limit;
		$groupColumns=$sqlQuery->groupColumns;
		$groupColNrs=array();
		
		// use column numbers (faster)
		for($i=0;$i<count($groupColumns);++$i) {
			$groupColNrs[$i]=$this->findColNrByFullName($groupColumns[$i]);
			if($groupColNrs[$i]==DBTXT_NOT_FOUND) {
				$this->errorThrow(get_class($this),"Column '" . $groupColumns[$i] . "' not found!",__FILE__,__LINE__);
				return false;
			}
			
		}
		
		// calc limit
		if(!$useLimit) {
			$limit = -1;
		} else {
			if(!isset($ar_limit[0]) && !isset($ar_limit[1])) {
				$limit = -1;
			} else if(count($ar_limit) > 1) {
				$limit = $ar_limit[0]+$ar_limit[1];	
			} else {
				$limit = $ar_limit[0];
			}
		}
			
		
		$rs=new ResultSet();
		$rs->copyColumData($this);
		$groupedRows=array(); 
		$groupedValues=array();
		
		$colNamesCount=count($this->colNames);
		
		$this->reset();
		while((++$this->pos)<count($this->rows)) {
			
			// generate key
			$currentValues=array();
			foreach($groupColNrs as $groupColNr) {
				array_push($currentValues, md5($this->rows[$this->pos]->fields[$groupColNr]));
			}
			$groupedRecsKey=join("-",$currentValues);
			
			for($i=0;$i<$colNamesCount;++$i) {
				$groupedValues[$groupedRecsKey][$i][]=$this->rows[$this->pos]->fields[$i];
			}
			
			// key doesn't exist ? add record an set key into array
			if(!array_key_exists($groupedRecsKey, $groupedRows)) {
				$groupedRows[$groupedRecsKey] = 1;
				$rs->append(false);			
				$rs->rows[$rs->pos]->fields=$this->rows[$this->pos]->fields;
				$rs->rows[$rs->pos]->id=$this->rows[$this->pos]->id;
			}

			
			if($limit != -1)
				if(count($rs->rows) >= $limit)
					break;
		}
		--$this->pos;
		
		if($this->blibVoiceMessages) {
			echo "<b>RS dump in groupRows():<br></b>";
			$rs->dump();
		}
		
	
		$groupFuncSrcColNr = -1; // the source column for the column with grouping functions
		
		// calculate the result of the functions
		for($i=0;$i<count($rs->colFuncs);++$i) {
			if(in_array($rs->colFuncs[$i],$gDbTxt_sqlGroupingFuncs)) {

				if($this->blibVoiceMessages) {		
					//$this->msgThrow(get_class($this),"Searching source for grouping function " . $rs->colFuncs[$i] . "(",__FILE__,__LINE__);
					if($rs->colTables[$i]){
						//$this->msgThrow(get_class($this),$rs->colTables[$i] . ".");
					//$this->msgThrow(get_class($this),$rs->colNames[$i] . "): ");
					}
				}
				
				if($rs->colFuncs[$i]=="COUNT" && $rs->colNames[$i]=="*")  {
					$groupFuncSrcColNr=0;
				} else {
					$groupFuncSrcColNr=$this->findColNrByAttrs($rs->colNames[$i],$rs->colTables[$i],"");
				}
				
				if($groupFuncSrcColNr==DBTXT_NOT_FOUND) {
					$this->errorThrow(get_class($this),"Column " . $rs->colNames[$i] . ", " . $rs->colTables[$i] . " not found!",__FILE__,__LINE__);
					return null;
				}
				
				foreach($groupedValues as $key => $value) {
					$groupedValues[$key][$i][0]=execGroupFunc($rs->colFuncs[$i], $groupedValues[$key][$groupFuncSrcColNr]);
				}
			}
		}
		
		// put the results back
		$rs->reset();
		foreach($groupedValues as $key => $value) {
			$rs->next();
			for($i=0;$i<$colNamesCount;++$i) {
				$rs->rows[$rs->pos]->fields[$i]=$groupedValues[$key][$i][0];
			}
		}
		return $rs;
	}
	
	
	// Make's the ResultSet containg only unique values
	function makeDistinct($ar_limit) {
		
		$colNames = $this->getColumnNames();
		
		// calc limit
		if(!isset($ar_limit[0]) && !isset($ar_limit[1]))
			$limit = -1;
		else if(count($ar_limit) > 1) 
			$limit = $ar_limit[0]+$ar_limit[1];	
		else 
			$limit = $ar_limit[0];

		$rs=new ResultSet();
		$rs->copyColumData($this);

		$distinctRows=array();
		$this->reset();
		while((++$this->pos)<count($this->rows)) {
			$currentValues=array();
			foreach($colNames as $col)
				array_push($currentValues, md5($this->getCurrentValueByName($col)));
			$joinedValues=join("-",$currentValues);
			if(!array_key_exists($joinedValues, $distinctRows)) {
				$distinctRows[$joinedValues] = 1;
				$rs->append(false);
				
				$rs->rows[$rs->pos]->fields=$this->rows[$this->pos]->fields;
				$rs->rows[$rs->pos]->id=$this->rows[$this->pos]->id;
				
			}
			if($limit != -1)
				if($rs->getRowCount() >= $limit)
					break;
		}
		--$this->pos;
		return $rs;
	}


	
	/***********************************
			Filter Functions
	************************************/

	// Removes all columns which are not found in the SqlQuery object
	function filterByColumnNamesInSqlQuery(&$sqlQuery) {
		$colNrsToKeep=array();
		
		if(count($sqlQuery->colNames)==1 && $sqlQuery->colNames[0]=="*" && (!$sqlQuery->colTables[0]) && (!$sqlQuery->colFuncs[0]))
			return true;
		
		for($i=0;$i<count($sqlQuery->colNames);++$i) {
			
			// keep all of a table ?
			if($sqlQuery->colNames[$i]=="*" && $sqlQuery->colTables[$i] && (!$sqlQuery->colFuncs[$i])) {
			  	$keepAllOfTable=$sqlQuery->colTables[$i];
			  	for($j=0;$j<count($this->colTables);++$j) {
					if($this->colTables[$j]==$keepAllOfTable || $this->colTableAliases[$j]==$keepAllOfTable) {
						$colNrsToKeep[]=$j;
					}
				}  	
			} else {

				$colNr=$this->findColNrBySqlQuery($sqlQuery,$i);
				if($colNr==DBTXT_NOT_FOUND) {
					$this->errorThrow(get_class($this),"filterByColumnNames(): Column '" . $sqlQuery->colNames[$i] . "' not found",__FILE__,__LINE__);
					return null;
				} else {
					$colNrsToKeep[]=$colNr;
				}
			}
		}
		
		// remove from last element to first (because colNr's change afer a removeColumn() call
		for($i=count($this->colNames)-1;$i>=0;$i--) 
			if(!in_array($i,$colNrsToKeep))
				$this->removeColumn($i);
	}
	
	
	

	// Filters the rows by 1-n AND Conditions
	// parameters: 
	// 2 parameter arrays and 1 operator array
	// the entry in the parameter arrays can be columns or 
	// values (numbers: 1234 or strings: 'bla')
	// Return value: ResultSet with filtered Records (copy) ($this is left unchanged)
	function filterRowsByAndConditions($params1, $params2, $operators) {
		$rs=new ResultSet();
		$rs->copyColumData($this);
		
		$this->reset();
		
		$colNrs1=array();
		$colNrs2=array();
		
		// find column nr's for params1 -1=no column, its a direct value
		for($i=0;$i<count($params1);++$i) {
			if(($colNrs1[$i]=$this->findColNrByFullName($params1[$i]))==DBTXT_NOT_FOUND) {
				if(has_quotes($params1[$i]) || is_numeric($params1[$i])) {
					$colNrs1[$i]=-1;
					if(has_quotes($params1[$i])) {
						remove_quotes($params1[$i]);
					}
				} else {
					$this->errorThrow(get_class($this),"Column '" . $params1[$i] . "' not found",__FILE__,__LINE__);
					return null;
				}
			}
		}
		
		// find column nr's for params2 -1=no column, its a direct value
		for($i=0;$i<count($params2);++$i) {
			if($operators[$i] == "IN" || $operators[$i] == "NOT IN") {
				$colNrs2[$i]=-1;
				continue;			
			}
			if(($colNrs2[$i]=$this->findColNrByFullName($params2[$i]))==DBTXT_NOT_FOUND) {
				if(has_quotes($params2[$i]) || is_numeric($params2[$i])) {
					$colNrs2[$i]=-1;
					if(has_quotes($params2[$i])) {
						remove_quotes($params2[$i]);
					}
				} else {
					$this->errorThrow(get_class($this),"Column '" . $params2[$i] . "' not found",__FILE__,__LINE__);
					return null;
				}
			}
		}
		
		$val1="";
		$val2="";			
		$this->reset();
		while((++$this->pos)<count($this->rows)) {
			$recMetsConds=true;
			for($i=0;$i<count($params1);++$i) {
				
				if($colNrs1[$i]==-1) {
					$val1=$params1[$i];
				} else {
					$val1=$this->rows[$this->pos]->fields[$colNrs1[$i]];
				}
				
				if($colNrs2[$i]==-1) {
					$val2=$params2[$i];
				} else {
					$val2=$this->rows[$this->pos]->fields[$colNrs2[$i]];
				}
				
				if(!compare($val1,$val2,$operators[$i])) {
					$recMetsConds=false;
					break;
				}
			}
			
			if($recMetsConds) {
				$rs->append(false);
				
				$rs->rows[$rs->pos]->fields=$this->rows[$this->pos]->fields;
				$rs->rows[$rs->pos]->id=$this->rows[$this->pos]->id;
			}
		}
		// reset ResultSet's
		$this->reset();
		$rs->reset();
		return $rs;
	}

	
	// Removes all rows from $this, which are not contained
	// in $otherResultSet. 
	// The $rows->id var is used to check if 2 Rows match.
	// parameter: $otherResultSet with !! row->id's set !!
	function filterResultSetAndWithAnother(&$otherResultSet) {	
		$this->reset();
		while($this->next()) {
			if($otherResultSet->searchRowById($this->getCurrentRowId())==DBTXT_NOT_FOUND) {
				$this->deleteCurrentRow();
				$this->prev(); // Because the current Row was deleted, check again at this position
			}
		}		
	}
	
	
	



	/***********************************
			ResultSet join Functions
	************************************/

	// Returns a ResultSet which contains the columns and rows
	// of $this and $otherResultSet (a new ResultSet is returned).
	// The ResultSet itself ($this) is left unchanged.
	// For each row in $this each row in $otherResultSet will be duplicated
	// Example:
	// 1	Test	Hello
	// 2 	Test2	Hello2 
	//  joined with
	// 10	Blabla
	// 11 	Foo_Bar
	// 13   Bar_foo
	//  results in
	// 1	Test	Hello	10	Blabla
	// 1	Test	Hello	11	Foo_Bar
	// 1	Test	Hello	13	Bar_foo
	// 2 	Test2	Hello2 	10	Blabla
	// 2 	Test2	Hello2 	11	Foo_Bar
	// 2 	Test2	Hello2 	13	Bar_foo
	//
	// useRowIdsOf: 0=this, 1=other
	function joinWithResultSet(&$otherResultSet, $useRowIdsOf=0) {

		if($this->getRowCount()<1) {
			//$this->msgThrow(get_class($this),"Joining emtpy ResultSet (results in empty ResultSet)",__FILE__,__LINE__);
		}
			
		$newResultSet=new ResultSet();
		// columns
		$newResultSet->setColumnNames(array_merge ($this->getColumnNames(), $otherResultSet->getColumnNames()));
		$newResultSet->setColumnAliases(array_merge ($this->getColumnAliases(), $otherResultSet->getColumnAliases()));
		$newResultSet->setColumnTables(array_merge ($this->getColumnTables(), $otherResultSet->getColumnTables()));
		$newResultSet->setColumnTableAliases(array_merge ($this->getColumnTableAliases(), $otherResultSet->getColumnTableAliases()));
		$newResultSet->setColumnTypes(array_merge ($this->getColumnTypes(), $otherResultSet->getColumnTypes()));
		$newResultSet->setColumnDefaultValues(array_merge ($this->getColumnDefaultValues(), $otherResultSet->getColumnDefaultValues()));
		$newResultSet->setColumnFunctions(array_merge ($this->getColumnFunctions(), $otherResultSet->getColumnFunctions()));
		$newResultSet->colFuncsExecuted=(array_merge ($this->colFuncsExecuted, $otherResultSet->colFuncsExecuted));
		

		$otherResultSet->reset();
		$this->reset();
		$newResultSet->reset();
		
		while($this->next()) {
			$otherResultSet->reset();
			while($otherResultSet->next()) {
				$row=array_merge($this->getCurrentValues(),$otherResultSet->getCurrentValues());
				if($useRowIdsOf==1) {
					
					$newResultSet->append(false);
					$newResultSet->rows[$newResultSet->pos]->fields=$row;
					$newResultSet->rows[$newResultSet->pos]->id=$otherResultSet->rows[$otherResultSet->pos]->id;		
					
				} else {
					
					$newResultSet->append(false);
					$newResultSet->rows[$newResultSet->pos]->fields=$row;
					$newResultSet->rows[$newResultSet->pos]->id=$this->rows[$this->pos]->id;
				} 
			}
		}
		
		return $newResultSet;
		
	}	
	
	
	
	
	function copy() {

		$newResultSet=new ResultSet();
		$newResultSet->copyColumData($this);
		$this->reset();
		$newResultSet->reset();
		
		while($this->next()) {
			$newResultSet->appendRow($this->rows[$this->pos]->fields, $this->rows[$this->pos]->id);
		}
		
		return $newResultSet;
	}	
	
	function addMissingRows(&$otherResultSet) {
		$otherResultSet->reset();
		$colCount = count($this->colNames);
		
		while($otherResultSet->next()) {
			$id=$otherResultSet->rows[$otherResultSet->pos]->id;
			$this->reset();
			while($this->next()) {
				if($this->rows[$this->pos]->id == $id) {
					continue 2;
				}
			}
			$this->append(false);
			$this->rows[$this->pos]->fields=create_array_fill($colCount,"");
			for($i=0;$i<count($otherResultSet->colNames);$i++) {
				$this->setCurrentValueByName($otherResultSet->colTables[$i] . "." . $otherResultSet->colNames[$i], $otherResultSet->getCurrentValueByNr($i));
			}
		}
	}
	
	/***********************************
			Row Order Functions
	************************************/
	// Order the rows in the ResultSet 
	// Parameters:
	// $orderCols an array of full column names to order
	// $orderTypes type of order for the column (DBTXT_ORDER_ASC or DBTXT_ORDER_DESC)
	// returns false on errors
	function orderRows($orderCols,$orderTypes) {
		
		// return if the ResultSet size is 0
		if(count($this->rows)<1)
			return;
		
		$colNrs=array();
		for($i=0;$i<count($orderCols);++$i) {
			if(($colNrs[$i]=$this->findColNrByFullName($orderCols[$i]))==DBTXT_NOT_FOUND) {
				$this->errorThrow(get_class($this),"orderRows(): Column '" . $orderCols[$i] . "' not found",__FILE__,__LINE__);
				return false;
			}
		}
		
		$evalString="";
		$sortArray=array();
		for($i=0;$i<count($colNrs);++$i) {
			$currentCol=$colNrs[$i];
			foreach ($this->rows as $val) {
				if(DBTXT_ORDER_CASE_SENSITIVE)
					$sortArray[$i][] = $val->fields[$currentCol];
				else
					$sortArray[$i][] = strtolower($val->fields[$currentCol]);
			}
			if($orderTypes[$i] == DBTXT_ORDER_ASC)
				$evalString .= "\$sortArray[".$i."], SORT_ASC, ";
			else
				$evalString .= "\$sortArray[".$i."], SORT_DESC, ";
		}
		
		$evalString = "array_multisort(".$evalString."\$this->rows);";
		eval($evalString);
		return true;
	}



	/***********************************
		  'SQL Functions' Functions
	************************************/
	
	// Executes all functions in the ResultSet which have no grouping behavior.
	// Only function for columns where colFuncsExecuted is false are executed.
	function executeSingleRecFuncs() {
		global $gDbTxt_sqlSingleRecFuncs;
		global $gDbTxt_sqlMathOps;

		//$this->msgThrow(get_class($this),"[executeSingleRecFuncs] executing singlerec functions...<br>",__FILE__,__LINE__);
		for($i=0;$i<count($this->colFuncs);++$i) {
			
			if(!$this->colFuncs[$i] || $this->colFuncsExecuted[$i])
				continue;
			
			if(!in_array($this->colFuncs[$i],$gDbTxt_sqlSingleRecFuncs))
				continue;
					
			//$this->msgThrow(get_class($this),$this->colFuncs[$i] . "(" . $this->colNames[$i] . "): ",__FILE__,__LINE__);
			

			// EVAL
			if($this->colFuncs[$i]=="EVAL") {

				$eval_str=$this->colNames[$i];
				$out_str="";
				if(has_quotes($eval_str)) {
					remove_quotes($eval_str);
				}
				//$this->msgThrow(get_class($this),"EVAL function, eval String is $eval_str!<br>",__FILE__,__LINE__);
				$sp=new StringParser();
				$sp->specialElements=$gDbTxt_sqlMathOps;
				$sp->setString($eval_str);
				while(!is_empty_str($elem=$sp->parseNextElement())) {
					//$this->msgThrow(get_class($this),"ELEM: $elem\n",__FILE__,__LINE__);
					if(is_numeric($elem) || in_array($elem,$gDbTxt_sqlMathOps)) {
						$out_str.= ($elem. " ");
					} else {
						$origColNr=$this->findColNrByAttrs($elem, "", "");
						if($origColNr==DBTXT_NOT_FOUND) {
							$this->errorThrow(get_class($this),"EVAL: Column '" . $elem . "' not found!",__FILE__,__LINE__);
							return false;
						}
						$out_str.="%$origColNr%";
					}
				}
				//$this->msgThrow(get_class($this),"New Eval String: $out_str\n",__FILE__,__LINE__);
				$val_str="";
				// apply function (use values from the original column as input)
				$rowCount=count($this->rows);
				$colCount=count($this->colNames);
				for($j=0;$j<$rowCount;++$j) {
					$val_str=$out_str;
					for($k=0;$k<$colCount;++$k) {
						if(!is_false(strpos($val_str,"%$k%"))) {
							$val_str=str_replace("%$k%",$this->rows[$j]->fields[$k],$val_str);
						}
					}
					//$this->msgThrow(get_class($this),"VAL_STR=$val_str\n",__FILE__,__LINE__);
					$this->rows[$j]->fields[$i]=execFunc($this->colFuncs[$i], $val_str);
				}
				$this->colFuncsExecuted[$i]=true;



			// function with paramater, but the parameter is not a column
			} else if($this->colNames[$i] && !is_empty_str($this->colNames[$i]) && (is_numeric($this->colNames[$i]) || has_quotes($this->colNames[$i]))) {
				$param=$this->colNames[$i];
				if(has_quotes($param))
					remove_quotes($param);
				$result=execFunc($this->colFuncs[$i],$param);
				$rowCount=count($this->rows);

				//$this->msgThrow(get_class($this),"a function with a non-column parameter! (result=$result)<br>",__FILE__,__LINE__);
				for($j=0;$j<$rowCount;++$j) {
					$this->rows[$j]->fields[$i]=$result;
				}
				$this->colFuncsExecuted[$i]=true;
			
			
			// function with parameter? =>execute function with the values form the original column
			} else if($this->colNames[$i]) {

				//$this->msgThrow(get_class($this),"a function with a column parameter!<br>",__FILE__,__LINE__);

				// find original column (without function)
				$origColNr=$this->findColNrByAttrs($this->colNames[$i], $this->colTables[$i], "");
				if($origColNr==DBTXT_NOT_FOUND) {
					$this->errorThrow(get_class($this),"Column '" . $this->colNames[$i] . "' not found!",__FILE__,__LINE__);
					return false;
				}
				
				// copy some column header data from the original
				$this->colTables[$i]=$this->colTables[$origColNr];
				$this->colTableAliases[$i]=$this->colTableAliases[$origColNr];

				// apply function (use values from the original column as input)					 
				$rowCount=count($this->rows);
				for($j=0;$j<$rowCount;++$j) {
					$this->rows[$j]->fields[$i]=execFunc($this->colFuncs[$i], $this->rows[$j]->fields[$origColNr]);
				}
				$this->colFuncsExecuted[$i]=true;

			// function without parameter: just execute!
			} else {
				//$this->msgThrow(get_class($this),"a function with no parameters!<br>",__FILE__,__LINE__);
				$result=execFunc($this->colFuncs[$i],"");
				$rowCount=count($this->rows);
				for($j=0;$j<$rowCount;++$j) {
					$this->rows[$j]->fields[$i]=$result;
				}
				$this->colFuncsExecuted[$i]=true;
			}
		}
	}
	
	
	

	/***********************************
			Debug Functions
	************************************/

	// Dump's the ResultSet
	function dump() {
		$size=35;
		$format="%-" . $size . "s";
		$id_size=5;
		$id_format="%-" . $id_size ."s";
		
		
		echo "<pre><b><i>ResultSet dump (Row Count: " . $this->getRowCount() . ")</b></i><br>";
		echo "<br><b>";

		printf($id_format,"ID");		
		// Column Names
		reset($this->colNames);
		while (list ($key, $val) = each ($this->colNames))
			printf($format, "$val");			
		echo "</b><br>";
		
		printf($id_format,"");
		reset($this->colNames);
		while (list ($key, $val) = each ($this->colNames))  {
			printf($format, "(al=" .$this->colAliases[$key] . ", tbl=". $this->colTables[$key] . ", tba=" .$this->colTableAliases[$key] . ")");			
		}
		echo "<br>";
		
		printf($id_format,"");
		reset($this->colNames);
		while (list ($key, $val) = each ($this->colNames))  {
			printf($format, "(ty=". $this->colTypes[$key]  .", def=". $this->colDefaultValues[$key] .", fnc=". $this->colFuncs[$key] .", ex=". $this->colFuncsExecuted[$key] . ")");			
		}
		echo "<br>";

		printf("%'-" . $id_size . "s","|");
		
		for($i=0;$i<count($this->colNames);++$i)
			printf("%'-" . $size . "s","|");
		echo "<br><br>";
		
		$this->reset();
		
		if(!isset($this->rows))
			return;
		
		while($this->next()) {
			reset($this->rows[$this->pos]->fields);
			if(isset($this->rows[$this->pos]->id))
				printf($id_format,$this->rows[$this->pos]->id . ": ");
			while (list ($key, $val) = each ($this->rows[$this->pos]->fields)) 
				printf($format, "$val");			
			
			echo "<br>";
		}
		echo "</pre>";
		$this->reset();
	}
}


/**********************************************************************
							ResultSetParser
***********************************************************************/

// Used to parse a ResultSet object from and into text-files
class ResultSetParser  extends blibClass{
	
	var $escapeCodeWrite;
	var $replaceWithWrite;
	
	var $escapeCodeRead;
	var $replaceWithRead; 
	
	
	/***********************************
			Line Parse Functions
	************************************/
	
	function ResultSetParser() {
		$this->escapeCodeRead=array(DBTXT_TABLE_FILE_ESCAPE_CHAR."h", 
									DBTXT_TABLE_FILE_ESCAPE_CHAR."n",
									DBTXT_TABLE_FILE_ESCAPE_CHAR."r", 
									DBTXT_TABLE_FILE_ESCAPE_CHAR."p");
		
		$this->replaceWithRead=array(DBTXT_COLUMN_SEPARATOR_CHAR, "\n", "\r", DBTXT_TABLE_FILE_ESCAPE_CHAR);
		
		$this->escapeCodeWrite=array_reverse($this->escapeCodeRead);
		$this->replaceWithWrite=array_reverse($this->replaceWithRead);

		
	}

	/***********************************
			Line Parse Functions
	************************************/
	
	function parseRowFromLine($line) {
		if(strlen(trim($line))==0)
			return false;
		
		// handle Windows \x0D\x0A (\r\n) newlines
		$line=rtrim($line);
		$row=explode(DBTXT_COLUMN_SEPARATOR_CHAR, $line);
				
		$row=str_replace($this->escapeCodeRead, $this->replaceWithRead, $row);
		
		return $row;
	}
	

	function parseLineFromRow($row) {
				
		$row=str_replace($this->replaceWithWrite, $this->escapeCodeWrite, $row);
		return implode(DBTXT_COLUMN_SEPARATOR_CHAR, $row);
			
	}



	/***********************************
			File Parse Functions
	************************************/
	
	// $fd must be a file descriptor (returned by fopen)
	function parseResultSetFromFile($fd) {
		
		$start=getmicrotime();
		
		$rs = new ResultSet();

		// read in the whole file
		fseek($fd,0,SEEK_END);
		$size=ftell($fd);
		fseek($fd,0,SEEK_SET);
		$wholeFile=fread($fd,$size);
				
		$lines=explode("\n",$wholeFile);
		unset($wholeFile); 
		$wholeFile="";
		
		$rec=$this->parseRowFromLine($lines[0]);
   		$rs->setColumnNames($rec);
   		
   		$rec=$this->parseRowFromLine($lines[1]);
   		$rs->setColumnTypes($rec);
   		
   		$rec=$this->parseRowFromLine($lines[2]);
   		$rs->setColumnDefaultValues($rec);
   		
   		$rs->reset();
   		
		$lineCount=count($lines);
  		for($i=3;$i<$lineCount;++$i) {
  			
  			//$rec=$this->parseRowFromLine($lines[$i]);		
  			//inlining function parseRowFromLine() for better performance
  			$line = $lines[$i];
            if(strlen(trim($line))==0)
                continue;
                    
            // handle Windows \x0D\x0A (\r\n) newlines
            $line=rtrim($line);
            $rec=explode(DBTXT_COLUMN_SEPARATOR_CHAR, $line);
            
            $rec=str_replace($this->escapeCodeRead, $this->replaceWithRead, $rec);
    
    		
			if(count($rec)==count($rs->colNames))
                $setDefaults = false;
            else                                                                      
                $setDefaults = true;  
        
        	if($rec) {
            	$rs->append($setDefaults);
            	$rs->rows[$rs->pos]->fields=$rec;
            	$rs->rows[$rs->pos]->id=-1;
  			}

  		}
  		//$this->msgThrow(get_class($this),"<i>II: parseResultSetFromFile: " . (getmicrotime() - $start) . " seconds elapsed</i><br>",__FILE__,__LINE__);

  		$rs->setColumnAliases(create_array_fill(count($rs->colNames),""));
  		$rs->setColumnTables(create_array_fill(count($rs->colNames),""));
  		$rs->setColumnTableAliases(create_array_fill(count($rs->colNames),""));
  		$rs->setColumnFunctions(create_array_fill(count($rs->colNames),""));
  		$rs->colFuncsExecuted=create_array_fill(count($rs->colNames),false);
	
		return $rs;	
	}
	
	
	
	// $fd must be a file descriptor (returned by fopen)
	function parseResultSetIntoFile($fd, &$resultSet) {
    
    	//$this->msgThrow(get_class($this), "parseResultSetIntoFileFD<br>",__FILE__,__LINE__);

		// now set file pointer at the beginning
		fseek($fd,0,SEEK_SET);

		$fwriteFails = 0;
		if(!fwrite($fd, $this->parseLineFromRow($resultSet->getColumnNames())."\n"))
			$fwriteFails = 1;
		
		if(!fwrite($fd, $this->parseLineFromRow($resultSet->getColumnTypes())."\n"))
			$fwriteFails = 1;
		
		if(!fwrite($fd, $this->parseLineFromRow($resultSet->getColumnDefaultValues())."\n"))
			$fwriteFails = 1;
		
		$resultSet->reset();
		while($resultSet->next()) {
			if(!fwrite($fd, $this->parseLineFromRow($resultSet->getCurrentValues())))
				$fwriteFails = 1;
			
			if($resultSet->getPos()<$resultSet->getRowCount()-1)
				if(!fwrite($fd, "\n"))
					$fwriteFails = 1;
		}
		
		if (!$fwriteFails)
			ftruncate($fd, ftell($fd));
	}
	
	
	// $fd must be a file descriptor (returned by fopen)
	// Parses only the column names, data types, default values and
	// some of the last rows so the ResultSet can be used to append records.
	function parseResultSetFromFileForAppend($fd) {
		
		$start=getmicrotime();
		$rs=new ResultSet();
		
		
		// COLUMN NAMES
		
		// read with a maximum of 1000 bytes, until there is a newline included (or eof)
		$buf="";
		while(is_false(strstr($buf,"\n"))) {
		    $buf.=fgets($fd,1000);
		    if(feof($fd)) {
		        $this->errorThrow(get_class($this),"Invalid Table File!<br>",__FILE__,__LINE__);
		        return null;
		    }
		}
		// remove newline
		remove_last_char($buf);
		
		$rec=$this->parseRowFromLine($buf);
   		$rs->setColumnNames($rec);
   		
   		
   		
   		// COLUMN TYPES
   		
   		// read with a maximum of 1000 bytes, until there is a newline included (or eof)
   		$buf="";
		while(is_false(strstr($buf,"\n"))) {
		    $buf.=fgets($fd,1000);
		    if(feof($fd)) {
				$this->errorThrow(get_class($this),"Invalid Table File!<br>",__FILE__,__LINE__);
		        return null;
		    }
		}
		
		// remove newline
		remove_last_char($buf);
			
		$rec=$this->parseRowFromLine($buf);
   		$rs->setColumnTypes($rec);
   		
   		
   		// COLUMN DEFAULT VALUES
   		
   		// read with a maximum of 1000 bytes, until there is a newline included (or eof)
   		$buf="";
		while(is_false(strstr($buf,"\n"))) {
		    $buf.=fgets($fd,1000);
		    if(feof($fd)) {
		        break; // there's no newline after the colum types => empty table
		    }
		}
		
		// remove newline
		if(last_char($buf)=="\n")
			remove_last_char($buf);
			
			
		$rec=$this->parseRowFromLine($buf);
   		$rs->setColumnDefaultValues($rec);
   		
   		
   		// get file size		
		fseek($fd,0,SEEK_END);
		$size=ftell($fd);
		$lastRecSize=min($size,DBTXT_ASSUMED_RECORD_SIZE);
		
		$lastRecPos=false;
		while(is_false($lastRecPos)) {
		    fseek($fd,-$lastRecSize,SEEK_END);
		    $buf=fread($fd,$lastRecSize);
		    $lastRecSize=$lastRecSize*2;
		    $lastRecSize=min($size,$lastRecSize);
			if($lastRecSize<1) {
				$this->errorThrow(get_class($this),"lastRecSize should not be 0! Contact developer please!",__FILE__,__LINE__);
			}
		    $lastRecPos=$this->getLastRecordPosInString($buf);
		    if($this->blibVoiceMessages) {
		        echo "<hr>pass! <br>";
		        echo "lastRecPos: " . $lastRecPos . "<br>";
		        echo "buf: " . $buf . "<br>";
            }
		    
		    
		}		
		
		$buf=trim(substr($buf,$lastRecPos));
		
		//$this->msgThrow(get_class($this),"buf after substr() and trim(): " . $buf . "<br>",__FILE__,__LINE__);
		   		
   		$rs->reset();
   		$row=$this->parseRowFromLine($buf);
   		
   		if($this->blibVoiceMessages) {
   		    echo "parseResultSetFromFileForAppend(): last Row:<br>";
   		    print_r($row);
   		    echo "<br>";
        }
        
   		
   		$rs->appendRow($row);	
   		
   		$rs->setColumnAliases(create_array_fill(count($rs->colNames),""));
  		$rs->setColumnTables(create_array_fill(count($rs->colNames),""));
  		$rs->setColumnTableAliases(create_array_fill(count($rs->colNames),""));
  		$rs->setColumnFunctions(create_array_fill(count($rs->colNames),""));
  		$rs->colFuncsExecuted=create_array_fill(count($rs->colNames),false);
   	
   		//$this->msgThrow(get_class($this),"<i>III: parseResultSetFromFileForAppend: " . (getmicrotime() - $start) . " seconds elapsed</i><br>",__FILE__,__LINE__);
   		
  		return $rs;	
	}
	
	
	// $fd must be a file descriptor (returned by fopen)
	function parseResultSetIntoFileAppend($fd, &$resultSet) {

    	fwrite($fd, "\n");
		$resultSet->reset();
		while($resultSet->next()) {
			fwrite($fd, $this->parseLineFromRow($resultSet->getCurrentValues()));
			
			if($resultSet->getPos()<$resultSet->getRowCount()-1)
				fwrite($fd, "\n");
		}		
	}
	
	// Returns an offset into $str where the last record begins.
	// If $str doesn't contain one valid record false is returned.
	// (Attention: may also return 0, which has not the same meaning as
	// false)
	function getLastRecordPosInString($str) {
	   
	    // contains other chars then whitespaces ?
	    if(strlen(trim($str))==0)
            return false;
        
        $pos=strlen($str)-1;
        
        while($str{$pos}=="\n" || $str{$pos}=="\r" || $str{$pos}=="\t" || $str{$pos}==" ") {
        	--$pos;
        	if($pos==-1)
        		return false;
        }
        while($str{$pos}!="\n" && $str{$pos}!="\r") {
        	--$pos;
        	if($pos==-1)
        		return false;
        }
        return $pos+1;
    }
	
}	

//file: blibDbTxt.class.php
/**
* Plain-text Database SQL Abstraction Layer
*/

// Define User Settings
define("DBTXT_LIKE_CASE_SENSITIVE",0);
define("DBTXT_ORDER_CASE_SENSITIVE",0);

define("DBTXT_ASSUMED_RECORD_SIZE",30);
define("DBTXT_NOT_FOUND",-1);

// File parsing
define("DBTXT_COLUMN_SEPARATOR_CHAR",'#');	// Char which seperates the columns in the table file
define("DBTXT_TABLE_FILE_ESCAPE_CHAR",'%'); 	// Char to Escape DBTXT_COLUMN_SEPARATOR_CHAR in the Table Files
define("DBTXT_TABLE_FILE_OPEN_MODE",'b'); 	// "b" or ""

// Timeouts
define("DBTXT_OPEN_TIMEOUT",10); 		// Timeout in seconds to try opening a still locked Table
define("DBTXT_LOCK_TIMEOUT",10); 		// Timeout in seconds to try locking a still locked Table
define("DBTXT_LOCKFILE_TIMEOUT",30); 	// Timeout for the maximum time a lockfile can exist

// Order Types
define("DBTXT_ORDER_ASC",1);
define("DBTXT_ORDER_DESC",2);

// Join Types
define("DBTXT_JOIN_INNER",1);
define("DBTXT_JOIN_LEFT",2);
define("DBTXT_JOIN_RIGHT",3);

// Row Flags
define("DBTXT_FLAG_KEEP",0x1);

// Column Types
define("DBTXT_COL_TYPE_INC","inc");
define("DBTXT_COL_TYPE_INT","int");
define("DBTXT_COL_TYPE_STRING","str");

// Column Function Types
define("DBTXT_COL_FUNC_TYPE_SINGLEREC",1);
define("DBTXT_COL_FUNC_TYPE_GROUPING",2);

// File Extensions
define("DBTXT_TABLE_FILE_EXT",".txt");
define("DBTXT_LOCK_FILE_EXT",".lock");
  
// Predefined Databases
define("DBTXT_ROOT_DATABASE","");

class blibDbTxt extends blibClass{
  var $dbDir = '';         //Databases folder
  var $dbFolder = '';         //Database name
  var $sqlInsertId = 0;       //In case INSERT|REPLACE query is passed, holds inserted row last ID.

  /**
  * class initialization routine
  */
  function init($dbDir, $dbName) {
		$this->dbDir = $dbDir;
		$this->dbFolder = $this->dbDir.$dbName;
		if(last_char($this->dbFolder) != "/")
			$this->dbFolder .= "/";
	}
	
	/*
	* Insert ID Functions
	*/
	function updatesqlInsertId($resultSet) { 
		$resultSet->end();
		for($i=0;$i<count($resultSet->colTypes);++$i) { 
			if($resultSet->colTypes[$i]==DBTXT_COL_TYPE_INC) { 
				$this->sqlInsertId=$resultSet->getCurrentValueByNr($i); 
				$this->msgThrow(get_class($this),"Setting sqlInsertId to " . $this->sqlInsertId ,__FILE__,__LINE__);
				return; 
			} 
		} 
       // if no inc column exists set sqlInsertId to 0 
       $this->sqlInsertId=0; 
       $this->msgThrow(get_class($this),"Setting sqlInsertId to " . $this->sqlInsertId ,__FILE__,__LINE__);
  } 
    
	function getsqlInsertId() {
		return $this->sqlInsertId;
	}	
	
	/*
	*	Table open/close functions
	*/

	// Does open a Table for writing
	function openTableWrite($tableName) {
		$this->msgThrow(get_class($this),"openTableWrite<br>",__FILE__,__LINE__);
		$filename = $this->dbFolder . $tableName . DBTXT_TABLE_FILE_EXT;
		
		$fp= fopen ($filename, "r+".DBTXT_TABLE_FILE_OPEN_MODE);
		if(!$fp) {
			return 0;
		}
		while(!flock($fp, LOCK_EX)) {
			usleep(50);
		}
		return $fp;
	}


	// same rules as for openTableWrite()
	// does open a table for appending
	function openTableAppend($tableName) {
		$this->msgThrow(get_class($this),"openTableAppend<br>",__FILE__,__LINE__);
		$filename = $this->dbFolder . $tableName . DBTXT_TABLE_FILE_EXT;

		$fp=fopen ($filename, "a".DBTXT_TABLE_FILE_OPEN_MODE);
		if(!$fp) {
			return 0;
		}
		while(!flock($fp, LOCK_EX)) {
			usleep(50);
		}

		return $fp;
	}

	// Opens a Table for reading
	// This function is used by SELECT
	// returns a FilePointer or false
	function openTableRead($tableName) {
		$this->msgThrow(get_class($this),"openTableRead<br>",__FILE__,__LINE__);
		$filename = $this->dbFolder . $tableName . DBTXT_TABLE_FILE_EXT;
    $this->msgThrow(get_class($this),"Table $tableName opened (READ)<br>",__FILE__,__LINE__);

		if(!file_exists($filename)) return 0;

		$fp=fopen ($filename, "r".DBTXT_TABLE_FILE_OPEN_MODE);
		if (!$fp) return 0;
		
		while(!flock($fp, LOCK_SH)) {
			usleep(50);
		}

		return $fp;
	}
	
	// Closes a Table 
	function closeTable($fp) {
		$this->msgThrow(get_class($this),"Table $fp closed<br>",__FILE__,__LINE__);
		while(!flock($fp, LOCK_UN)) {
			usleep(50);
		}
		return fclose($fp);		
	}
	
	/*
	*	Table read-write functions
	*/

	// Reads a Table into a ResultSet
	// Returns a ResultSet or null (the function opens an closes the file itself)
	function readTable($tableName) {
		$this->msgThrow(get_class($this),"readTable<br>",__FILE__,__LINE__);
		$parser= new ResultSetParser();
		if(!($fd=$this->openTableRead($tableName))) {
			$this->errorThrow(get_class($this),"readTable(): Cannot open Table $tableName",__FILE__,__LINE__);
			return null;
		}
		$rs=$parser->parseResultSetFromFile($fd);
		$this->closeTable($fd);
		return $rs;
	}

	// Reads a Table into a ResultSet
	// But only the column names and types + the last record
	// thats usefull for appending record
	function readTableForAppend($tableName) {
		$this->msgThrow(get_class($this),"readTableForAppend<br>",__FILE__,__LINE__);
		$parser= new ResultSetParser();
		if(!($fd=$this->openTableRead($tableName))) {
			$this->errorThrow(get_class($this),"readTableForAppend(): Cannot open Table $tableName",__FILE__,__LINE__);
			return null;
		}
		$rs=$parser->parseResultSetFromFileForAppend($fd);
		$this->closeTable($fd);
		return $rs;
	}

	// writes the table by using the FilePointer $fd 
	// $fd has to be opened an closed by the caller
	function writeTable($fd, $resultSet) {
		$this->msgThrow(get_class($this),"writeTable<br>",__FILE__,__LINE__);
		$parser= new ResultSetParser();
		return $parser->parseResultSetIntoFile($fd, $resultSet);
	}

	// appends to the table by using the FilePointer $fd 
	// $fd has to be opened an closed by the caller
	function appendToTable($fd, $resultSet,$recordCount) {
		$this->msgThrow(get_class($this),"appendToTable<br>",__FILE__,__LINE__);
		$parser= new ResultSetParser();
		while($resultSet->getRowCount()>$recordCount) {
			$resultSet->reset();
			$resultSet->next();
			$resultSet->deleteCurrentRow();
		}
		return $parser->parseResultSetIntoFileAppend($fd, $resultSet);
	}

	
	/*
	*	Query dispatcher
	*/
	// $sql_query_str is an unparsed SQL Query String
	// Return Values:
	// SELECT Queries: Returns a ResultSet Object or false
	// CREATE TABLE: Returns true or false
	// All other types: Returns the number of rows affected
	function query($sql_query_str) {
		return $this->executeQuery($sql_query_str);
	}
	function executeQuery($sql_query_str) {
		$this->msgThrow(get_class($this),"[executeQuery] Query: $sql_query_str<br>",__FILE__,__LINE__);
		
		// Parse Query
		$start = getmicrotime();
		$sqlParser=new SqlParser($sql_query_str);
	  $sqlQuery=$sqlParser->parseSqlQuery();
	  $this->msgThrow(get_class($this),"parseSqlQuery: " . (getmicrotime() - $start) . " seconds elapsed<br>",__FILE__,__LINE__);

		// free $sqlParser
		unset($sqlParser);
		$sqlParser="";

		// Test Query
		if((!$sqlQuery) || (!$sqlQuery->test())) {
			return false;
		}
		
		$start=getmicrotime();
	
		$this->msgThrow(get_class($this),"[executeQuery] Parsed Query:<br>",__FILE__,__LINE__);
		if($this->blibVoiceMessages) {
			$sqlQuery->dump();
		}


		// Dispatch
		switch($sqlQuery->type) {
			case "SELECT":
				$rc=$this->executeSelectQuery($sqlQuery);
				break;
			case "INSERT":
				$rc=$this->executeInsertQuery($sqlQuery);
				break;
			case "DELETE":
				$rc=$this->executeDeleteQuery($sqlQuery);
				break;
			case "UPDATE":
				$rc=$this->executeUpdateQuery($sqlQuery);
				break;
			case "CREATE TABLE":
				$rc=$this->executeCreateTableQuery($sqlQuery);
				break;
			case "DROP TABLE":
				$rc=$this->executeDropTableQuery($sqlQuery);
				break;
			case "CREATE DATABASE":
				$rc=$this->executeCreateDatabaseQuery($sqlQuery);
				break;
			case "DROP DATABASE":
				$rc=$this->executeDropDatabaseQuery($sqlQuery);
				break;
			case "LIST TABLES":
				$rc=$this->executeListTablesQuery($sqlQuery);
				break;
			default:
				$this->errorThrow(get_class($this),"Invalid or unsupported Query Type: " . $sqlQuery->type,__FILE__,__LINE__);
				return false;
		}
		
		if(is_false($rc)) {
			$this->errorThrow(get_class($this),"Query '" . $sql_query_str . "' failed",__FILE__,__LINE__);
		}
		
		$this->msgThrow(get_class($this),"[executeQuery] Query execution done: " . (getmicrotime() - $start) . " seconds elapsed<br>",__FILE__,__LINE__);
		return $rc;
	}	


	/*
	*	DELETE Que
	*/
	function executeDeleteQuery(&$sqlQuery) {
		// Read Table
		$rs=$this->readTable($sqlQuery->tables[0]);
		if(!$rs) {
			$this->errorThrow(get_class($this),"Reading the Table " . $sqlQuery->tables[0] . " failed",__FILE__,__LINE__);
			return false;
		}
		
		$rowsAffected=0;
		
		if(!$sqlQuery->where_expr || $sqlQuery->where_expr=="") {
			$rowsAffected=$rs->getRowCount();
			$rs->deleteAllRows();
		} else {
			// set row ids
			$rId=-1;
			$rs->reset();
			while($rs->next()) 
				$rs->setCurrentRowId(++$rId);
			$rs->reset();
			
			// calc current column count
			$colCount=count($rs->colNames);
			
			// generate additional columns from the WHERE-expression
			$rs->generateAdditionalColumnsFromWhereExpr($sqlQuery->where_expr);
		
			// execute the new single-rec functions
			$rs->executeSingleRecFuncs();
			
			// apply WHERE Expression
			$ep = new ExpressionParser();
			$et = $ep->getExpressionTree($sqlQuery->where_expr);
			$rsFiltered = $et->getFilteredResultSet($rs);
			
			if(!$rsFiltered)
				return 0;			
			
			// Delete rows..
			$rsFiltered->reset();
			while($rsFiltered->next()) {
				$rowId=$rsFiltered->getCurrentRowId();
				$rs->deleteRow($rs->searchRowById($rowId));
			}
			
			$rowsAffected=$rsFiltered->getRowCount();
			
			// Remove columns added from WHERE Expression
			while(count($rs->colNames)>$colCount) {
				$rs->removeColumn(count($rs->colNames)-1);
			}
		} 	
		
		// Open Table
		$fp=$this->openTableWrite($sqlQuery->tables[0]);
		if(!$fp) {
			$this->errorThrow(get_class($this),"Open the Table " . $sqlQuery->tables[0] . " (for WRITE) failed",__FILE__,__LINE__);
			return false;
		}
		
		// Write Table
		$this->writeTable($fp,$rs);
		$this->closeTable($fp);
		return $rowsAffected;
	}

	
	/*
	*	INSERT Que
	*/
	function executeInsertQuery(&$sqlQuery) {
		// Read Table
		$rs=$this->readTableForAppend($sqlQuery->tables[0]);
		
		if(!$rs) {
			$this->errorThrow(get_class($this),"Reading the Table " . $sqlQuery->tables[0] . " failed",__FILE__,__LINE__);
			return false;
		}
		
		// Open Table
		$fp=$this->openTableAppend($sqlQuery->tables[0]);
		if(!$fp) {
			$this->errorThrow(get_class($this),"Open the Table " . $sqlQuery->tables[0] . " (for APPEND) failed",__FILE__,__LINE__);
			return false;
		}
		
		// a INSERT INTO table () VALUES () query: just write the default values
		if(count($sqlQuery->colNames)==0 && count($sqlQuery->fieldValues)==0) {
				$rs->append();
				$this->updatesqlInsertId($rs);
				$this->appendToTable($fp,$rs,1);
				$this->closeTable($fp);
				return 1; // Error Handling ??
		}
				
		// execute functions on the values
		$colName="";
		$colTable="";
		$colFunc="";
		
		for($i=0;$i<count($sqlQuery->fieldValues);++$i) {
			split_full_colname($sqlQuery->fieldValues[$i],$colName,$colTable,$colFunc);
			if($colFunc) {
				if($colName && has_quotes($colName))  {
					remove_quotes($colName);
				}
				$sqlQuery->fieldValues[$i]=execFunc($colFunc, $colName);
			} else {
			    if(has_quotes($sqlQuery->fieldValues[$i])) {
			        remove_quotes($sqlQuery->fieldValues[$i]);
			    }
			}
		}
				
		$rc=true;
		switch(count($sqlQuery->colNames)) {
			case 0:
				$rs->appendRow($sqlQuery->fieldValues);
				$this->updatesqlInsertId($rs);
				$this->appendToTable($fp,$rs,1);
				$this->closeTable($fp);
				return $rc;
				break;
			default:
				$rs->append();
				for($i=0;$i<count($sqlQuery->colNames);++$i) {
					if(!$rs->setCurrentValueByName($sqlQuery->colNames[$i],$sqlQuery->fieldValues[$i])) {
						$rc=false;
						break;
					}
				}
				if($rc) {
					$this->updatesqlInsertId($rs);
					$this->appendToTable($fp,$rs,1);
				}
				$this->closeTable($fp);
				return $rc;
				break;
		}
	}
	
	/*
	*	UPDATE Que
	*/
	// returns the affected Row count or false
	function executeUpdateQuery(&$sqlQuery) {
		// Read Table
		$rs=$this->readTable($sqlQuery->tables[0]);
		if(!$rs) {
			$this->errorThrow(get_class($this),"Reading the Table " . $sqlQuery->tables[0] . " failed",__FILE__,__LINE__);
			return false;
		}

		// calc original column count
		$colCount=count($rs->colNames);

		$rs->generateAdditionalColumnsFromArray($sqlQuery->fieldValues);

		if(txtdbapi_error_occurred())
			return false;

		$rs->executeSingleRecFuncs();

		// check if there are wrong functions
		for($i=0;$i<count($rs->colFuncs);++$i) {
			if($rs->colFuncs[$i] && !$rs->colFuncsExecuted[$i]) {
				$this->errorThrow(get_class($this),"Function '" . $rs->colFuncs[$i]  . "' not supported in UPDATE statements",__FILE__,__LINE__);
				return false;
			}
		}

		if($this->blibVoiceMessages) {
			$this->msgThrow(get_class($this),"[executeUpdateQuery] ResultSet dump after generating columns:<br>",__FILE__,__LINE__);
			$rs->dump();
		}

		// No where_expr ? update all
		if( (!isset($sqlQuery->where_expr)) || (!$sqlQuery->where_expr) ) {
			// update 
			$rs->reset();
			while($rs->next()) {
				for($i=0;$i<count($sqlQuery->colNames);++$i) {
					$rc=$rs->setCurrentValueByName($sqlQuery->colNames[$i],
					$rs->getCurrentValueByName($sqlQuery->fieldValues[$i]));
					if(!$rc)  {
						return false;
					}
				}
			}

			// Remove columns added from WHERE Expression
			while(count($rs->colNames)>$colCount) {
				$rs->removeColumn(count($rs->colNames)-1);
			}

			// Open Table
			$fp=$this->openTableWrite($sqlQuery->tables[0]);
			if(!$fp) {
				$this->errorThrow(get_class($this),"Open the Table " . $sqlQuery->tables[0] . " (for WRITE) failed",__FILE__,__LINE__);
				return false;
			}
			// Write Table
			$this->writeTable($fp,$rs);
			$this->closeTable($fp);
			return $rs->getRowCount();

		} else {
			// set row id's
			$rs->reset();
			$rId=-1;
			while($rs->next())
				$rs->setCurrentRowId(++$rId);

			// generate additional columns from the WHERE-expression
			$rs->generateAdditionalColumnsFromWhereExpr($sqlQuery->where_expr);

			// execute the new single-rec functions
			$rs->executeSingleRecFuncs();

			// create a copy 
			$rsFiltered=$rs;

			// filter by where expression
			$ep=new ExpressionParser();
			$et=$ep->getExpressionTree($sqlQuery->where_expr);
			$rsFiltered=$et->getFilteredResultSet($rsFiltered);

			if($rsFiltered->getRowCount()<1)
				return 0;

			// update 
			$rsFiltered->reset();
			while($rsFiltered->next()) {
				for($i=0;$i<count($sqlQuery->colNames);++$i) {
					$rc=$rsFiltered->setCurrentValueByName($sqlQuery->colNames[$i],
					$rsFiltered->getCurrentValueByName($sqlQuery->fieldValues[$i]));
					if(!$rc)  {
						return false;
					}
				}
			}

			// put filtered part back in the original ResultSet
			$rowNr=0;
			$putBack=0;
			$rs->reset();
			$rsFiltered->reset();
			while($rs->next()) {
				if(($rowNr=$rsFiltered->searchRowById($rs->getCurrentRowId())) !=DBTXT_NOT_FOUND) {
					$rs->setCurrentValues($rsFiltered->getValues($rowNr));
					$putBack++;
				}
			}
			if($putBack<$rsFiltered->getRowCount()) {
				$this->errorThrow(get_class($this),"UPDATE: Could not put Back all filtered Values",__FILE__,__LINE__);
				return false;
			}

			// Remove columns added from WHERE Expression
			while(count($rs->colNames)>$colCount) {
				$rs->removeColumn(count($rs->colNames)-1);
			}

			// Open Table
			$fp=$this->openTableWrite($sqlQuery->tables[0]);
			if(!$fp) {
				$this->errorThrow(get_class($this),"Open the Table " . $sqlQuery->tables[0] . " (for WRITE) failed",__FILE__,__LINE__);
				return false;
			}
			$this->writeTable($fp,$rs);
			$this->closeTable($fp);
			return $rsFiltered->getRowCount();
		}
	}
	
	/*
	*	CREATE TABLE Que
	*/
	// executes a SQL CREATE TABLE Statement
	// param: SqlQuery Object
	// returns True or False
	function executeCreateTableQuery(&$sqlQuery) {
		clearstatcache();
		$filename=$this->dbFolder . $sqlQuery->tables[0] . DBTXT_TABLE_FILE_EXT;
		
		// checks
		if(!$sqlQuery->tables[0]) {
			$this->errorThrow(get_class($this),"Invalid Table " . $sqlQuery->tables[0],__FILE__,__LINE__);
			return false;
		}
		if(file_exists($filename)) {
			$this->errorThrow(get_class($this),"Table " . $sqlQuery->tables[0] . " allready exists",__FILE__,__LINE__);
			return false;
		}
		if(count($sqlQuery->colNames)!=count($sqlQuery->colTypes)) {
			$this->errorThrow(get_class($this),"There's not a type defined for each column",__FILE__,__LINE__);
			return false;
		}
		for($i=0;$i<count($sqlQuery->colTypes);++$i) {
			$tmp= ($sqlQuery->colTypes[$i]=strtolower($sqlQuery->colTypes[$i]));
			if( !($tmp == DBTXT_COL_TYPE_INT || $tmp == DBTXT_COL_TYPE_STRING || $tmp==DBTXT_COL_TYPE_INC)) {
				$this->errorThrow(get_class($this),"Column Type " . $tmp . " not supported",__FILE__,__LINE__);
				return false;
			}
		}
		
		// write file	
		$fp=fopen ($filename, "w".DBTXT_TABLE_FILE_OPEN_MODE);
		
		$rsParser=new ResultSetParser();
		
		fwrite($fp, $rsParser->parseLineFromRow($sqlQuery->colNames));
		fwrite($fp, "\n");
		fwrite($fp, $rsParser->parseLineFromRow($sqlQuery->colTypes));
		fwrite($fp, "\n");
		fwrite($fp, $rsParser->parseLineFromRow($sqlQuery->fieldValues));
				
		fclose($fp);
		chmod($filename,0777);
		return true;	
	}	
	
	/*
	*	DROP TABLE Que
	*/
	// executes a SQL DROP TABLE Statement 
	// param: SqlQuery Object
	// returns True or False
	function executeDropTableQuery(&$sqlQuery) {
		clearstatcache();
		if(!isset($sqlQuery->colNames[0]))
			return false;
		
		for($i=0;$i<count($sqlQuery->colNames);++$i) {
			$rc=unlink($this->dbFolder. $sqlQuery->colNames[$i]  . DBTXT_TABLE_FILE_EXT);
			if(!$rc) {
				$this->errorThrow(get_class($this),"DROP TABLE " . $sqlQuery->colNames[$i] . " failed",__FILE__,__LINE__);
				return false;
			}
		}
		return true;	
	}

	
	/*
	*	LIST TABLES Que
	*/
	// executes a LIST TABLES Statement 
	// param: SqlQuery Object
	// returns: A ResultSet Object with a single column "table"
	function executeListTablesQuery(&$sqlQuery) {
		$rs=new ResultSet();
		$rs->colNames=array("table");
		$rs->colAliases=array("");
		$rs->colTables=array("");
		$rs->colTableAliases=array("");
		$rs->colTypes=array(DBTXT_COL_TYPE_STRING);
		$rs->colDefaultValues=array("");
		$rs->colFuncs=array("");
		$rs->colFuncsExecuted=array(false);
		
		$handle=opendir ($this->dbFolder);
		
		$rs->reset();
		while ($file = readdir ($handle)) { 
			if ($file != "." && $file != ".." && is_file($this->dbFolder . $file)) { 
				$rs->appendRow(array(substr($file,0,strlen($file)-strlen(DBTXT_TABLE_FILE_EXT))));
			} 
		}
		
		// apply WHERE Statement
		if($sqlQuery->where_expr) {
			$ep=new ExpressionParser();
			$et=$ep->getExpressionTree($sqlQuery->where_expr);
			$rs=$et->getFilteredResultSet($rs);
		} 
			
		// Order ResultSet
		if(count($sqlQuery->orderColumns)>0) {
			$rs->orderRows($sqlQuery->orderColumns,$sqlQuery->orderTypes);
		}

		// Group ResultSet (process GROUP BY)
		if(count($sqlQuery->groupColumns)>0) {
			$rs = $rs->groupRows($sqlQuery->groupColumns, $sqlQuery->limit);
		}

		// Apply Limit		
		$rs->reset();
		$rs = $rs->limitResultSet($sqlQuery->limit);
		
		closedir($handle); 
		$rs->reset();
		return $rs;
	}

	
	/*
	*	CREATE DATABASE Que
	*/
	// executes a SQL CREATE DATABASE Statement 
	// param: SqlQuery Object
	// returns True or False
	function executeCreateDatabaseQuery(&$sqlQuery) {
		clearstatcache();
		if($this->dbFolder!=$this->dbDir .DBTXT_ROOT_DATABASE && $this->dbFolder!=$this->dbDir .DBTXT_ROOT_DATABASE . "/") {
			$this->errorThrow(get_class($this),"Databases can only be created with a DBTXT_ROOT_DATABASE instance!",__FILE__,__LINE__);
			return false;
		}
		if(!isset($sqlQuery->colNames[0]))
			return false;
			
		$directory=$this->dbFolder . $sqlQuery->colNames[0];
		$rc=mkdir ($directory , 0777);
		if(!$rc) {
			$this->errorThrow(get_class($this),"Cannot create Database " . $sqlQuery->colNames[0],__FILE__,__LINE__);
			return false;
		}
		return true;
	}

	
	/*
	*	DROP DATABASE Que
	*/
	// executes a SQL DROP DATABASE Statement 
	// param: SqlQuery Object
	// returns True or False
	function executeDropDatabaseQuery(&$sqlQuery) {
		clearstatcache();
		if($this->dbFolder!=$this->dbDir .DBTXT_ROOT_DATABASE && $this->dbFolder!=$this->dbDir .DBTXT_ROOT_DATABASE . "/") {
			$this->errorThrow(get_class($this),"Databases can only be deleted with a DBTXT_ROOT_DATABASE instance!",__FILE__,__LINE__);
			return false;
		}
		if(!isset($sqlQuery->colNames[0]))
			return false;
		$directory=$this->dbFolder . $sqlQuery->colNames[0];
		
		// delete all tables
		$dirHandle=opendir($directory); 
		while ($file = readdir ($dirHandle)) { 
			if ($file != "." && $file != ".." && is_file($directory . "/" . $file)) { 
				if(!($rc=unlink($directory . "/" . $file))) {
					$this->errorThrow(get_class($this),"Cannot drop Database: Deleting the table $file failed",__FILE__,__LINE__);
				}
			} 
		}
		closedir($dirHandle); 
		$rc=rmdir ($directory);
		if(!$rc) {
			$this->errorThrow(get_class($this),"Cannot drop Database " . $sqlQuery->colNames[0],__FILE__,__LINE__);
			return false;
		}
		return true;	
	}

	
	/*
	*	SELECT Que
	*/
	// executes a SQL SELECT STATEMENT and returns a ResultSet 
	// param: SqlQuery Object
	function executeSelectQuery(&$sqlQuery) {
		global $gDbTxt_sqlGroupingFuncs, $gDbTxt_sqlSingleRecFuncs;

		$resultSets=array();		

		// create a copy
		$aliases=$sqlQuery->colAliases;
		$funcs=$sqlQuery->colFuncs;


		// Read all Tables
		for($i=0;$i<count($sqlQuery->tables);++$i) {
			$this->msgThrow(get_class($this),"<br>[executeSelectQuery] Reading table " . $sqlQuery->tables[$i] ."<br>",__FILE__,__LINE__); 
			if(!($resultSets[$i]=$this->readTable($sqlQuery->tables[$i]))) {
				$this->errorThrow(get_class($this),"Reading Table " . $sqlQuery->tables[$i]. " failed",__FILE__,__LINE__);
				return false;
			}
			$resultSets[$i]->setColumnTableForAll($sqlQuery->tables[$i]);
			$resultSets[$i]->setColumnTableAliasForAll($sqlQuery->tableAliases[$i]);

			// set all functions to the ResultSet of the current table
			// if table and column name matches
			$this->msgThrow(get_class($this),"[executeSelectQuery] Setting functions for the current table:<br>",__FILE__,__LINE__);
			for($j=0;$j<count($funcs);++$j) {
				if(!$funcs[$j] || !$sqlQuery->colNames[$j])
					continue;

				if($sqlQuery->colTables[$j]==$sqlQuery->tables[$i] ||
				(strlen($sqlQuery->tableAliases[$i]) > 0 && ($sqlQuery->colTables[$j]==$sqlQuery->tableAliases[$i]))) {
					$colNr=$resultSets[$i]->findColNrByAttrs($sqlQuery->colNames[$j],$sqlQuery->colTables[$j],"");
					if($colNr==DBTXT_NOT_FOUND) {
						continue;
					}					
					// create a new column for each function
					$resultSets[$i]->addColumn($sqlQuery->colNames[$j],$sqlQuery->colAliases[$j],$sqlQuery->colTables[$j],"","str","",$funcs[$j],"",true);
					$funcs[$j]="";
				}
			}

			// set all aliases where table, column name and function matches
			$this->msgThrow(get_class($this),"[executeSelectQuery] Setting aliases for the current table:<br>",__FILE__,__LINE__);
			for($j=0;$j<count($aliases);++$j) {
				if(!$aliases[$j])
					continue;

				if($sqlQuery->colTables[$j]==$sqlQuery->tables[$i] ||
				$sqlQuery->colTables[$j]==$sqlQuery->tableAliases[$i]) {	
					if(($colNr=$resultSets[$i]->findColNrByAttrs($sqlQuery->colNames[$j],$sqlQuery->colTables[$j],$sqlQuery->colFuncs[$j])) != DBTXT_NOT_FOUND) {
						$resultSets[$i]->setColumnAlias($colNr,$aliases[$j]);
						$aliases[$j]="";				
					}
				}
			}

			if($this->blibVoiceMessages) {
				$this->msgThrow(get_class($this),"<br>[executeSelectQuery] Dump of Table $i (" . $sqlQuery->tables[$i] . "):<br>",__FILE__,__LINE__);
				$resultSets[$i]->dump();
			}
		}

		// set remaining functions to the ResultSet where column name matches
		$this->msgThrow(get_class($this),"[executeSelectQuery] Setting remaining functions where column name matches:<br>",__FILE__,__LINE__);
		for($i=0;$i<count($resultSets);++$i) {
			for($j=0;$j<count($funcs);++$j) {
				if(!$funcs[$j] || !$sqlQuery->colNames[$j])
					continue;

				$colNr=$resultSets[$i]->findColNrByAttrs($sqlQuery->colNames[$j],"","");
				if($colNr==DBTXT_NOT_FOUND) {
					// 'text' or 123 ? => add column
					if(! (is_numeric($sqlQuery->colNames[$j]) || has_quotes($sqlQuery->colNames[$j]))) {
						continue;
					}
					$this->msgThrow(get_class($this),"Adding function with quoted string or number paremeter!<br>",__FILE__,__LINE__);
				}

				// create a new column for each function
				$resultSets[$i]->addColumn($sqlQuery->colNames[$j],$sqlQuery->colAliases[$j],$sqlQuery->colTables[$j],"","str","",$funcs[$j],"",true);
				$funcs[$j]="";
			}
		}

		// set remaining aliases where column name and function matches
		$this->msgThrow(get_class($this),"[executeSelectQuery] Setting remaining aliases where column name and function matches:<br>",__FILE__,__LINE__);
		for($i=0;$i<count($resultSets);++$i) {
			for($j=0;$j<count($aliases);++$j) {
				if(!$aliases[$j])
					continue;
				if(($colNr=$resultSets[$i]->findColNrByAttrs($sqlQuery->colNames[$j],"",$sqlQuery->colFuncs[$j])) !=DBTXT_NOT_FOUND) {
					$resultSets[$i]->setColumnAlias($colNr,$aliases[$j]);
					$aliases[$j]="";
				}
			}
		}

		$this->msgThrow(get_class($this),"[executeSelectQuery] Executing single-rec functions (on the separate ResultSet's):<br>",__FILE__,__LINE__);
		// execute single-rec functions (on the separate ResultSet's)
		for($i=0;$i<count($resultSets);++$i) {
			$resultSets[$i]->executeSingleRecFuncs();
		}

		// A query without tables ? => make a dummy ResultSet
		$dummyResultSet=false;
		if(count($sqlQuery->tables)==0) {
			$dummyResultSet=true;
			$rsMaster=new ResultSet();	
			$rsMaster->addColumn("(dummy)", "(dummy)", "(dummy)", "(dummy)", "str", "(dummy)", "", "", true);
			$rsMaster->append();

			// else: real ResultSet
		} else {
			$dummyResultSet=false;

			// Perform JOIN's
			foreach($sqlQuery->joins as $join) {
				if(!isset($rsMaster)) {
					$rsMaster=$resultSets[$join->leftTableIndex];
					$resultSets[$join->leftTableIndex]=0;
				}
				
				if($join->type == DBTXT_JOIN_INNER) { // INNER => Nothing special
					$rsMaster=$rsMaster->joinWithResultSet($resultSets[$join->rightTableIndex]);
					$ep=new ExpressionParser();
					$et=$ep->getExpressionTree($join->expr);
					$rsMaster=$et->getFilteredResultSet($rsMaster);
					$resultSets[$join->rightTableIndex]=0;
				} else if($join->type == DBTXT_JOIN_LEFT) { // LEFT OUTER JOIN => keep all of the left
					// generate new row id's for the left
					$rsMaster->generateRowIds();
					// copy the left
					$copy=$rsMaster->copy();
					$rsMaster=$rsMaster->joinWithResultSet($resultSets[$join->rightTableIndex],0);
					$ep=new ExpressionParser();
					$et=$ep->getExpressionTree($join->expr);
					$rsMaster=$et->getFilteredResultSet($rsMaster);
					$resultSets[$join->rightTableIndex]=0;
					// add back missing
					$rsMaster->addMissingRows($copy);
				} else if($join->type == DBTXT_JOIN_RIGHT) { // RIGHT OUTER JOIN => keep all of the right
					// generate new row id's for the right
					$resultSets[$join->rightTableIndex]->generateRowIds();
					// copy the right
					$copy=$resultSets[$join->rightTableIndex]->copy();
					$rsMaster=$rsMaster->joinWithResultSet($resultSets[$join->rightTableIndex],1);
					$ep=new ExpressionParser();
					$et=$ep->getExpressionTree($join->expr);
					$rsMaster=$et->getFilteredResultSet($rsMaster);
					$resultSets[$join->rightTableIndex]=0;				
					// add back missing
					$rsMaster->addMissingRows($copy);
				}
			}

			// join the remaining ResultSet's
			if(!isset($rsMaster)) {
				$rsMaster=$resultSets[0];
				$i=1;
			} else {
				$i=0;
			}
			for(;$i<count($resultSets);++$i) {
				if($resultSets[$i] != 0) {
					$rsMaster=$rsMaster->joinWithResultSet($resultSets[$i]);
				}
			}
		}

		// from here we only work with $rsMaster and can free the other ResultSet's
		unset($resultSets);
		$resultSets="";

		// generate additional columns for COUNT(*) functions
		$this->msgThrow(get_class($this),"[executeSelectQuery] Adding COUNT(*) functions<br>",__FILE__,__LINE__);
		for($i=0;$i<count($funcs);++$i) {
			if($funcs[$i] && $sqlQuery->colNames[$i]=="*") {
				$rsMaster->addColumn($sqlQuery->colNames[$i],$sqlQuery->colAliases[$i],$sqlQuery->colTables[$i],"","int","",$funcs[$i],"","");
				$funcs[$i]="";
			}
		}

		// generate additional columns for the remaining functions (functions without params)
		for($i=0;$i<count($funcs);++$i) {
			if($funcs[$i]) {
				$rsMaster->addColumn($sqlQuery->colNames[$i],$sqlQuery->colAliases[$i],"","","str","",$funcs[$i],execFunc($funcs[$i],""));
			}
		}

		// generate additional columns from the WHERE-expression
		$rsMaster->generateAdditionalColumnsFromWhereExpr($sqlQuery->where_expr);

		// generate additional columns from ORDER BY
		$rsMaster->generateAdditionalColumnsFromArray($sqlQuery->orderColumns);

		// generate additional columns from GROUP BY
		$rsMaster->generateAdditionalColumnsFromArray($sqlQuery->groupColumns);

		// execute the new single-rec functions (on the Master ResultSet)
		$rsMaster->executeSingleRecFuncs();

		// generate new row id's 
		$rsMaster->generateRowIds();

		$this->msgThrow(get_class($this),"<br>[executeSelectQuery] Master ResultSet:</b><br>",__FILE__,__LINE__);
		if($this->blibVoiceMessages) $rsMaster->dump();


		// apply WHERE expression
		if($sqlQuery->where_expr) {
			$ep=new ExpressionParser();
			$et=$ep->getExpressionTree($sqlQuery->where_expr);
			$rsMaster=$et->getFilteredResultSet($rsMaster);
		} 
		// free $ep
		unset($ep);
		$ep="";
		
		/*
		// stop if the WHERE expression failed
		if(txtdbapi_error_occurred()) {
			return false;
		}
		*/


		// check if we can use some optimization 
		// (use the limit in group by, but only if there are no grouping function
		// in the groupRows. To be able to do this we must order before grouping)
		$optimizedPath=true;
		if(!$sqlQuery->limit || !$sqlQuery->orderColumns) {
			$optimizedPath=false;
		} else {
			for($i=0;$i<count($sqlQuery->colFuncs);++$i) {
				if(in_array($sqlQuery->colFuncs[$i],$gDbTxt_sqlGroupingFuncs)) {
					$optimizedPath=false;
					break;
				}
			}				
		}
		if($optimizedPath) {
			$this->msgThrow(get_class($this),"[executeSelectQuery] Using optimized path!<br>",__FILE__,__LINE__);
		} else {
			$this->msgThrow(get_class($this),"[executeSelectQuery] Using normal path!<br>",__FILE__,__LINE__);
		}

		// Order ResultSet (if optimizedPath)
		if($optimizedPath) {	
			$this->msgThrow(get_class($this),"[executeSelectQuery] Calling orderRows() (optimized path)..<br>",__FILE__,__LINE__);
			if(count($sqlQuery->orderColumns)>0) {
				$rsMaster->orderRows($sqlQuery->orderColumns,$sqlQuery->orderTypes);
			}
		}

		// Group ResultSet (process GROUP BY)
		$numGroupingFuncs=0;
		for($i=0;$i<count($sqlQuery->colFuncs);++$i) {
			if($sqlQuery->colFuncs[$i] && in_array($sqlQuery->colFuncs[$i],$gDbTxt_sqlGroupingFuncs)) {
				++$numGroupingFuncs;
				break;
			}
		}
		if($numGroupingFuncs>0 || count($sqlQuery->groupColumns)>0) {
			$this->msgThrow(get_class($this),"[executeSelectQuery] Calling groupRows()..<br>",__FILE__,__LINE__);
			$rsMaster = $rsMaster->groupRows($sqlQuery,$optimizedPath);
		}

		// Order ResultSet (if NOT optimizedPath)
		if(!$optimizedPath) {	
			$this->msgThrow(get_class($this),"[executeSelectQuery] Calling orderRows() (normal path)..<br>",__FILE__,__LINE__);
			if(count($sqlQuery->orderColumns)>0) {
				$rsMaster->orderRows($sqlQuery->orderColumns,$sqlQuery->orderTypes);
			}
		}

		// add direct value columns
		$this->msgThrow(get_class($this),"[executeSelectQuery] Adding direct value columns..<br>",__FILE__,__LINE__);
		for($i=0;$i<count($sqlQuery->colNames);++$i) {
			if($sqlQuery->colNames[$i] && (is_numeric($sqlQuery->colNames[$i]) || has_quotes($sqlQuery->colNames[$i])) &&
			!$sqlQuery->colTables[$i] && !$sqlQuery->colFuncs[$i] &&
			$rsMaster->findColNrByAttrs($sqlQuery->colNames[$i],"","")==DBTXT_NOT_FOUND) {
				$value=$sqlQuery->colNames[$i];
				if(has_quotes($value)) {
					remove_quotes($value);
				}
				$rsMaster->addColumn($sqlQuery->colNames[$i],$sqlQuery->colAliases[$i],"","","str","","",$value,true);
			}
		}

		// return only the requested columns
		$this->msgThrow(get_class($this),"[executeSelectQuery] Removing unwanted columns...<br>",__FILE__,__LINE__);
		$rsMaster->filterByColumnNamesInSqlQuery($sqlQuery);


		// order columns (not their data)
		$this->msgThrow(get_class($this),"[executeSelectQuery] Ordering columns (amog themself)...<br>",__FILE__,__LINE__);
		if(!$rsMaster->orderColumnsBySqlQuery($sqlQuery)) {
			$this->errorThrow(get_class($this),"Ordering the Columns (themself) failed",__FILE__,__LINE__);
			return false;
		}	

		// process DISTINCT
		if($sqlQuery->distinct == 1) {
			$rsMaster = $rsMaster->makeDistinct($sqlQuery->limit);
		}

		// Apply Limit		
		$rsMaster->reset();
		$rsMaster = $rsMaster->limitResultSet($sqlQuery->limit);

		$rsMaster->reset();
		return $rsMaster;
	}

	
  /**
  * Auxillary Funcs
  */
  function strEscape($inStr) {
    return mysql_escape_string($inStr);
  }
	function esc($inStr) {
		return $this->strEscape($inStr);
	}
	function escape() {
		return $this->strEscape($inStr);
	}

	function getVar($inQue) {
		$rs = $this->query($inQue);
		if($rs->getRowCount()&&$rs->next()) {
			return $rs->getCurrentValueByNr(0);
		}
		return '';
	}

	function getRows($inQue) {
		$rs = $this->query($inQue);
		$out = array();
		while($rs->next()) {
			$out[] = $rs->getCurrentValuesAsHash();
		}
		return $out;
	}

	function getRow($inQue) {
		$rs = $this->query($inQue);
		if($rs->next()) {
			return $rs->getCurrentValuesAsHash();
		}
		return array();
	}
}

?>